2021-11-29 1.6.1 released

2021-11-29 zzz
 * Tunnels: Fix NPE in BuildHandler

2021-11-29 1.6.0 (not released)

2021-11-23 zzz
 * Tunnels:
   - Drop request if hop throttle exceeded by 50%
   - Revert banning peer in throttles

2021-11-21 zzz
 * Console: Drop peer when manually banned
 * Tunnels:
   - Ban peer on excessive build requests
   - Drop requests if previous or next peer is banned
 * Update: Drop peer when banlisted

2021-11-12 zzz
 * Tunnels: Improve build success when at conn limits

2021-11-09 zzz
 * GeoIP 2021-11-01

2021-11-09 zzz
 * Util: Update DoH server list

2021-10-23 zzz
 * Debian: Update JRE dependencies

2021-10-21 idk
 * Improve consistency between light and dark theme on Bandwidth Config Wizard

2021-10-20 zzz
 * SSU: Send Peer Test from Bob to Alice in-session

2021-10-13 zzz
 * Util: Recognize newer Intel processors

2021-10-11 zzz
 * Tomcat 9.0.54

2021-10-10 zzz
 * Jetty 9.3.30.v20211001

2021-10-05 zzz
 * NetDB: Reduce ban time for routers without netId

2021-10-03 zzz
 * Console: Add theme selection to wizard

2021-10-01 zzz
 * i2ptunnel: Fix enc type configuration logic

2021-09-30 zzz
 * Console: Add js to /configui to preview themes

2021-09-27 zzz
 * Router: Rekey all Android/ARM routers

2021-09-25 zzz
 * Tunnels:
   - Implement Bloom filter for short TBM
   - Reduce TBM Bloom filter size and interval for EC routers

2021-09-22 zzz
 * UDP: Replace ACKSender thread with per-PeerState ack timers

2021-09-10 zzz
 * I2CP: Don't call listener.readError() after external client disconnect

2021-09-05 zzz
 * Update: Get backup URLs from news feed

2021-08-28 zzz
 * Console: Catch error checking systray availability (gitlab issue #331)

2021-08-26 zzz
 * Debian: Fix dh_installdocs build error
 * Router: Increase rekey probability
 * Tunnels: Enable sending short build messages

2021-08-23 1.5.0 released

2021-08-20 zzz
 * Update GeoIP and translations

2021-08-13 zzz
 * Crypto: Fix corruption of EC and DSA private keys on Java 17

2021-08-07 zzz
 * UPnP: Fix URL handling

2021-08-02 zzz
 * Console: Show restart button if there's an update
   to be handled by a post-processor

2021-07-30 zzz
 * Util: Update DoH server list

2021-07-28 zzz
 * Tunnels: Fixes for proposal 157

2021-07-23 zzz
 * Transport: Fix UPnP IPv6 NPE

2021-07-22 zzz
 * Tunnels: Fixes for proposal 157

2021-07-20 zzz
 * NetDB: Increase min ff version to 0.9.38

2021-07-18 zzz
 * Tunnels: Updates for proposal 157

2021-07-07 zzz
 * Streaming: Reduce immediate ack delay

2021-07-02 zzz
 * UPnP: IPv6 address validation fix

2021-06-22 zzz
 * Tests: Fix duplicate classes in i2ptest.jar
 * Tunnels: Changes for new build messages (Prop. 157)

2021-06-20 zzz
 * Jetty: Case-insensitive sort on directory listing, put directories first

2021-06-18 zzz
 * Console: Add Permissions-Policy header
 * SSU: Fix handling of bad peer test responses
 * Transport: Remove 4/6 caps config

2021-06-16 zzz
 * Router: Increase key pool sizes for slow machines

2021-06-13 zzz
 * Tests: Fix and expand BuildMessageTestStandalone
 * Tunnels: Continue work on new build messages (proposal 157)

2021-06-11 zzz
 * UPnP: Bind to IPv6 addresses for search responses

2021-06-10 zzz
 * Updates:
   - Add preliminary support for dmg/exe updates
   - Make backup news URL configurable (see gitlab MR !33)

2021-06-08 zzz
 * NetDB: Prevent rare deadlock in rebuildRouterInfo()
 * Tunnels:
   - More work on short tunnel build messages (proposal 157)
   - Fix compare logic in ITBM parser (ticket #2814)
   - Extend use of high cap peers in expl. tunnels at startup, after extended downtime
   - Switch from SHA256 to SipHash for peer ordering

2021-06-01 zzz
 * i2psnark: Fix autostart for magnets
 * Router: Fix JobQueue getLastJobBegin() and getLastJobEnd() (ticket #2809)

2021-05-23 zzz
 * UPnP: Fix IPv6 address check (ticket #2811)

2021-05-21 zzz
 * Router: Increase rekey probability
 * RRD4J 3.8

* 2021-05-18 0.9.50 released

2021-05-14 zzz
 * SAM: Remove ancient client demo code
 * Update Translations

2021-05-10 zzz
 * Sybil: Fix retention of analysis files when configured
   to never delete

2021-05-07 zzz
 * Console: /configpeer improvements

2021-05-04 zzz
 * GeoIP 2021-05

2021-05-02 zzz
 * Console: Update bug report URLs

2021-04-25 zzz
 * Console: Add author for initial news

2021-04-24 zzz
 * Jetty: Patch for CVE-2021-28165 Jetty #6072 -
   Jetty server high CPU when client send data length > 17408
 * SusiMail: Fix infinite loop in decoder on malformed input

2021-04-24 zlatinb
 * SusiMail:
   - Fix stream closed exception reading new mail
     (trac ticket #2202, gitlab ticket #17)
   - Fix corruption of large messages (ticket #2765)

2021-04-23 idk
 * Router: Fix update on Windows from very old versions (gitlab ticket #16)

2021-04-20 zzz
 * NTCP:
   - Set outbound addresses at startup when force-firewalled
   - More NTCP1 removal cleanup
 * SSU:
   - Fix setting addresses from interfaces at startup
   - Don't start peer test when shutting down

2021-04-18 zzz
 * Proxy: Decode IDN hostnames in error pages

2021-04-17 zzz
 * Transport: IPv6 state transition fixes

2021-04-12 zzz
 * SSU: Fix peer test getting stuck

2021-04-11 zzz
 * Proxy: Precompress error page CSS
 * SSU: IPv6-only fixes

2021-04-09 zzz
 * Router: Fixes for setting up config dir in embedded applications

2021-04-08 zzz
 * Debian: Fix link to compiler jar (Debian ticket #986474)
 * SSU: IPv6 introducer fixes

2021-04-05 zzz
 * Build: Remove launcher code
 * Console: Convert update versions to times for debug page
 * Sybil: Register blocklist version with update manager

2021-04-04 zzz
 * Tunnels: Fix timestamp checking for ECIES records

2021-04-03 zzz
 * SAM: Remove subsessions when primary session closes
 * SSU: Remove restrictions on IPv6 introducers (prop. 158)

2021-04-02 zzz
 * SSU: Fix dup IPv6 introducers

2021-04-01 zzz
 * NetDB: Negative cache LS received with zero leases

2021-03-31 zzz
 * SSU: Update address when IPv6 introducers change (prop. 158)

2021-03-30 zzz
 * Transport: Fix NTCP removing IPv4 address when SSU removes IPv6 address

2021-03-29 zzz
 * SSU: Don't request introducers when hidden
 * Transport: Don't open UPnP ports when hidden or force-firewalled

2021-03-27 zzz
 * Router: Fix decryption of blinded leasesets

2021-03-25 zzz
 * i2ptunnel: Force non-SSL socket to local target for SSL ports
 * SSU: Implement IPv6 introductions (proposal 158)
 * Transports: Don't open UPnP ports for disabled IPv4/v6

2021-03-23 zzz
 * NetDB: Sort published addresses for consistency
 * SSU: Fix IPv6 transition from firewalled to non-firewalled

2021-03-22 zzz
 * Sybil: Persist blocklist
 * Tunnels: Don't count established routers as new in OBEP throttle (ticket #2245)

2021-03-20 zzz
 * Tunnels: Fix RED dropping for part. tunnels (Gitlab MR #24)

2021-03-18 zzz
 * Util:
   - DoH: Update server list
   - EepGet timeout fixes
   - EepHead: Fix failure if headers specify chunked
   - SSLEepGet: Specify hostname for SSL socket when using DoH
   - SSLEepGet: Use DoH by default (reseeding) (ticket #2201)

2021-03-16 zzz
 * Console: Fix netdb SSU caps search
 * Transports: Enable 4/6 caps

2021-03-15 zzz
 * SSU: Fix IPv6 addresses not being removed on some state transitions
 * Util: Don't call out to InetAddress for IP parsing

2021-03-13 zzz
 * Console: Limit share to 90% max

2021-03-11 zzz
 * NetDB: Queue RI file deletion and delete in a single thread
 * SSU: Limit port changes

2021-03-09 zzz
 * Throttle: Don't do exponential calculation unless necessary
 * Util: Consolidate dup BandwidthEstimator interfaces

2021-03-08 zzz
 * NTCP: Remove NTCP 1 suppport
 * SSU: Increase CoDel drop threshold at UDPSender queue

2021-03-06 zzz
 * SSU: Require confirmation for IPv6 firewalled state transitions

2021-03-04 zzz
 * I2CP: More prep for different release and API versions
 * i2ptunnel: Add missing button icons for proxy forms
 * Router: Increase rekey probability
 * Transports: Prefer IPv6 temporary addresses if the kernel does

2021-03-03 zzz
 * NTCP: Fix reachability status when force-firewalled
 * SSU:
   - Only advertise 'C' cap if we can really introduce
   - Only ask for relay tag if we don't have enough
   - Fix transition out of IPv4 firewalled after UPnP success
   - Fix validation of current introducers
   - Don't publish IPv4 address at startup when force-firewalled
   - Publish empty '4' address if firewalled and no introducers
   - Publish empty '6' address if firewalled
   - 4/6 caps fixes
   - Increase hole punch rate limit
 * UPnP: Fix retention of deprecated addresses

2021-03-02 zzz
 * UPnP:
   - Limit event subscription time
   - Subscribe to IPv6 service also

2021-03-01 zzz
 * UPnP:
   - Fix mappings not being renewed before expiration
   - IPv6 port forwarding fixes
   - Continue to forward deprecated addresses for a while

2021-02-28 zzz
 * SSU: Fix set of states requiring address confirmation
 * UPnP:
   - Add support for IPv6 firewall addresses
   - Add support for forwarding IPv6 addresses

2021-02-27 zzz
 * UPnP: Move IPv6 checks from Parser to ControlPoint

2021-02-25 zzz
 * NetDB: Fix NPE validating expired blinded LS2
 * NTCP: Don't publish IP at startup when configured as firewalled
 * SSU: Enable RelayRequest over IPv6
 * Transports: Adjust conn limits for some platforms

2021-02-24 zzz
 * Jetty: Fix detection of SSL connector
 * SSU: Avoid outbound connections to buggy routers

2021-02-23 zzz
 * Build: Prep for different release and API versions
 * Transports: Add 4/6 transport caps

2021-02-21 zzz
 * Console: List all Jetty servers in sidebar
 * Profiles: Disable peer test (ticket #2456) and tunnel test response time stat

2021-02-20 zzz
 * Router: Don't rekey previous ECIES every restart on ARM

2021-02-19 zzz
 * i2psnark: Fix theme selection

2021-02-18 zzz
 * Build: Remove empty jars and wars from installers
 * NTP: Year 2036 fixes (gitlab ticket #12)

* 2021-02-17 0.9.49 released

2021-02-15 zzz
 * Build: Test script fixes
 * Pull translations from Transifex

2021-02-13 zzz
 * Util: Update router su3 keys

2021-02-10 zzz
 * Util: Fix up KeyStoreUtil CLI

2021-02-06 zzz
 * Proxy: Update default jump servers
 * NetDB:
   - Ensure RI is published after netdb is initialized
   - Only rewrite blind cache at shutdown if changed
 * NTCP: Don't publish saved local address when hidden

2021-02-05 zzz
 * GeoIP update

2021-02-03 zzz
 * Tunnels: Peer selection changes

2021-01-31 zzz
 * Router:
   - Update list of hidden mode countries
   - Force hidden mode routers to LU
   - Don't publish stats in first hour of uptime
   - Add H.323 to invalid ports list
   - Improve crashed message in event log
 * Util: Improved classification of public/local IPv6 addresses

2021-01-30 zzz
 * UPnP: Fix NPE (android gitlab ticket #1)

2021-01-29 zzz
 * Tests: Addresses tests
 * Util: Don't allow empty string as valid IP

2021-01-24 zzz
 * Tunnels: Update profiles for tunnel peers on corrupt message at endpoint

2021-01-23 zzz
 * Console: New readme translations
 * Eepsite: New help translations

2021-01-22 zzz
 * Build: Drop old Makefile.gcj
 * Console: Drop old proof page

2021-01-20 zzz
 * Console: Fix link to UPnP status
 * SSU: Fix deadlock with router restart
 * Tests: ConvertToHash tests

2021-01-14 zzz
 * Router:
   - Change default encryption type to ECIES-X25519 (proposal 156)
   - Move Sybil subsystem from console to router
   - Limit max addresses in RI

2021-01-13 zzz
 * Jetty: Fix URI in request logs

2021-01-12 zzz
 * i2psnark: Don't decrement downloaded counter after receiving bad piece

2021-01-11 zzz
 * Console: Delete rrd files for no-longer-configured stats at startup

2021-01-08 zzz
 * i2ptunnel: Disable shared clients (DSA) (part 2)
 * SSU: Fix bandwidth estimator deadlock (ticket #2798)

2021-01-07 zzz
 * Router: Disable reseeding and NTP in vmCommSystem
 * SSU: Implement fast retransmit (tickets #2427, #2668)

2021-01-05 zzz
 * Console: Reduce limit of concurrent graph generation on slow devices
 * i2psnark: Add ability to remove I2CP options
 * SusiDNS: Hide last-modified on details page if empty

2021-01-04 zzz
 * Build:
   - Gradle build fixes
   - Update external javadoc links

2021-01-02 zzz
 * Sybil: Reduce default threshold
 * Tunnels: Improve error handling at OBEP

2020-12-31 zzz
 * Console: Use local time on graphs by default
 * NetDB:
   - Drop lookups with replies going to us
   - Extend lookup expire time

2020-12-30 zzz
 * Ratchet: Fix N pattern for ECIES build replies

2020-12-29 zzz
 * Crypto: Cache AES Ciphers
 * i2ptunnel: Disable shared clients (DSA)
 * NetDB: Verify RI stores for a while after starting
 * Ratchet: mixHash() not required after message for N pattern

2020-12-28 zzz
 * Debian: Add Java 15/16 to control

2020-12-27 zzz
 * SSU: Fix restoration of window after failed message

2020-12-26 zzz
 * Console:
   - Move flag overrides to war
   - Move initial news to jar
 * Router: Move some geoip files to jars

2020-12-24 zzz
 * I2CP: Fix requesting leasesets for subsessions (ticket #2458)

2020-12-23 zzz
 * Crypto: Increase ratchet tag window
 * I2CP: Fix encrypted leaseset for ECIES and offline keys
 * i2ptunnel: Fix writing config file twice on save

2020-12-22 zzz
 * Console:
   - Add netdb search by enc. type
   - Move readme files to war

2020-12-21 zzz
 * SSU: Fix partial acks not being sent

2020-12-20 zzz
 * Console: Fix theme selection
 * Proxy: Move error page resources to jar
 * SSU: Westwood+ congestion control (ticket #2427)

2020-12-18 zzz
 * Crypto: Fix use after free (ticket #2797)

2020-12-17 zzz
 * SSU: Send subset of fragments (ticket #2427)

2020-12-16 zzz
 * NetDB: Fix rare floodfill monitor NPE
 * SSU: Fix occasional high CPU usage

2020-12-11 zzz
 * Router (proposal 156):
   - Change router ECIES SKM to use N pattern
   - Allow encrypted messages to ECIES routers
   - Allow ECIES routers to become floodfill
   - Add XDH factory to VM comm system for tests

2020-12-06 zzz
 * Console, webapps: Move web resources to wars
 * i2psnark:
   - Add support for web seeds (ticket #2780)
   - Preserve file attribute strings in metainfo
 * Streaming: Add Retry-After header to throttle response
 * Util: Change DoH to RFC 8484 protocol (ticket #2201)

* 2020-12-01 0.9.48 released

2020-11-26 zzz
 * NTCP: Enable nodelay by default
 * SSU: Don't wakeup OMF after ack if no more messages are pending

2020-11-24 zzz
 * Build: Fix targets for git
 * NTCP: Add nodelay option for testing

2020-11-23 zzz
 * Console: Serve default favicon.ico
 * i2pcontrol: Basic HTML fixes and HTTP headers for static pages

2020-11-22 zzz
 * NetDB: Increase min FF version for LS lookups

2020-11-21 zzz
 * i2psnark: Remove old default opentrackers
 * Proxy:
   - Remove old default jump servers
   - Fix CSP for conflict error page

2020-11-20 zzz
 * NetDB: Increase exploration rate when hidden
 * Tomcat 9.0.40

2020-11-19 zzz
 * Build: Reproducible build fix (ticket #2279)
 * Crypto: Adjust Java key cache sizes
 * Debian: Update apparmor profile for usrmerge

2020-11-17 zzz
 * Jetty:
   - Update to 9.3.29.v20201019
   - Patch to fix console not starting on Java 11.0.9.1
 * NetDB: Disable sending encrypted messages to ECIES routers
 * Wrapper: Add missing binaries for armv7 and aarch64
   to installer (ticket #2308)

2020-11-16 zzz
 * GeoIP 2020-11-01
 * I2NP: Don't extend DataStructureImpl, to save space
 * Imagegen: Update zxing to 3.4.1
 * Wrapper: Update to 3.5.44

2020-11-11 zzz
 * Data: Store timestamps as longs, not Dates, to save space
 * I2CP: Don't have I2CP Messages extend DataStructureImpl, to save space

2020-11-10 zzz
 * Data: SDS no longer extends DataStructureImpl to save space
 * i2psnark: Larger read buffer for large files
 * Ratchet: Destroy HandshakeState after fatal NS/NSR errors

2020-11-07 zzz
 * Tunnels: Simplify TunnelId and HopConfig to save space

2020-11-05 zzz
 * NetDB: Ensure RI republish time is less than validation time

2020-11-04 zzz
 * Util: ELiminate unneeded data copying in ByteArrayOutputStream

2020-11-03 zzz
 * i2ptunnel: Add checks for offline expiration of alternate destination

2020-11-02 zzz
 * I2CP: Remove tunnels immediately on client disconnect
 * i2psnark: Limit max size of embedded video
 * i2ptunnel: Restart tunnel if offline-signed private key file updated

2020-10-30 zzz
 * i2psnark: MetaInfo support for url-list (prep for BEP 19)
 * Util: Fix NPE in EepGet CLI callback via PartialEepGet

2020-10-29 zzz
 * Crypto: Precalculate Noise initial hashes
 * i2psnark: Store BEP 47 padding file info
 * Tunnels: Improved logging and handling of offline signature expiration

2020-10-28 zzz
 * Tunnels: Fix tunnel tests for ECIES routers

2020-10-27 zzz
 * Util:
   - DNSOverHTTPS improvements
   - Fix SSLEepGet handling of previous SSL state

2020-10-26 zzz
 * Util: Fix EepGet allowCaching parameter

2020-10-25 zzz
 * Router: Quick checks of eph. key MSB before Noise DH
 * Tunnels: Additional checks on ECIES BRR to catch old/buggy routers

2020-10-23 zzz
 * i2ptunnel: Remove mtn tunnel (new installs only)
 * Tunnels:
   - Move AES reply keys from HopConfig to TunnelCreatorConfig
   - Add missing expiration field to ECIES BRR

2020-10-21 zzz
 * NetDB:
   - ECIES router support for encrypted lookups and stores (proposal #156)
   - Reseed after a long downtime
 * SSU:
   - Increase socket buffer size (ticket #2781)
   - Redesign of the congestion control (tickets #2412, #2649, #2654, #2713)

2020-10-17 zzz
 * i2psnark: Remove references to "maggot" links
 * SSU: Fix calculation of nextSendDelay (ticket #2714)

2020-10-15 zzz
 * Crypto: libjbigi for aarch64 (ticket #1840)
 * i2psnark: Hide BEP 48 padding directory from UI
 * Router:
   - More efficient initialization of Noise state
   - Destroy ratchet HandshakeState after NS failure
   - Add support for ratchet zero key (proposals #144, #156)
 * Util: Singleton OrderedProperties comparator

2020-10-12 zzz
 * DTG: Enable by default for Linux KDE and LXDE;
   Hide option on /configservice if not supported
 * New translations for Kurdish, Turkmen, Argentinian Spanish
 * NTCP:
   - Fix sending termination on idle timeout (ticket #2777)
   - Catch possible race IAE in Reader

2020-10-11 zzz
 * Installer: Disable pack200 (ticket #2778)

2020-10-10 zzz
 * i2psnark: Cache length of metainfo
 * Transport: Improved IPv6 address validation

2020-10-09 zzz
 *  NetDB:
    - Don't use DSA-SHA1 routers for lookups, stores, or tunnel peers
    - Don't use non-ElGamal routers for lookups or stores
    - Prevent DSA-SHA1 routers from auto-floodfill

2020-10-07 zzz
 * Build:
   - Set javac release property (ticket #2775)
   - Ant version 1.9.8 or higher now required
   - Drop support for Xenial package build
   - Fix up BOB build configuration
   - Fix i2psnark standalone build
 * i2ptunnel: Filter server response headers even if not compressing

2020-10-03 zzz
 * Router: Support building tunnels through ECIES routers (proposal 152)

2020-09-28 zzz
 * Router: Don't unregister a message without a selector (ticket #2771)

2020-09-27 zzz
 * Streaming: Fix tag option handling

2020-09-26 zzz
 * JBigI: GMP 6.2.0 for linux 64 bit Zen and Zen2 (ticket #1869)

2020-09-22 zzz
 * i2ptunnel: Change enctype default to both for:
   HTTP, IRC, and Streamr servers
   IRC, SOCKS IRC, and Streamr clients
 * Susimail, SAM: More defensive ByteBuffer casting (ticket #2775)

2020-09-18 zzz
 * Build: More git support for release and Debian targets

2020-09-16 zzz
 * i2psnark: Defensive checks for v2 format files and magnet links
 * Router: Block same-country when in hidden mode (ticket #2759)

2020-09-11 zzz
 * Blocklist: Refactoring, Move HTML status generation to console
 * Console: Fix /configclients help message for split client config files
 * Crypto: Cache HMAC256 instances
 * GeoIP: Add methods to get all IPs for a country (ticket #2759)
 * Router: Use MuxedSKM for ECIES routers (proposal 156 WIP)

2020-09-08 zzz
 * Blocklist: Track versions of each file
 * NTCP: Call afterSend() for multiple messages in NTCP2 (ticket #2769)

2020-09-04 zzz
 * Console: Support remote lookup of full router hash from search form
 * Tunnels: Don't try to decrypt build record if router is ECIES (proposal 152 WIP)

2020-09-02 zzz
 * Installer: New Ed25519 destinations for postman's servers
 * Router:
   - Prep for router encryption types (Proposal 156 WIP)
   - Randomize SSU intro key
   - Reduce next key threshold for ratchet
   - Change ratchet SparseArray from int to char to reduce space
 * Util: Fix decompression of compressed zero bytes (ticket #2770)

2020-08-29 zzz
 * i2ptunnel: Prevent creating bad alt destination when
   tunnel is running

* 2020-08-24 0.9.47 released

2020-08-14 zzz
 * Profiles: Create profiles in the nonblocking path

2020-08-10 idk
 * Replace all icons with icons from a single consistent source/style, icons
   used from FontAwesome suggested by design team and selected and edited by
   Sadie.

2020-08-01 zzz
 * Debian: Support libjson-simple-java 3 for bullseye
 * I2NP: Locking for message ID
 * NetDB: Track client that requested LS
 * OCMOSJ: Don't send to a RAP LS
 * Router: Logging fix for client start failures
 * Util:
   - More efficient use of random data
   - Add KeyStore and SHA256 to CLI

2020-07-28 zzz
 * Data: Don't check LS1 revocation signature

2020-07-22 zzz
 * i2ptunnel:
   - Change default encType to both for new tunnels, http client,
     shared clients, and all tunnels for new installs (ticket #2751)
   - Change IRC tunnel sigType to EdDSA for new installs (ticket #2749)
   - Change CONNECT tunnel default sigType to EdDSA (ticket #2749)

2020-07-19 zzz
 * i2psnark: Increase max pipeline, negotiate actual value (ticket #2280)

2020-07-11 zzz
 * NTCP: Atomics for NTCP final state (ticket #2701)
 * OCMOSJ: Don't lookup an expiring LS2 if unpublished

2020-07-07 zzz
 * i2psnark: Change ETA default sort order (ticket #2733)
 * Reseed: Enforce minimum version in generated bundle

2020-07-02 zzz
 * i2ptunnel: Fix missing throttling section for non-HTTP servers (ticket #2758)

2020-06-28 zzz
 * NetDB: Check signature in verify

2020-06-23 idk
 * Update the images on the bandwidth wizard, based on undraw
   assets, used under licenses/LICENSE-Undraw.txt. Design and assets
   were developed by @sadie.

2020-06-22 zzz
 * Sybil: Enable analysis and blocking by default

2020-06-12 zzz
 * I2CP: Meta LS2 error code handling

2020-06-10 zzz
 * Util: Support hostname lookups in LookupDest CLI

2020-06-07 zzz
 * i2ptunnel: Fix missing tunnel quantity section for servers (ticket #2747)
 * Jetty: Update servlet-api

2020-06-06 zzz
 * Data: Fix creation of Encrypted LS2 (ticket #2746)
 * I2CP: Fix issues with persisted leaseset private keys
 * I2CP, i2ptunnel: Check for expired offline signature client-side

2020-06-03 zzz
 * i2psnark: Enable dual-keys
 * Router: Implement ratchet-layer acks (proposal 144)

2020-06-01 zzz
 * Profiles: Make more calls nonblocking
 * Transports: Make unreachable maps concurrent

2020-05-31 zzz
 * Tomcat 9.0.35 (Servlet 4.0)
 * Util: Update json-simple lib to 2.3.0

2020-05-30 zzz
 * Streaming: Increase MTU for ratchet (proposal 155)
 * Util: Fix DoH handling of Cloudflare responses

2020-05-28 zzz
 * Console: RRD4J 3.6 (ticket #2716)

2020-05-27 zzz
 * Installer:
   - Require Java 8 (ticket #2511)
   - Sign the dlls (ticket #2704)
 * Jetty 9.3.28 (ticket #2098)
 * UPnP: More fixes
 * Util: Faster gzip

* 2020-05-25 0.9.46 released

2020-05-23 zzz
 * Windows: Fix permissions in install directory

2020-05-22 zzz
 * Console: Translations update
 * UPnP: More fixes

2020-05-21 zzz
 * Streaming: Fix timer race (ticket #2739)

2020-05-20 zzz
 * i2ptunnel: Disable gzip for streamr server
 * i2ptunnel, SusiDNS: Replace onblur with CSP-safe js
 * Tunnels: Reduce the IBGW and client OBGW batch time

2020-05-19 zzz
 * Util: Speed up zero compression

2020-05-18 zzz
 * NetDB: Reseed update
 * Proxy: Fix error code for incompatible encryption
 * Ratchet: Prep for ratchet-layer acks (WIP)

2020-05-17 zzz
 * Streamr: Add expiration timer
 * UPnP:
   - Fixes for multiple devices
   - Fixes for device and interface changes
   - Handle devices that support permanent leases only
   - Prevent using public IP on Android

2020-05-15 zzz
 * i2ptunnel: Remove javascript from proxy error pages

2020-05-14 zzz
 * Streaming: Change pushBackRTO() log error to warn (ticket #2739)

2020-05-13 zzz
 * Console:
   - Fix option text on /confignet (ticket #2738)
   - Changes to support handlers on /configplugins and /configreseed
   - HTML fixes on /configplugins

2020-05-12 zzz
 * Console: Hide sensitive properties on /configadvanced
 * Console, susimail: Refactor js, stricter CSP
 * i2ptunnel:
   - Fix data loss in forms
   - Encrypt keys in forms
   - Disable more options when running
   - Hide shared client warning when it doesn't apply

2020-05-11 zzz
 * Console: Fix delete confirmation dialog on /configplugins
 * Console, i2psnark, i2ptunnel: Refactor js, stricter CSP

2020-05-10 zzz
 * i2psnark: Support file paths in add form (ticket #2100)

2020-05-10 idk
 * SusiDNS: Fix trac #2419

2020-05-08 zzz
 * Build: Use git revisions when available
 * i2ptunnel: Disable changing some options while running
 * Router: FloodfillPeerSelector cleanup (ticket #2694)

2020-05-07 zzz
 * Router:
   - Fix INMP NPE on non-default config (ticket #2688)
   - Min version for tunnel peers

2020-05-06 zzz
 * Streaming: Reduce default ack delay (ticket #2706)

2020-05-05 zzz
 * Build: Use --java2 for msgfmt
 * i2ptunnel:
   - Add ECIES persistent key support
   - Fix changing enc type on servers
   - Remove experts label from dual-key option
 * Ratchet: Add padding based on optimal message size

2020-05-04 zzz
 * Console: Add log clear buttons (ticket #2449)
 * i2ptunnel: Copy over all relevant options to other shared clients
   when saving, not just tunnel quantity and length (ticket #1545)

2020-05-02 zzz
 * eepsite: Fix RTL issues on Arabic help page (ticket #2731)
 * i2ptunnel: Disable I2CP gzip for HTTP server tunnels
 * i2psnark: Disable I2CP gzip

2020-05-01 zzz
 * Ratchet: Fix NPE ratcheting IB NSR tagset

2020-05-01 idk
 * i2ptunnel: Collapse/Expand UI elements for advanced features, organize
   advanced features by category. Replace nested tables.
 * SusiMail: Fix missing icon from dark theme (ticket #2726)

2020-04-30 zzz
 * i2ptunnel: Prevent changing enc type on running tunnel
 * Ratchet: Error handling fixes
 * Streaming: Westwood+ congestion control (ticket #2719)

2020-04-29 zzz
 * Ratchet: Increase callback timeout
 * Router: Replace old data structure classes

2020-04-27 zzz
 * Crypto: Reduce max ElG tagset expiration at receiver
 * i2psnark:
   - Don't unchoke when we don't have pieces
   - Don't avoid partial pieces if there are several seeds

2020-04-25 zzz
 * i2psnark: Increase min size for video preview
 * Ratchet: Variable tagset lookahead/trim limits

2020-04-24 zzz
 * i2psnark: Don't mark torrent BAD on I2CP errors (ticket #2725)
 * Logging: Log to wrapper log after log manager shutdown (ticket #2725)
 * Router:
   - Allow more time to send disconnect messages at shutdown (ticket #2725)
   - Don't delete router context at shutdown, to prevent a late
     creation of a new app context (ticket #2725)

2020-04-23 zzz
 * Ratchet: Fixes and parameter adjustments
 * Router: Check for key certs in dests (proposal 145)
 * Streaming: Reduce TCB cache time
 * SusiDNS: Fix typo that broke the add form

2020-04-21 zzz
 * Router: Fix logging NPE (thx zlatinb)

2020-04-19 zzz
 * Ratchet: Adaptive order of muxed decrypt based on previous traffic
 * Streaming: Single retransmit timer per connection (ticket #2715)

2020-04-18 zzz
 * i2psnark: Connect out to other seeds to fetch comments (ticket #2288)

2020-04-17 zzz
 * Crypto: Disable speculative AES tagset usage
 * Streaming: Slow start fix

2020-04-16 zzz
 * Build: Reproducible build fix (ticket #2279)

2020-04-14 zzz
 * Ratchet: Improve muxed decrypt
 * Streaming:
   - Fix slow start (ticket #2708)
   - Reset retransmission timer after ack (ticket #2710)

2020-04-13 zzz
 * i2ptunnel: Allow comments in CLI command files

2020-04-10 zzz
 * Streaming: Fix retransmission time (ticket #2709)

2020-04-10 zzz
 * Jetty: Add GzipHandler for eepsites on Jetty 9.3/9.4 (ticket #2599)

2020-04-08 zzz
 * i2psnark: Give peers preference to get first pieces (ticket #2473)
 * NetDB: Remove class M from auto-floodfill
 * NTCP: Retain pending messages when replacing connection
 * Ratchet: TagSet cleanups

2020-04-07 zzz
 * Console: Fix disabling sidebar refresh
 * Graphs:
   - Reduce rrd4j sync thread pool size
   - Disable pool if not persisting
   - Stop pool on shutdown

2020-04-06 zzz
 * Ratchet:
   - Finish Next Key impl.
   - Simplify OB Session
   - Performance improvements and cleanups
   - Debug page fixes

2020-04-03 zzz
 * PrivateKeyFile: Add support for addsubdomain authentication strings

2020-04-01 zzz
 * Ratchet:
   - Next Key WIP
   - Validate NS datetime block; add NS key bloom filter

2020-03-31 zzz
 * NetDB:
   - Add support for ratchet replies (proposal 154)
   - Add support for ElG lookups and stores from ECIES-only destinations
   - Variable timeout for MessageWrapper-generated tags
 * Ratchet:
   - Variable timeout for tagsets
   - Expire tags too far behind current one
   - Remove ID and DI from ACKREQ block
   - Add timeout job in OCMOSJ
   - Prep for next key support
   - Add support for acks and callbacks
 * Tunnels:
   - Refactor TestJob to use MessageWrapper
   - Add support for ratchet

2020-03-24 zzz
 * Blockfile: Add b32 to export output
 * Graphs: Fix rrd4j deprecation warnings
 * Profiles:
   - Don't decay during first 90 minutes of uptime
   - Change decay from .75 twice a day to .84 four times a day
 * Tunnels: Make new tunnel selection round-robin

2020-03-20 zzz
 * Tunnels: FragmentHandler cleanup (ticket #2699)

2020-03-17 zzz
 * i2psnark: Hide non-i2p trackers on details page

2020-03-15 zzz
 * Ratchet: Stub out ack and ack request blocks

2020-03-01 zzz
 * Console:
   - Disable browser launch on /configclients when a service
   - Hide temporary IPv6 addresses from bind options
   - Add security headers to XHR targets
   - Fix wizard XHR initialization

2020-02-29 zzz
 * i2ptunnel: Check for same interface before warning of dup port
 * Profiles: Limit average speed calculation to max high cap peers
 * SusiDNS: Support adding b32's (ticket #2101)

2020-02-28 zzz
 * Console: Fix /viewlicense for Debian packages
 * Debian: Remove fonts-dejavu as package recommendation

2020-02-27 zzz
 * Systray: Don't attempt to launch browser when running as a service

2020-02-26 zzz
 * Profiles: Fix bug causing persisted speed values to be
   reduced when read back in

2020-02-25 zzz
 * Graphs: Replace jrobin with rrd4j 3.5 (ticket #2684)
 * NetDB: Don't send 'fake hash' for exploration any more

* 2020-02-25 0.9.45 released

2020-02-21 zzz
 * Update translations

2020-02-20 zzz
 * Build: Add non-pack200 release targets (ticket #2693)
 * GeoIP (ticket #2692):
   - Add unknown and Kosovo country codes for db-ip.com
   - Change GeoIP update script to use db-ip.com
   - Prefer more recent of mmdb or Debian files if we have both
 * Update: Don't require pack200 for in-net update (ticket #2693)

2020-02-18 zzz
 * Util: Improve LookupDest CLI, add to CommandLine

2020-02-17 zzz
 * Debian: Remove GzipFilter in base-context.xml,
   does nothing with Jetty 9.4 (ticket #2599)
 * Install: Remove commented-out GzipFilter in cgi-context.xml
 * i2psnark: Revert API changes that broke i2psnark-rpc plugin

2020-02-15 zzz
 * Console: Fix jump-to-section on /stats
 * NTCP: Remove closed connections from write queue (ticket #2686)

2020-02-12 zzz
 * I2CP: Place ECIES first in LS2
 * i2ptunnel: Change default sig type to Ed for non-shared HTTP client

2020-02-10 zzz
 * Transport: Mark yggdrasil IPv6 prefix as not routable

2020-02-09 zzz
 * Console: Show local tunnel status as green if any leases are valid
 * I2CP: I2CPMessageHandlerMap cleanup

2020-02-05 zzz
 * SSU: Skip down interfaces when looking for MTU

2020-02-03 zzz
 * Graphs: Clean up font setting, fix bugs (ticket #2684)

2020-01-26 idk
 * changed many icons on both light and dark themes out for Feather equivalents.

2020-01-26 zzz
 * Tunnels: Don't test ECIES-only tunnels

2020-01-21 zzz
 * SSU: Use same valid IP criteria for relay request and response

2020-01-21 zzz
 * Ratchet: Randomize two high bits of Elligator2 encoding

2020-01-15 zzz
 * i2ptunnel: Fix NPE if no config file

2020-01-11 zzz
 * SSU: Extend timeout for msgs with multiple fragments (ticket #2640)

2020-01-08 zzz
 * i2psnark: Support "preview" HTML5 play for partial files
 * Jetty 9.2.29.v20191105
 * Tomcat 8.5.50

2020-01-03 zzz
 * Console:
   - Don't refresh bw graph unless enclosing sidebar refresh is longer
   - Remove scroll-in-scroll for wrapper logs
   - Refactor the configstats js
 * i2psnark:
   - CSS tweaks so the refresh isn't as glitchy
   - Reduce default refresh to 15 sec
 * Tests: Drop empty unit test files

2020-01-02 idk
 * Dark Theme: Colors, borders, icons were simplified across the board
 * Images: Checked in icons from Feather icons, which are under the MIT License
  - https://github.com/feathericons/feather/blob/master/LICENSE

2020-01-02 zzz
 * Util:
   - Add https redirect support to EepGet and SSLEepGet
   - Add https support to EepGet CLI

2019-12-25 zzz
 * Console, webapps: CSP improvements
 * Console: Remove onload and use nonce for inline scripts where able

2019-12-24 zzz
 * Console: Don't show a temporary IP ban if it's permanently banned also
 * i2ptunnel: Double default conn. and POST limits

2019-12-21 zzz
 * Console:
   - Don't show 'Unresolved TCP address' error
   - Fix displayed name when installing new plugin
 * i2psnark: Fix autostart for torrent files copied into the dir

2019-12-20 zzz
 * I2CP: Don't throw exception on early internalConnect()
 * SSU:
   - Reduce log level on packet size error (ticket #2675)
   - Move statement affecting debug stats (ticket #2676)

2019-12-18 zzz
 * Proxy: Clean up links in error pages
 * Router: Prep for a new router bundle

2019-12-17 zzz
 * Util: Move some from console to new core bundle
 * NetDB: Fixes for hidden routers losing peers (ticket #2673)

2019-12-16 zzz
 * Console: Partial az translation

2019-12-15 zzz
 * Console:
   - Hide services sidebar section if empty
   - Fix Hebrew translation

2019-12-14 zzz
 * Console:
   - Add Content-Disposition header to graphs
   - Stat group display names
 * Router: Add new known peers stat

2019-12-03 zzz
 * NDT: Numerous fixes (ticket #2672)
 * OCMOSJ: Cancel timeout job on reply

2019-12-02 zzz
 * Console:
   - Move restart status up in summary bar
   - Process restart status first regardless of display order
 * NDT: Prevent NPE on JSON parse of bad/empty input (ticket #2672)
 * Update manager: Notify GeoIP type and file version

* 2019-12-01 0.9.44 released

2019-11-30 zzz
 * Pull translations

2019-11-30 sadie
 * Console, SusiDNS: CSS updates

2019-11-29 zzz
 * Console, proxy, SusiDNS: Add partial Persian translations

2019-11-27 zzz
 * GeoIP update

2019-11-24 zzz
 * Debian: Add apparmor support for Java 11 (Github PR #19)
 * i2psnark: File system error message improvements

2019-11-23 zzz
 * Router:
   - Don't count zero-hop tunnels as part of the pool when building
   - Don't build more than one zero-hop tunnel in a pool
   - Assume high build failure rate for new installs
   - Reduce threshold for tunnel length override

2019-11-20 zzz
 * I2CP:
   - Prevent an uncaught OCMOSJ exception from killing the session
   - Don't put ECIES first in LS2

2019-11-17 zzz
 * SSU: Lower ACKSender log level (ticket #2651)

2019-11-16 zzz
 * Transport: Save IPv6 firewalled state across restarts (ticket #2175)

2019-11-15 zzz
 * Console: Fix plugin icon-code images
 * i2psnark: Don't start tunnels when autostart enabled but no
   torrents set to autostart (ticket #2662)
 * SSU: Remove redundant field (ticket #2659)

2019-11-14 zzz
 * Transport:
   - Fixes for IPv6 firewalled logic (ticket #2175)
   - Fix SSU log value (ticket #2652)
   - Remove unused currentReceiveSecond (ticket #2661)

2019-11-13 zzz
 * Console: Hide buttons on /configkeyring if no entries
 * i2ptunnel: Don't delay after ConnectException if stopped
   (fixes zzzot stop delay)

2019-11-12 zzz
 * i2psnark:
   - Audio playlist support
   - Restrict mime types for HTML5 players

2019-11-11 zzz
 * KeyGenerator: Use new PrivateKey constructor
 * Router: Set default sig type to EdDSA for Android (ticket #2643)

2019-11-08 zzz
 * i2psnark: Add HTML5 players on details page

2019-11-06 idk
 * Router: Use Local Application Data(%LOCALAPPDATA%)
   instead of Roaming for config (ticket #1258)
 * Console: Change home page organization and headers

2019-11-05 zzz
 * Router: No longer check the clove ID in the Bloom filter

2019-11-02 zzz
 * Router: NSR/ES fixes for proposal 144

2019-10-31 zzz
 * Router: Updates for proposal 144

2019-10-27 zzz
 * NetDB: Don't send encrypted lookup reply to ratchet dest
 * OCMOSJ:
   - Bundle unwrapped ack with LS for ratchet dest
   - Keep bundling LS until acked

2019-10-25 zzz
 * Router (proposal 144):
   - Set client SKM based on configured encryption
   - Select target key in LS based on local client's support
   - Hook new SKMs and engines into Garlic Message encryption/decryption
 * Transport: Publish IPv6 address on transition to non-firewalled
   (ticket #2175)

2019-10-24 zzz
 * Router: New SKMs and Engines for Ratchet (proposal 144)

2019-10-23 zzz
 * Build:
   - Recognize gettext 0.20
   - Make 3 release targets, with jbigi/geoip/neither
 * Crypto:
   - New KeyFactory interface
   - Base classes for ECIES-Ratchet (proposal 144)
 * Data:
   - Reduce SessionTag size
   - Cache public key in private key class
   - Add LeaseSet methods to get encryption key by type
 * I2CP:
   - Fix error message for config errors (ticket #2639)
   - Add config to disable loopback for testing
 * i2ptunnel: Add encrytion type selection to form (proposal 144)
 * NetDb: Don't garlic encrypt netdb messages with a ECIES key
 * Router (proposal 144):
   - Add KeyManager support for multiple leaseset private keys
   - Fix logic error in check for local destinations
   - Register all LS2 keys with KeyManager
 * Startup: clients.config.d files must end in ".config"

* 2019-10-22 0.9.43 released

2019-10-18 zzz
 * Translation updates
 * GeoIP update

2019-10-12 zzz
 * NTCP: Performance improvement (tickets #2619, #2620)

2019-10-11 zzz
 * Console: Fix mime type and encoding on javadoc pages

2019-10-06 zzz
 * I2NP: Remove unused I2NPMessageHandler methods

2019-10-03 zzz
 * i2psnark: Start with minimum tunnel count (ticket #2623)

2019-10-03 idk
 * Console: Wizard updates (ticket #2415)

2019-10-01 zzz
 * Console: Remove i2pwiki.i2p (ticket #2626)
 * PortMapper: Fix URL generation for IPv6 hosts

2019-09-21 zzz
 * Tomcat 8.5.46

2019-09-19 zzz
 * i2ptunnel: Support quoting for custom options (ticket #2603)

2019-09-18 zzz
 * I2CP:
   - More BlindingInfo serialization fixes
   - Shorten lookup timeout on router side

2019-09-17 zzz
 * I2CP: Fix BlindingInfo serialization
 * i2ptunnel:
   - Remove streamr, connect, and httpbidir from wizard
   - B32 auth form improvements
   - Improve query parsing in local HTTP server
   - New CLI BlindingInfo test
 * Router: Implement expiration for BlindData entries

2019-09-14 zzz
 * i2ptunnel: Fix SSL wizard for split config (ticket #2610)
 * Reseed: Fix adding netid param (ticket #2621)
 * Util: Don't attempt to load hidden cert files (ticket #2622)

2019-09-12 zzz
 * I2CP: BlindingInfo fixes
 * i2ptunnel: New form for blinding info

2019-09-10 zzz
 * I2CP: New Blinding Info message (proposal 123)
 * i2ptunnel: New b32 error page
 * Util: Fix AIOOBE on bad input to base 32 decode

2019-09-08 zzz
 * Transport:
   - Don't automatically transition from firewalled
     to non-firewalled when IPv6 address changes
   - Prefer temporary IPv6 addresses when in laptop mode
   - Also use saved IPv6 address for local router GeoIP lookup

2019-09-07 zzz
 * Console: Fix first row of version info not selectable (ticket #2615)
 * Jetty: Support annotation scanning of plugins for Servlet 3.0 @WebServlet
 * Transport: Detect IPv6 address changes (ticket #2175)

2019-09-06 zzz
 * Transports: Remove IPv6 addresses on transition to IPv6 firewalled

2019-09-04 zzz
 * SSU: Don't mark peer unreachable if it reports
   we have a bad port (ticket #2467)
 * SusiMail:
   - Show "to" rather than "from" in sent and drafts folder (ticket #2571)
   - Fix sort links going to wrong folder

2019-09-03 zzz
 * SSU: Fix IPv6 peer test not firing
 * Tunnels: Use context AES for hop processing
 * Utils:
   - Fix SAN verification for IPv6 hostnames
   - Add Quad9 DoH servers

2019-09-02 zzz
 * Unit test fixes

2019-08-30 zzz
 * Util: Consolidate and standardize date/time formatting (ticket #2016)

2019-08-29 zzz
 * Router: Job Queue cleanups and javadocs (ticket #2590)
 * Transport:
   - Move I2PHMac to udp package
   - UPnP HTML output fix

* 2019-08-27 0.9.42 released

2019-08-23 zzz
 * Translation updates

2019-08-19 zzz
 * SSU: Increase initial concurrent messages limit (ticket #2576)

2019-08-18 zzz
 * Jetty: Log stack trace if 2nd arg is a Throwable (ticket #2592)

2019-08-15 zzz
 * SSU: Reduce ACK time to 150 (ticket #2574)
 * Tunnels: Reduce IBGW batching time (ticket #2586)

2019-08-14 zzz
 * Console: Clean up help text, tag for translation (ticket #2298)

2019-08-10 str4d
 * EdDSA: Reduce diff between vendored code and upstream
 * Jetty: Fix Gradle build
 * Tests:
   - Fix compilation bug after SSU HMAC implementation move
   - Temporarily mitigate discrepancy between Ant and Gradle in
     SingleFileNamingServiceTest
   - Unify core test resources across JUnit and ScalaTest
   - Fix streaming integration tests after access filtering changes

2019-08-05 zzz
 * i2ptunnel:
   - Add configs to override user agent
   - Add failsafe timeouts for local sockets (ticket #2568)
 * Reseed: Send network ID in query string (proposal 147)
 * Transports: Implement cross-network detection (proposal 147)

2019-08-04 zzz
 * i2psnark:
   - Add checks for dup data dirs (ticket #2291)
   - Fix autostart to only start torrents running previously (ticket #2120)
 * SSU: Fix stall when higher-priority message is queued (ticket #2582)
 * Streaming: Reduce immediate ack delay (ticket #2584)

2019-08-03 zzz
 * Transport: Allow local addresses when configured

2019-08-02 zzz
 * Router: Fix Bloom filter false positives

2019-08-01 zzz
 * i2psnark:
   - Fix announce hosts of the form b64dest[.i2p]
   - Add last activity stat
   - Disallow illegal filenames on Windows

2019-07-27 zzz
 * JBigI: GMP 6.1.2 for linux 64 bit (ticket #1869)

2019-07-26 zzz
 * Debian: Change debian files from stretch (Jetty 9.2, Tomcat 8, Java 8)
   to buster (Jetty 9.4, Tomcat 9, Java 11)
 * Prop from i2p.i2p.zzz.confsplit:
   Split clients.config and i2ptunnel.config into individual files
   for each client and tunnel, except on android and portable.

2019-07-23 zzz
 * Data: Initial support for enc types
 * Router: Checks for new enc types

2019-07-22 zzz
 * NetDB: Handle LS2 blinded flag bit

2019-07-19 zzz
 * Console: Split up /help page, prep for translation (ticket #2298)

2019-07-18 zzz
 * Data: Set LS2 flag bit when blinded

2019-07-12 zzz
 * Build: Move SSU HMAC implementation from core to router
 * Test: Fix broken unit test build

2019-07-11 zzz
 * imagegen: Improve QR font rendering

2019-07-09 zzz
 * NetDb:
   - Fix NPE on store of Encrypted LS (ticket #2563)
   - Pick alternate reply GW for netdb store reply
     if connected, to reduce connections

2019-07-04 zzz
 * Console: Hide netdb RI and LS tabs (ticket #2558)

* 2019-07-03 0.9.41 released

2019-06-28 zzz
 * Update translations from Transifex

2019-06-26 zzz
 * Transport: Fix issues with leaving hidden mode (ticket #2557)

2019-06-25 zzz
 * I2CP: Prevent sending message to a local meta destination
 * imagegen: Catch render error (ticket #2507)
 * Router: Disable MessageHistory job on Android
 * Streaming:
   - Check that destinations match in signatures
   - Increase size of recently-closed cache

2019-06-22 zzz
 * Console: New logo
 * I2CP: Ensure that callbacks are called on abnormal close

2019-06-21 zzz
 * Transport: Update hidden mode country list

2019-06-18 zzz
 * i2ptunnel: Improve logging when no outproxy configured (ticket #2338)
 * Reseed: Remove atomike

2019-06-17 zzz
 * Console: Hide news section in summary bar if
   news fetching is disabled (ticket #2301)
 * Router: Don't check for ping file at startup on Android

2019-06-16 zzz
 * i2psnark:
   - Increase DHT blacklist time (ticket #2275)
   - Fix QupZilla detection (ticket #2026)

2019-06-15 zzz
 * Console: Fix stopping webapps at shutdown (ticket #2508)

2019-06-09 zzz
 * Eepsite Help page: Add links to Arabic, Hungarian, Indonesian.
   fix link to Italian
 * SusiMail: Add Farsi translation
 * Tests: Fix some bashisms, add more files to bashisms check
 * UPnP: Set lease duration of 3 hours, always refresh the lease

2019-06-08 zzz
 * NetDB:
   - Fix Deliv. Status msg sent direct to tunnel
   - Faster startup for non-Android

2019-06-07 zzz
 * NetDB: Fix NPE on failed decrypt of enc. ls2

2019-06-06 zzz
 * CPUID/NBI:
   - Add Skylake support (ticket #1869)
   - Recognize more Intel "Lake" processors

2019-06-05 zzz
 * NetDb: Fix to set netDb ready immediately after reseed
 * Util: Add EKU to selfsigned certs

2019-06-03 zzz
 * Transport: Fix large messages in SSU (ticket #2505)

2019-06-02 zzz
 * Build: Fix Debian (ticket #2517)
 * i2ptunnel: Add new getInstance() method for Android
 * Update PAC file for additional security

2019-06-01 zzz
 * NetDB: Don't wait for all RIs to be read in on Android
 * Tunnels: Ensure GW Pumper threads stop on Android

2019-05-31 zzz
 * Blinding: Bug fixes
 * Transport: UPnP fixes for Android (ticket #2499)

2019-05-30 zzz
 * Console: Support deleting blinded entries on /configkeyring

2019-05-29 zzz
 * I2CP: Fix bugs with lookup password
 * Util: Store save time in config files

2019-05-28 zzz
 * Console: Form handling on /configkeyring for LS2

2019-05-27 zzz
 * Console: Start rework of /configkeyring for LS2

2019-05-26 zzz
 * I2CP: Add per-client auth to generated leaseset

2019-05-24 zzz
 * i2ptunnel:
   - Per-client auth config
   - Hide encryption key for per-client auth
   - User-select: all for key fields

2019-05-23 zzz
 * i2ptunnel:
   - Rework server encryption key UI in prep for blinded keys
   - Remove generate button, automatically generate when required
   - Refactor auto configuration
   - Add LS2 option, change to select box
   - Select box for sig type

2019-05-22 zzz
 * Crypto: Add X25519 DH class
 * Data: Per-client auth for enc. LS2 (proposal 123)
 * Transport: Use KeyGenerator for X25519 keys

2019-05-21 zzz
 * Profiles: Omit comments from stored profiles

2019-05-20 zzz
 * Console: Hide some columns on /peers SSU tab unless advanced
 * Installer:
   - Fix -console install for Izpack 5 (ticket #2492)
   - Switch to Izpack 5 for non-windows release installer
 * Sybil:
   - Escape % in stored reasons
   - Improve error handling when loading files
   - Skip comment lines in stored files
 * Tunnels: Increase tunnel reuse probability

2019-05-19 zzz
 * Build: Remove dependencies on Nashorn (ticket #2367)
 * Sybil:
   - Run IP and family tests on all routers
   - Delete old stored analysis if configured

2019-05-18 zzz
 * Javadoc: fixes from FreeBSD ports
 * Sybil:
   - Option to run on non-floodfills too
   - Show routers in analysis even if no RI available
   - Date format and reason text fixes
   - Add link to banlist

2019-05-15 zzz
 * EepGet: Don't continue when requested a partial but didn't
   get it, and the output is to a stream
 * Streaming: Fix NPE in debug logging (ticket #2504)

2019-05-14 zzz
 * Util: Don't set restrictive permissions on exported certs

2019-05-13 zzz
 * Console:
   - Hide transport table unless advanced
   - Prevent editing a client while it's starting
 * Sybil: Add support for auto-blocking
 * Tunnels: Fix connection checker for NTCP2

2019-05-12 zzz
 * Jetty: Fix webapps in eepsite (ticket #2477)
 * Util: Consolidate Java version checking code, fix bugs

2019-05-11 zzz
 * Utils: Allow absolute path to certs in I2PSSLSocketFactory

2019-05-10 zzz
 * NetDB: Store Meta LS2 to floodfills (proposal #123)

2019-05-09 zzz
 * Console:
   - Delay plugin update check until router is ready
   - Remove plugin install success message (ticket #2494)
 * Transport: Start first GeoIP lookup when netdb is ready
 * Wrapper:
   - Add support for armv7 and aarch64 (ticket #2308)
   - Update to 3.5.39

2019-05-08 zzz
 * Utils: Auto-generate su3 output file for extract if not specified

* 2019-05-07 0.9.40 released

2019-05-02 zzz
 * Android: Catch ISE from PRNG at shutdown (ticket #2077)
 * GeoIP Maxmind 2019-04-29
 * NTCP: Rare EventPumper 100% CPU fix (ticket #2476)
 * UPnP: Remove finalize() in HTTPSocket (ticket #2490)

2019-04-25 zzz
 * Build: Drop unmaintained sample apparmor script (ticket #2319)
 * i2ptunnel: Force connect delay and bulk profile for most
   client tunnel types, and hide from UI
 * Transport: Disable NTCP 1 by default

2019-04-24 zzz
 * Crypto: Catch ProviderException in KeyStoreUtil (ticket #2479)

2019-04-22 zzz
 * Build:
   - Switch to IzPack 5.1.3 for building releases (ticket #1864)
   - Use izpack2exe for Windows installer (ticket #2403)

2019-04-21 str4d
 * Gradle:
   - Adjust dependencies to match Tomcat and Jetty updates
   - Generate reproducible archives
   - Generate attributes for JAR manifests
 * Tests: Fix ministreaming tests after access filtering changes

2019-04-20 zzz
 * Console, SusiDNS: New icons
 * Debian: Update Bionic/Cosmic to include patch for Jetty 9.4
 * Router:
   - Update NTCP checks for NTCP2
   - Remove old check for 0.6.1.32 and earlier routers

2019-04-18 zzz
 * Console: Improve error message when graphs disabled (ticket #2452)
 * Utils: CoDel minor speedup (ticket #2398)

2019-04-17 zzz
 * Transport: More fixes for NTCP when SSU disabled (ticket #1417)

2019-04-16 zzz
 * Console: More new icons

2019-04-15 zzz
 * Console: Don't display I2CP error during soft restart (ticket #2468)
 * NamingService: Fix class selection in app context (ticket #2469)
 * Tomcat 8.5.40

2019-04-13 zzz
 * i2ptunnel:
   - Config UI for encrypted ls2
   - Display encrypted b32
   - Disable registration authentication when encrypted
   - Hide I2CP config in router context
   - Disallow any encrypted LS for offline keys
   - Fix NPE creating server tunnel
   - Add Red25519 sigtype option for servers

2019-04-10 zzz
 * Jetty: Hide sizes and dates of directories in listings
 * NTCP2: Allow longer padding in msg 1 if NTCP1 disabled

2019-04-08 zzz
 * Util: Fix memory leak in compressor (ticket #2471)

2019-04-03 zzz
 * I2PTunnel: Start/stop POST throttle timer

2019-04-02 zab
 * I2PTunnel: Implement access filtering (ticket #2464)

2019-03-31 zzz
 * Data: Implement Destroyable for private keys (ticket #2462)

2019-03-29 zzz
 * Crypto: SigContext (WIP) (proposal #148)
 * NetDB: Persist cached blinding data (proposal #123)

2019-03-27 zzz
 * NetDB: Cache blinding data for lookups and decryption (proposal #123)

2019-03-23 zzz
 * Data: Preliminary work on new b32 format (proposal #149)
 * SelfSignedGenerator:
   - Fix generation with Ed25519ph keys (ticket #2465)
   - Increase serial number from 63 to 71 bits
 * SusiDNS: Add import feature (ticket #2447)

2019-03-22 zzz
 * i2ptunnel: Escape {} in URLs (ticket #2130)

* 2019-03-21 0.9.39 released

2019-03-16 zzz
 * Fix Debian builds with Jetty 9.4.15 (ticket #2457)

2019-03-11 zab
 * Startup: make negative client app delay value mean waiting
   for router to be RUNNING (ticket #2377)
 * I2PTunnel: make I2PTunnel default to negative startup delay value
   (ticket #2377)

2019-03-11 zzz
 * Console: New home page icons

2019-03-09 zzz
 * Data: Consolidate offline key check
 * I2CP: Add support for blinding secret
 * i2ptunnel: Prevent registration auth if key offline

2019-03-07 zzz
 * NetDB: Minor performance improvement in selectors

2019-03-06 zzz
 * NetDB: Fix flood version check, add version check for RedDSA

2019-03-05 zzz
 * Data: Update Encrypted LS2 blinding and encryption

2019-03-04 zzz
 * Console: Fix NPEs displaying encrypted LS2
 * Data: Fix NPE in debug logging
 * I2CP, NetDB: More fixes for encrypted LS2 (proposal 123)
 * NetDB: Call fail callback when lookup is negative cached (thx zab)

2019-03-02 zzz
 * I2CP, NetDB: Fixes for encrypted LS2 (proposal 123)

2019-03-01 zzz
 * Streaming: Fix sending messages with expired times (ticket #2451)

2019-02-28 zzz
 * Console:
   - Fix router logs not shown if first msg is a dup
   - Change fallback client names to use b32

2019-02-26 zzz
 * SSU:
   - Fix scheduling of peer test at startup (ticket #2441)
   - Fix RTT/RTO calculations (ticket #2443)

2019-02-25 zzz
 * NetDB: Fix dup publish of RI at startup
 * NTCP: Fix number of SendFinisher threads (ticket #2438)

2019-02-23 zzz
 * Console: Flip order of router logs
 * NetDB:
   - Use published date, not earliest lease expiration, for LS2 comparisons
   - Fix earliest LS expiration adjustment when publishing for LS2
   - Increase flood candidates for LS2
   - Don't start new store after verify fail if we've already done so
   - Version checks for encrypted LS2
 * NTCP: Loop in pumper if more to write (ticket #2440)

2019-02-21 zzz
 * Crypto: Keygen for RedDSA, allow RedDSA for unblinded keys (Enc LS2)
 * Data: Always set unpublished flag for inner LS (Enc LS2)
 * I2CP: Force i2cp.leaseSetType option for offline keys

2019-02-20 zzz
 * Crypto: ChaCha20 and RedDSA for Encrypted LS2 (proposal #123)
 * Data: Encrypt/decrypt/sign/verify for Encrypted LS2 (proposal #123)

2019-02-19 zzz
 * Crypto: Implement blinding, add sig type 11 (proposal 123)

2019-02-18 zzz
 * Console: Drop midnight and classic themes (ticket #2272)
 * Tomcat 8.5.38
 * Transport:
   - Fixes for NTCP when SSU disabled (ticket #1417)
   - Delay port forwarding until after UPnP rescan complete

2019-02-08 zzz
 * Console: Hide disabled transports on /peers
 * SSU: EstablishmentManager fixes (ticket #2397)

2019-02-07 zzz
 * NTCP:
   - Add option to disable NTCP1 (ticket #2328)
   - Don't bid for outbound-only NTCP2 addresses
   - Fix NTCP2 cost when transitioning to inbound
 * SAM: Support offline keys
 * Streaming: Fix exception after sig verify fail

2019-02-06 zzz
 * Build: Add targets for alternate debian distros (ticket #2410)
 * Crypto: Shortcut GroupElement representation conversion
 * I2CP: Prevent use of repliable datagrams with offline keys

2019-02-05 zzz
 * Transport:
   - Clean up unreachable() methods (ticket #2382)
   - Speed up NTCP allowConnection() (ticket #2381)
   - OutNetMessage cleanup (ticket #2386)
   - SSU PacketHandler cleanup (ticket #2383)

2019-02-04 zzz
 * I2CP: Change format and message type of CreateLeaseSet2 message

2019-02-03 zzz
 * I2CP:
   - Remove revocation private key from CreateLeaseset2 message
   - Use correct key to sign SessionConfig with offline keys
 * i2ptunnel: Fix HTTP websockets by passing through
   Connection headers containing "upgrade" (ticket #2422)
 * Streaming:
   - Support offline signatures (proposal 123)
   - Don't send FROM in RESET, not required since 0.9.20
   - Send RESET when SYN signature verification fails
   - Use cached buffers for signature verification
   - Always verify packets with signatures, even if not required
 * Test: Disable NTP in LocalClientManager

2019-02-02 zzz
 * Debian: Fix build of i2pcontrol

2019-02-01 zzz
 * Debian: AppArmor fix for Oracle JVM (ticket #2319)
 * i2ptunnel:
   - Caching of outproxy selection, avoid last-failed outproxy
   - More localhost checks
   - Handle PUT like POST

2019-01-31 zzz
 * Debian: Fix version detection of Tomcat 9 required
   for reproducible builds (ticket #2279)

2019-01-30 zzz
 * Build: Fix javac.classpath in junit.compileTest targets (ticket #2333)
 * I2CP: Fixes for CreateLeaseset2 message with multiple keys

2019-01-28 zzz
 * Bundle i2pcontrol
 * EdDSA: Make more classes serializable (Github PR #68)

2019-01-27 zzz
 * NDT:
   - Catch exception on DNS lookup failure (ticket #2399)
   - Add support for specifying server in CLI (ticket #2413)

2019-01-24 zzz
 * Debian:
   - Fix Debian control files (ticket #2401)
   - Add build option for libtomcat9 (ticket #2364)
   - Fix PPA builds for precise and trusty (ticket #2408)

* 2019-01-22 0.9.38 released

2019-01-21 zzz
 * Debian:
   - Add source param to javadoc target (ticket #2394)
   - Replace ttf-dejavu with fonts-dejavu (ticket #2395)
 * Reseed: Update SSL cert

2019-01-18 zzz
 * Build:
   - Update translations
   - Add files for Disco
 * NTCP: Stop X25519KeyFactory on shutdown (ticket #2388)
 * Plugins: Fix loading of webapp configuration classes (ticket #2385)

2019-01-15 zzz
 * Debian: AppArmor updates (ticket #2319)
 * SusiMail:
   - Fix sending mail with attachments (ticket #2373)
   - Fix deleting attachments from drafts
   - Fix dup attachments after clicking add attachment without browsing first
   - Fix update of draft folder after saving as draft
   - Change text of add attachment button for clarity

2019-01-13 zzz
 * I2CP: Set LS2 unpublished bit, show in debug output

2019-01-12 zzz
 * NetDB: Use isSlow() in floodfill criteria
 * SSU: More consolidation of clock().now() calls

2019-01-10 zzz
 * I2CP:
   - Router-side handling of meta LS2
   - Remove client-side-only options from those sent to router
   - Router-side stub for encrypted LS2

2019-01-09 zzz
 * Console: Fix broken image link on /configui
 * I2CP: Stub out client-side creation of meta and enc. LS2
 * Wrapper: Increase default heap to 256 MB

2019-01-05 zzz
 * Crypto: Stub out EdDSA blinding (proposal 123)

2019-01-04 zzz
 * Build: Check cert validity
 * Data: Add type byte to MetaLease (proposal 123)
 * NetDb: Prevent ISJ deadlock (ticket #2366)
 * Router: Reseed updates

2019-01-02 zzz
 * Console: Wizard styling (ticket #1473)
 * Data: Encrypted LS2 progress (proposal 123)

2019-01-01 zzz
 * Console:
   - New light background (ticket #738)
   - Add warning for OpenJDK Zero VM
 * Data:
   - Add support for LS2 multiple encryption keys (proposal 123)
   - Fix Meta LS2 bugs (proposal 123)
 * Debian: Remove obsolete systray.config
 * NBI: Add lookup tables for ARMv8

2018-12-24 zzz
 * Console: Update ARM warning (ticket #2368)

2018-12-23 zzz
 * Console: Sybil tool background analysis setup form

2018-12-21 zzz
 * Transports: Improve banning of routers from wrong network

2018-12-19 zzz
 * NTCP: Efficiency improvements (ticket #2355)

2018-12-17 zzz
 * Console: Sybil tool background analysis
 * Data: Set encrypted LS2 hash (proposal 123)
 * GeoIP: Fix NPE (thx parg)
 * NTCP: Use new HKDF class

2018-12-15 zzz
 * Console: Sybil tool refactoring

2018-12-13 zzz
 * Crypto: Add HKDF class for LS2 and NTCP2 (proposal 123)

2018-12-12 zzz
 * DTG: Use UrlLauncher to launch browser
 * Installer: Drop unused systray.config
 * UrlLauncher: Improvements and cleanups
 * Util: Add another ShellCommand String[] method

2018-12-11 zzz
 * Crypto: HMAC-SHA256 cleanup
 * Debian: Add conffiles list
 * Utils: Enable TLSv1.3 for SSL sockets

2018-12-08 zzz
 * Console: Hide I2CP config if disabled
 * NetDb: Allow longer expiration for Meta LS2
 * Transport:
   - Don't repeatedly publish RI if IPv6-only but
     not configured IPv6-only
   - Don't set status to disconnected if IPv6-only but
     not configured IPv6-only

2018-12-05 zzz
 * I2CP:
   - Propagate error from disconnect message to session listener
   - Set offline keys in generated LS2
   - Set and validate offline sig in SessionConfig

2018-12-04 zzz
 * Data: Add preliminary PrivateKeyFile support for LS2 offline keys (proposal #123)
 * I2CP: Add preliminary support for LS2 offline keys (proposal #123)

2018-12-03 zzz
 * I2CP: Consolidate all the port 7654 definitions
 * NetDb: Don't send our RI in response to DSM when shutting down
 * Wizard: Update text

2018-12-02 zzz
 * Router: Allow LS2 DSM down a tunnel
 * Transport: Add methods to force-disconnect a peer

2018-12-01 zzz
 * I2CP: Add preliminary support for LS2 (proposal #123)
 * Router: More support for LS2 types (proposal #123)

2018-11-30 zzz
 * Crypto: Move X25519 primitives from router to core (proposal #144)
 * Data: Update LS2 sign/verify to match spec changes (proposal #123)

2018-11-25 zzz
 * Utils: Catch ProviderException in SelfSignedGenerator (ticket #2344)

2018-11-20 zzz
 * GeoIP: Add support for Maxmind GeoLite2 format (ticket #2268)

2018-11-19 zzz
 * Debian: Add libjson-simple-java dependency
 * Util: Change json lib from net.minidev.json to com.json.simple

2018-11-17 zzz
 * Console: Wizard fixes and improvements

2018-11-15 zzz
 * Console: Connect NDT to setup wizard, various fixes

2018-11-13 zzz
 * Console:
   - New M-Lab NDT subsystem (ticket #2321)
   - Setup wizard (WIP) (ticket #1473)
 * Router: LS2 handling for proposal 123

2018-10-13 zzz
 * Build: Add javac.classpath to junit.compileTest targets (ticket #2333)
 * Data: Add LS2 classes for proposal 123

2018-10-11 zzz
 * Console: Remove static Server reference

2018-10-10 zzz
 * Build: Provide option to prevent Class-Path in manifests (ticket #2317)

2018-10-09 zzz
 * Console: Sybil tool refactoring

2018-10-08 zzz
 * Console: Refactor StatSummarizer

2018-10-07 zzz
 * Build: Fix config with-libtomcat8-java but not
   with-libjetty9-java (ticket #1934)
 * Debian: Don't override dh_builddeb (ticket #2329)

2018-10-06 zzz
 * Console:
   - Fix P/X caps on /tunnels
   - Netdb search fixes (ticket #2326)
   - Sort addresses in RIs
   - Split /peers page into tabs (ticket #1934)

* 2018-10-04 0.9.37 released

2018-10-01 zzz
 * Pull translations from tx

2018-09-26 zzz
 * Crypto: Avoid privkey conversion when generating CRL,
   failing on Android for unknown reasons (ticket #2296)
 * IRC: Make inbound whitelist static
 * Router: Don't add 'O' cap for P/X anymore

2018-09-24 zzz
 * Build: Compile jsps in-order for reproducibility (ticket #2279)

2018-09-23 zzz
 * Plugins: Blacklist neodatis and seedless for Java 9+ (ticket #2295)

2018-09-22 zzz
 * NTCP:
   - Fix handling of multiple connections
   - Change termination code for expired RI

2018-09-16 zzz
 * Build: Fix hang with Tomcat 8.5.33+ (ticket #2307)
 * Tomcat 8.5.34

2018-08-27 zzz
 * Debian: Prevent dup version (ticket #2300)

2018-08-26 zzz
 * NTCP2: Publish outbound address after transition to firewalled

2018-08-24 zzz
 * i2psnark: Better comment deduping, fixes rating average
 * NTCP2: Enable by default

* 2018-08-23 0.9.36 released

2018-08-20 zzz
 * Jetty 9.2.25.v20180606

2018-08-19 zzz
 * NTCP2: Catch bad IV exception
 * Update translations

2018-08-16 zzz
 * i2ptunnel: Change read timeout defaults now that streaming timeout works

2018-08-13 zzz
 * Console: Format part. tunnel rate

2018-08-04 zzz
 * Data: Check sooner for unknown sig type
 * I2NP: Remove unused Stream methods

2018-08-03 zzz
 * NTCP2: Fix termination handling and padding calculation

2018-08-02 zzz
 * i2psnark: Don't disconnect seeds if comments enabled (ticket #2288)
 * NTCP2: Send termination on idle timeout
 * Streaming: More efficient copying in MessageInputStream

2018-07-28 zzz
 * Console: Catch ISE in get/setAttribute() (ticket #1529)
 * Streaming: Throw exception on read timeout (ticket #2292)

2018-07-27 zzz
 * Console: Split netdb output into pages
 * Router: Implement router.rejectStartupTime config (ticket #2285)
 * Transport: Defer NTCP 1/2 classification until receiving 64 bytes

2018-07-21 zzz
 * Build: Add check for libtaglibs package in debian builds
 * Console: Add netdb search by transport
 * i2psnark: Sequential order option for single-file torrents (ticket #2234)
 * NTCP2:
   - Fix error sending large message (ticket #2286)
   - Fix NPE after handshake failure (ticket #2286)
   - Reduce log levels
 * Tests: Backport EdDSA junit changes; fixes NPE in 2 tests

2018-07-16 zzz
 * Console: Fix HTML error on /configservice w/o wrapper

2018-07-15 zzz
 * I2CP: Add option for forcing gzip on/off per-message
 * NTCP: Increase failsafe sleep threshold (ticket #2251)
 * Router: Add CLI tool to generate family keys

2018-07-14 zzz
 * i2psnark: Recreate deleted files on recheck/reopen (ticket #2125)

2018-07-13 zzz
 * i2psnark: Add sequential order option (ticket #2234)

2018-07-10 zzz
 * Installer (ticket #1864):
   - Fix wrapper selection on Windows 10
   - Add support for IzPack 5
 * SSU: Sync/notify improvements (ticket #2260)
 * Util: Convert more caches to TryCache (ticket #2263)

2018-07-08 zzz
 * i2psnark: Add comment icon (ticket #2278)
 * NTCP2: Avoid possible NPEs (ticket #2286)
 * Transport: More efficient caching (ticket #2263)

2018-07-06 zzz
 * NTCP: Read all available data when able (ticket #2243)
 * SSU: Change remaining acks from List to Set (ticket #2258)

2018-07-05 zzz
 * i2psnark:
   - Fix IOOBE when stopping torrent that is allocating (ticket #2273)
   - Fix comments wrapping (ticket #2284)
 * NTCP2: Increase max message size

2018-07-04 zzz
 * NTCP: Don't advertise interface address when configured for force-firewalled

2018-07-01 zzz
 * Build: Move Jetty/Tomcat version properties to top-level build.xml
 * Crypto: Backport EdDSA versions 0.2/0.3 from github
 * NTCP2: Adjust padding defaults and size calculation

2018-06-30 zzz
  * Console: Fix reading flags when symlinked (ticket #2270)
  * Router: Reselect jbigi lib when processor changes (ticket #2277)

2018-06-28 zzz
  * Debian: Initial work on reproducible builds (ticket #2279)

2018-06-27 zzz
  * Debian: Add dependency for famfamfam-flag-png (ticket #2270)

2018-06-26 zzz
  * Console: Move modified flags to new dir (ticket #2270)
  * Console servlets: Move to new package (ticket #2265)
  * NTCP pumper: Reduce false positives in failsafe code (ticket #2237)
  * NTCP2: Initial checkins (proposal #111)
  * Streaming: Enforce valid port in setters

* 2018-06-26 0.9.35 released

2018-06-23 zzz
 * Pull translation updates from Transifex
 * New Azerbaijani translations
 * GeoIPv6 update from MaxMind 2018-06-04

2018-06-21 zzz
 * Console: Add Azerbaijani
 * SusiMail: Fix NPE on logout (ticket #2266)

2018-06-19 zzz
 * Console:
   - Restore line breaks in copy/pasted logs (ticket #2078)
   - Don't show individual tx/rx graphs if showing combined graph (ticket #2106)
 * SSU: Set volatile on field (ticket #2260)

2018-06-17 zzz
 * NTCP: Log and fail messages on outbound queue overflow

2018-06-16 zzz
 * GeoIP: Don't log error when reading to the end
   of the geoipv6.dat file

2018-06-15 zzz
 * i2ptunnel: Add new irc server
 * SusiMail: CSS fixes (ticket #2242)

2018-06-13 zzz
 * Console: po-update
 * NTCP: Fix clearing of write interest ops on
   inbound establishment (ticket #2237)

2018-06-09 zzz
 * eepsite: Fix up help page in prep for translation (ticket #2214)
 * i2psnark: Fix torrent ignoring priority settings when
   autostart is enabled (ticket #2229)

2018-06-02 zzz
 * Console: Sort tunnels within pools by expiration (ticket #2232)
 * NTCP:
   - Refactor EstablishState in prep for NTCP2
   - Initial NTCP2 RI and payload code, disabled for now
   - Fix state lock, should not have been static

2018-06-01 zzz
 * SusiDNS: Fix deleting notes (ticket #1433)

2018-05-31 zzz
 * Console:
   - Fix CSS preventing ordered lists (ticket #2075)
   - Change Java 10 warning to Java 11,
 * SusiDNS: Add notes form (ticket #1433)

2018-05-30 zzz
 * Debian build fixes, remove things from source package
 * NTCP: Cleanup, prep for NTCP2, increase max RI size
 * SusiMail:
   - Button and CSS fixes
   - Don't require confirmation to delete from Trash,
   - Clear reallydelete flag when clicking cancel or change folder
   - Fix dup ConnectWaiter run, lack of failure message
   - Fix persistent loading/fetching/refresh messages

2018-05-28 zzz
 * Console: Tagged string fixes (ticket #2017)
 * SusiMail: (ticket #2087)
   - Send deletions after connect so emails don't come back after a move
   - Fix fetches in check mail
   - CSS fixes

2018-05-26 zzz
 * /confignet: Reorganize (ticket #2217)
 * /configsidebar: Tag sections for translation; sort unselected sections by translated name
 * i2psnark:
   - Hide "0 Bps" if no peers (ticket #2152)
   - Hide peers button if no peers (ticket #2152)
   - Hide column 1 icon for peers (ticket #1996)
 * i2ptunnel: Retry accept after server socket closed (ticket #2003)
 * Jetty: Skip files with [] in default servlet listing
 * ministreaming: Add classpath to jar (ticket #2228)
 * Router: Fix wrapper.config path in OOM message when installed as
   Debian package, but not running as a service (ticket #2223)
 * Summary Bar: Change header from "I2P Updates" to "Update Status" (ticket #2137)
 * Utils: Disable DNSoverHTTPS by default (ticket #2201)

2018-05-25 zzz
 * Console: Fix changes to wrong tunnel on /configtunnels (ticket #2227)
 * i2ptunnel: Fix dup tunnels clicking generate on new tunnel (ticket #2225)

2018-05-06 meeh
 * launchers:
   - rewritten some logic
   - made CompleteDeployment which extracts i2pbase.zip
   - made a SBT task that creates i2pbase.zip
   - after the hassle I had even getting an JRE7, short: OSX assumes JRE8+
   - started on a class SystemTrayManager which also holds router state info for menu item filter
   - "ant osxLauncher" produces now a valid app bundle under launchers/output
 * Updated ant and made osxLauncher work again (first time triggers SBT dl if not already installed.)
 * monotone ignore file update

2018-05-05 zzz
 * i2ptunnel:
   - Link to SSL wizard (ticket #2159)
   - Enable SSL to i2p hosts by default
 * Streaming: Don't send HTTP response on an HTTPS connection

2018-05-01 meeh
 * launchers:
   - Added deployment profile for Mac OS X launcher.
   - Sourced out common code to a common library SBT project.
   - Decided ~/Library/I2P should be base path on Mac OS X when using regular bundle (Non-BB).

2018-04-29 zzz
 * Console: Fix NPE on /configsidebar (ticket #2220)

2018-04-28 zzz
 * i2ptunnel:
   - Fix startup deadlock in TCG
   - Initial work on SSL wizard

2018-04-27 zzz
 * Tunnels: Fix and consolidate allow-zero-hop logic,
   prevent zero-hop client tunnels when no active peers

2018-04-24 meeh
 * Mac OS X launcher is still WIP, but:
   - Building the I2P.app bundle is mostly done
     - It copies certificates, locale and manuals
     - It copies jar and war files to the bundle
 * Added new entries to mtn-ignore so we avoid any PEBCAK with commiting build directories
 * Added an SBT AutoPlugin named IconHelper to generate valid ICNS images for Mac OS X

2018-04-23 zzz
 * Clock: Fix early NPE via DoH
 * EepGet: Handle HTTP response line with no status text

2018-04-23 meeh
 * Added launchers for Browser Bundle and Mac OS X

2018-04-22 zzz
 * SusiMail: Include attachments when forwarding (ticket #2087)

2018-04-21 zzz
 * SusiMail: Remove Bcc-to-self feature, replace with
   copy-to-sent config (ticket #2087)

2018-04-19 zzz
 * SusiMail:
   - Fix reply/forward filling in compose form
   - Better formatting of addresses in forwarded mail

2018-04-18 zzz
 * SusiMail: Fix unhandled decoding exception

2018-04-17 zzz
 * Console: Fix sidebar status when updating plugin (ticket #2137)
 * Reseed, NTP: Use DNSoverHTTPS (ticket #2201)
 * SusiMail: Fix error message on login page

2018-04-16 zzz
 * Console: Add links to bandwidth graphs on /tunnels
 * SusiMail: Move logging to router logs (ticket #2191)

2018-04-14 zzz
 * Console: Add built-by to /logs (ticket #2204)
 * CPUID: Fix TBM detection (ticket #2211)
 * Debian updates (ticket #2027, PR #15)
 * i2ptunnel: Build restructuring
 * Jetty: Fix quote in header line tripping XSS filter (ticket #2215)
 * SusiMail: Add folders, drafts, background sending (ticket #2087)

2018-04-11 zzz
 * Debian updates for 0.9.34
 * Jetty 9.2.24-v201801015
 * Tomcat 8.5.30

* 2018-04-10 0.9.34 released

2018-04-10 zzz
 * Console: Change Java 9 log warning to Java 10
 * i2psnark: Fix logic error in warning
 * Tunnels: Fix fallback stat name

2018-04-05 zzz
 * EepGet: Increase max header length
 * SSLEepGet: Set default CLI proxy type back to none
 * GeoIP update

2018-04-04 zzz
 * Reseed: Move ReseedBundler from console to router (ticket #2203)

2018-04-03 zzz
 * Stats: Enable per-tunnel bw stats by default (tickets #2106, #2145)

2018-04-02 zzz
 * KeyStore: Fix ConncurrentModificationException (ticket #2196)

2018-03-24 zzz
 * i2psnark: Change default sort order for some columns (ticket #2152)
 * i2ptunnel: Fix display of 'tunnels not initialized' message

2018-03-19 zzz
 * i2ptunnel: Rewrite or pass through Accept: header

2018-03-15 zzz
 * i2psnark: Start even if data directory not found (ticket #2166)

2018-03-14 zzz
 * Console:
   - Hide links to webapps and eepsite if not running (ticket #2161)
   - Hide link to /configplugins if disabled
   - Add error handler to webapps (ticket #2155)
 * i2ptunnel: Hide links to webapps that are not runnning (ticket #2161)
 * SusiDNS: Translate svg image text (ticket #1749)
 * SusiMail: Shorten URLs

2018-03-12 zzz
 * SusiMail: Fix up compose.js (ticket #2176)

2018-03-11 zzz
 * Crypto: Add utils for renewing a cert in a keystore
 * Router: More peer selection fixes for hidden mode

2018-03-10 zzz
 * Console: Fix compression logic
 * i2ptunnel: Strip server Date header
 * NetDB: Wake up FloodfillMonitor when setting changes
 * Router: Fix rekey after hidden config change

2018-03-09 zzz
 * Console:
   - Enable compression (ticket #2157)
   - Close output stream on redirect
   - Add Accept-Ranges header

2018-03-08 zzz
 * Crypto: Generate non-CA cert for family
 * Router:
   - Improved tunnel peer selection of closest hop for routers
     that are hidden, IPv6-only, or have disabled transports
   - Don't select IPv6-only routers for IBGW or OBEP
   - Don't try to build tunnel if adjacent peers aren't compatible
   - Remove ancient version check in peer selectors
   - Check for transport compatibility before direct store of RI;
     send through tunnel if incompatible
   - Fix repeated store of RI when IPv6-only

2018-03-07 zzz
 * Router:
   - Validate tunnel ID in requests
   - Remove ancient version check in BuildRequestor
   - Disable floodfill for IPv6-only and disabled transports

2018-03-05 zzz
 * Util: Consolidate FileFilters

2018-03-04 zzz
 * Console:
   - Show SAM cert on /certs
   - Fix more forms inside tables
 * i2ptunnel: Fix multipart config for /register
 * KeyStore: Log expiration of self-signed certs

2018-03-03 zzz
 * Utils:
   - Skip IPs of down interfaces on Windows
   - Improve identification of temporary IPv6 addresses

2018-02-28 zzz
 * Logs: Fix lost log messages at router shutdown
 * Tools: CLI improvements for Addresses and UPnP
 * Transport: Rescan addresses and UPnP after network reconnection
 * UPnP: IGD IP validation

2018-02-27 zzz
 * UPnP:
   - Improve diagnostics
   - Fix event listening, prep for using events
   - Recognize IGD2 schemas (ticket #2175)
   - Don't use IGD on same host
   - Preliminary work for IPv6

2018-02-25 zzz
 * Crypto: Add support for more alt names in certs (tickets #2159, #2160)

2018-02-24 zzz
 * Console: Mark request handled when rejecting in HostCheckHandler
 * i2psnark standalone: Add DNS rebinding protection
 * XSSFilter: Catch cascaded ISE

2018-02-23 zzz
 * Getopt: Add new translations, fix tests
 * i2psnark: Number formatting tweaks (ticket #1913)
 * SusiMail: Check mail fixes (ticket #2174)

2018-02-22 zzz
 * Util: Support setSoTimeout() for InternalSockets

2018-02-21 zzz
 * Console: Hide options on /configupdate if a package (ticket #2172)
 * SusiMail: Add Date header to sent messages

2018-02-20 zzz
 * Console:
   - Redirect to HTTPS if available (ticket #2160)
   - Change all 302s to 303 or 307
   - Change sendError() to setStatus() for 3xx responses
 * Crypto: Backdate selfsigned cert to allow for clock skew
 * Eepget: Handle 308

2018-02-19 zzz
 * Console:
   - Change trac links (ticket #2014)
   - Change selfsigned cert cname to localhost (ticket #2160)
 * Crypto: Add IP addresses to selfsigned cert SAN (ticket #2160)
 * Streaming: Don't exceed configured tag settings
 * Time: More sanity checks on NTP responses

2018-02-18 zzz
 * i2ptunnel: Retry accept after router soft restart (ticket #2003)

2018-02-17 zzz
 * Console: Number formatting tweaks (ticket #1913)
 * i2psnark: folder.js cleanup (ticket #2168, PR #14)
 * i2ptunnel: Close sockets in finally{}
 * SusiMail: Fix mail save truncation

2018-02-16 zzz
 * i2psnark: Fix NPE on torrent not found (ticket #2167)
 * i2ptunnel: Change POST throttle response to 429
 * Streaming: Configurable response when over conn limits (ticket #2145)

2018-02-12 zzz
 * i2ptunnel: Close sockets
 * Proxy: Update clearnet user-agent (ticket #2163)
 * SusiMail:
   - Background email checking (ticket #2087)
   - Set Cache-Control header for attachments
   - Fix rotated attached images

2018-02-11 zzz
 * Util: Number formatting tweaks (ticket #1913)

2018-02-09 zzz
 * SusiMail:
   - Don't collapse spaces in email display (ticket #2156)
   - Constant URL for attachments
   - Fixes when no subject is present
   - Filename encoding fixes
   - Handle lower case in Q-P decode
   - Don't show the no-charset warning
   - Thread loading mail from disk
   - More error handling fixes

2018-02-08 zzz
 * SusiMail:
   - Error handling fixes
   - More tolerant parsing of Date headers
   - Set a date if we don't get a Date header
   - Fix parsing long Base64 encoded headers
   - Fix page count after changing page size
   - Make attribute name parsing case-insensitive
   - Import mail method for debugging

2018-02-07 zzz
 * SusiMail: Use input streams for reading mail (ticket #2119)
   - Rewrite Base64, HeaderLine, and QuotedPrintable decoders
   - Rewrite ReadBuffer class and utilities for streams
   - ReadBuffer becomes Buffer interface with multiple implementations
   - Rewrite Mail and MailPart to parse the headers only once
   - Rewrite MailPart parser to use streams
   - MailPart decoder rewrite to decode stream-to-stream

2018-02-01 zzz
 * Console: Fix number formatting (tickets #1912, #1913, #2126)
 * i2psnark: URL escape fixes
 * i2ptunnel: Reset connection if out of threads
 * NetDB: Increase min floodfill version
 * SusiMail: Don't duplicate Re: and Fwd: in subject

* 2018-01-30 0.9.33 released

2018-01-26 zzz
 * i2ptunnel: Fix dup tunnels on create
 * Update translations from Transifex

2018-01-25 zzz
 * GeoIP 2018-01-05
 * SusiMail: Close POP3 socket on error

2018-01-24 zzz
 * i2psnark: Prevent commenting without comment name (ticket #2138)
 * SusiMail: Fix header corruption (ticket #2139)

2018-01-19 zzz
 * i2ptunnel: Prevent changing sigtype after dest creation (ticket #2128)

2018-01-18 zzz
 * Build: New poupdate-source target
 * Util: Consolidate console URL generation in PortMapper

2018-01-17 zzz
 * i2ptunnel:
   - Set defaults for limits
   - Change include style for edit jsps

2018-01-16 zzz
 * i2ptunnel: Fix NPE stopping TCG

2018-01-14 zzz
 * Keyring (ticket #2108):
   - Separate local and remote dests on /configkeyring
   - Prohibit local changes on /configkeyring
   - Remove local keys on tunnel shutdown or encryption disable
   - Ensure subsession encryption setting matches primary session

2018-01-13 zzz
 * SessionKeyManager: Clean up sessions with excess tagsets

2018-01-10 zzz
 * Addressbook: Remove finalizers (ticket #2115)
 * /confignet: Display IP even if firewalled (ticket #2133)
 * i2psnark:
   - Fix double-escaping of '&' (ticket #2127)
   - Fix infinite loop stopping update torrent (ticket #2125)
 * jrobin: Disable DeallocationHelper for Java 9
 * /netdb: Note encrypted leasesets

2018-01-09 zzz
 * SusiMail: Rewrite/fix subject line encoding

2018-01-06 zzz
 * Console: Show and set burst bandwidth (ticket #2123)
 * i2ptunnel:
   - Advanced config in/out tunnels separately
   - Better error message on invalid URLs (eepget too) (ticket #2130)
   - Escape chars unescaped by browsers (ticket #2130)

2018-01-04 zzz
 * i2psnark: Fix overflow in ratio sorter (ticket #2129)

2017-12-23 zzz
 * SusiMail:
   - Fix filenames for inline attachments
   - Support RFC 5987/6266 for attachment and save-as filenames
   - Add alt tags for images
   - Fix long encoded lines in headers
   - Fix replacing underscores in Base 64 decoded headers

2017-12-22 zzz
 * SusiMail:
   - Fix bug sending CC recipients as a 2nd To line
   - Separate recipients by commas
   - Workaround on receive side for CC bug
   - Display To and CC lists on show page
   - Case-insensitive handling of all mail headers
   - Escape leading '-' in q-p encoding

2017-12-16 zzz
 * SusiMail:
   - Sorting cleanups and fixes, only sort when required
   - Show result after server check (ticket #2087)

2017-12-15 zzz
 * SusiMail: Don't store state in session object (ticket #1373)

2017-12-14 zzz
 * SusiMail (ticket #1373):
   - Put more parameters in forms and use P-R-G to
     put several parameters into the URLs
   - Redesign sort parameter handling
   - Fix state tracking issues with delete

2017-12-13 zzz
 * i2ptunnel: Add internal sockets for SMTP and POP3 (ticket #2118)
 * Util: InternalSocket improvements

2017-12-11 zzz
 * Jetty: Fix request log showing zero length for static content
 * Startup: Raise open files ulimit (ticket #1967)

2017-12-10 zzz
 * Router: Change RI locking to a read/write lock (ticket #2096)

2017-12-08 zzz
 * SU3File: Flush and sync on extract (ticket #1941)
 * SusiMail:
   - Reference mails by UIDL, not index on page, put UIDL in
     attachment links, remove session object UIDL (ticket #1373)
   - Fix download of attachments without a Content-Transfer-Encoding
   - Fix error return for attachment not found
   - Fix handling of requests for unknown messages
   - Set encoding for text attachments
   - Add more safe mime types for downloading
   - Add tooltips for icon-only buttons

2017-12-07 zzz
 * Console: Don't list aliased tunnels separately on
   /tunnels and /configtunnels
 * i2psnark: Better locking on BitField byte array
 * SusiMail: Recheck max size if SMTP server reports less than default
 * Util: Deprecate BigPipedInputStream

2017-12-05 zzz
 * Console: Fix multipart config for /configplugins
 * SusiMail:
   - Don't store attachments of composed email in-memory (ticket #1668)
   - Fix bug corrupting sent text and text attachments
     larger than about 1000 chars
   - Fix bug corrupting some sent text and text attachments
     containing '.'
   - Fix handling of unimplemented encoders
   - Add test code for encoders
   - Error message improvements
   - Adjust multipart size limits
   - Better handling of errors when multipart limits are exceeded
   - Test for total size limit

2017-12-04 zzz
 * Servlet: Refactor RequestWrapper to use Servlet 3.0 API (ticket #2109)

2017-12-03 zzz
 * i2ptunnel:
   - Don't lose messages on refresh (ticket #2107)
   - New clear messages button
   - Hide message box if none

2017-12-02 zzz
 * i2ptunnel: Propagate resets from streaming to Socket
   and vice versa (ticket #2071)
 * Streaming: Send reset when receiving more data after locally closed,
   rather than acking (ticket #2071)
 * Tests: Fix up deprecation warnings

2017-12-01 zzz
 * Build: Split net.i2p.router.web into two packages
 * Console: Move /configkeyring HTML to console, fix deletion,
   don't truncate hashes, better form errors, tag for translation (ticket #2108)
 * LeaseSet: Better error messages when decode fails (ticket #2108)
 * Streaming: Double the RTO on congestion (ticket #1939)

2017-11-27 zzz
 * Debian: Exclude gradle, IntelliJ, Docker, .tx, gcj files from source tarballs

2017-11-27 str4d
 * Build: Add Gradle build scripts for compiling the codebase and generating
   IDE project files.

2017-11-26 zzz
 * Build: Add xenial build option
 * Console: Safer processing of changes on /configadvanced
 * Context: Hopefully fix rare NPE on Android (ticket #2092)

2017-11-25 zzz
 * Console:
   - Show full logger.config path on /configlogging
   - Don't say 'Plugin downloaded' when installing from file
 * Debian:
   - Replace glassfish-javaee with libtaglibs-standard-* (ticket #2093)
   - Remove libecj-java dependency (ticket #2094)

2017-11-23 zzz
 * i2ptunnel: Add timeout to header reads for CONNECT, HTTP, and SOCKS clients
 * Wrapper 3.5.34

2017-11-22 zzz
 * i2psnark: Fix nbsp in logs on config change (ticket #2082)
 * Streaming: Fix bug causing loopback hangs and
   preventing desired ack behavior (ticket #1939)
 * Tomcat 8.5.23

2017-11-21 zzz
 * EepGet: Refuse attempted redirect to HTTPS, won't work
 * Reseed: Add support for reseeding via outproxy or Orchid (ticket #1841)

2017-11-20 zzz
 * HTTP Proxy: Better HTTP status message when no outproxy configured
 * i2prouter: Fix echo -n on OSX
 * Reseed: Add outproxy and Orchid proxy support (ticket #1841)

2017-11-19 zzz
 * Debian:
   - Fix builds for x32 (ticket #2076)
   - Incorporate patches 2 and 3 into build scripts
 * DTG: On OSX, set dock icon, and enable by default

2017-11-18 zzz
 * Reseed:
   - Add SOCKS proxy support (ticket #1130)
   - Show proxy info, if applicable, in logs
   - Show status in summary bar for manual reseed (previously hidden if more than 30 routers)
   - Show status in summary bar after successul completion
   - Show reseed button in summary bar if less than 50 known RIs (previously 30)
   - Show current status on /configreseed if already running
   - Consolidate proxy settings detection in ReseedRunner constructor
   - Enhance help text on /configreseed (tickets #423, #1130)

2017-11-17 zzz
 * Addressbook: Fix adding alternates after importing an empty book (ticket #2072)
 * Reseed: Add HTTPS proxy support (ticket #423)
 * SOCKS: Move code from i2ptunnel to core, in prep for SSLEepGet use (ticket #1130)

2017-11-16 zzz
 * Console: Hide Reseed HTTP proxy options if no HTTP URLs (ticket #2007)
 * i2psnark: Fix bad completion status after recheck (ticket #2046)
 * Jetty 9.2.22

2017-11-07 zzz
 * Utils: Constant-time password check

* 2017-11-07 0.9.32 released

2017-11-03 zzz
 * Update translations, add Indonesian as selection
 * GeoIP update

2017-11-03 str4d
 * Console:
   - /graphs:
     - Reorganised config form
     - Fixed "hide legends" option
   - Sidebar: limit event logs to last 7 days, to avoid page freezes
   - Fix scrolling latency issue light theme in Chrome/blink and older Firefox
     versions (ticket #2024)
   - Various cosmetic tweaks, fixes and enhancements
 * I2PSnark:
   - Reduce scrolling and hover latency
   - Add sort direction hover indicators to .snarkTorrents header icons
     (dark/midnight)
   - Various cosmetic tweaks, fixes and enhancements
 * Susimail/SusiDNS:
   - Various cosmetic tweaks, fixes and enhancements

2017-11-02 str4d
 * Console:
   - Sidebar:
     - Fix erratic display of sidebar graph
     - Add id to memory bar so we can target it for Chrome/blink display issue
 * I2PSnark:
   - Roll back target="_top" in config page to prevent embedded view from
     breaking out of iframe
   - Add target="_blank" to relevant links to avoid display in iframe in
     embedded mode
   - Enhance presentation of tracker links in TorrentInfo view

2017-10-31 str4d
 * I2PSnark: Use reflection to access ConfigUIHelper in standalone build

2017-10-25 str4d
 * Console:
   - /graphs:
     - Add option to hide legends
     - Adjust size of up/down bw graph to match other graphs (ticket #1996)
     - Modify image font color to better blend with themes
     - Tweak spacing of elements for non-Debian installs
   - Sidebar:
     - Adjust vertical spacing of general section
     - Rename 'General' section to 'Router Info' and move ident info to h3
       tooltip (ticket #1996)
     - Replace 'Short Router Info' with a new 'Advanced Router Info' section in
       default advanced sidebar (adds memory usage and clock skew)
     - Add optional embedded bandwidth graph (experimental)
     - Add optional memory usage bar
     - Add optional Advanced Peers section (adds failing and banned peers)
     - Add Help link to 'I2P Internals' section
     - Add help page anchored links and troubleshooting to 'Help & FAQ' section
     - Add download progress bar for router and plugin updates
     - Add 'Advanced Minimal' sidebar configuration
     - Add Jobs and Events links to Advanced section
     - Add additional reachability states for clockskew and vmcomm (with icons)
   - Homepage: Add 'Customize Sidebar' link to signpost the feature now that
     there are more optional sections available (ticket #1996)
   - /configui:
     - Add option to embed Susimail and I2PSnark in console
     - Use larger flags for language selection
   - /help:
     - Update sidebar help section (en)
     - Remove redundant CSS class from all help section files (li.tidylist)
   - /tunnels:
     - Indicate that no participating tunnels will be built when shared bw is too low
     - Replace <a name> with id attribute for anchor links
   - light:
     - Lighten/tint buttons and dropdowns to better blend with reworked theme,
       vary text color for different button states
     - Increase vertical spacing for status/buttons in news section
     - Fix minor rendering issue with h1's (remove bottom border-radius)
     - Fix some mismatched heading coloring issues
     - Fix alignment issue on /configservice in Arabic/Chinese (ticket #2024)
     - Ensure spacing of sidebar elements is consistent in Chinese
   - dark: Overhaul theme
   - classic: Add fallback CSS to ensure browsers without CSS3 support can
     display icons on buttons (tested with Netsurf)
 * Proxy: Remove truncation of URLs in the error messages and handle with CSS to
   avoid UI breakage
 * I2PTunnel: Add hostname / destination (b32) information to server section on
   index page (for parity with client tunnels section)
 * I2PSnark
   - Fix broken collapsible panels issue for browsers that don't support the
     feature by conditionally loading override CSS to expand panels by default
     and disable hover/active states for panel headings (tickets #2002, #2026)
   - Add UI option to configuration section to enable collapsible panels, and
     disable the option if a non-compliant browser is detected
   - Fix multiple instances of snark refreshing to the homepage (ticket #2028)
     (patch supplied by mindless)
   - Tentative fix for caching of images so ajax refresh doesn't reload all
     image resources
   - Standardize 'Save Configuration' action to return to top of the page
     (so we can see message log entry)
   - Add button hoverstate for tracker details, torrent details and file icons
   - light
     - Sync buttons in embedded mode with console theme
     - Fix non-functioning message log close icon
   - dark: Overhaul theme and sync with console theme in embedded mode
   - classic: refresh CSS
 * SusiDNS:
   - Reinstate filter removal on addressbook navigation links (ticket #1996)
   - Reduce vertical padding for filter buttons section
   - Migrate search section to div and reposition page elements to better
     integrate with host list and minimize whitespace
 * Susimail:
   - Overhaul dark theme
   - Sync theme to console theme by default, override if user sets theme
     (unless universal themeing is enabled)

2017-10-24 zzz
 * NTCP: Convert configured NTCP hostname to IP address
   before publishing (proposal #141)

2017-10-21 zzz
 * UDP: Reduce log level on IP change (ticket #2053)

2017-10-11 zzz
 * Console: Validate host header (thx Kevin Froman)
 * Router: Honor IPv6 setting when converting configured hostnames
   to IP addresses (proposal #141)

2017-10-04 zzz
 * Router: Convert configured hostnames to IP addresses
   before publishing (proposal #141)

2017-09-29 zzz
 * Debian: Backport fixes from 0.9.30-4 package (ticket #2027)

2017-09-14 zzz
 * Router: Don't lookup hostnames in addresses (proposal #141)

2017-09-12 str4d
 * Core: New benchmarking framework based on JMH (ticket #2036)

2017-09-02 zzz
 * Data: Prohibit excess key data in certs (ticket #2035)
 * i2psnark: New open trackers
 * Startup: Add property to disable output redirect (ticket #2037)

2017-08-26 str4d
 * Console (light):
   - Sidebar Restart/Shutdown buttons:
     - Increase width to better occupy available space and increase width of
       containing form to ensure browser scaling doesn't wrap buttons
     - Reduce vertical padding
     - Reduce height of buttons in console_big.css
   - /debug:
     - Multi-column view for Session Key Manager expiry IDs
     - Fix color mismatch of inbound/outbound h3s
 * I2PSnark (ubergine):
   - Fix hover state for inert section headings
   - Minor adjustments to DHT debug section
 * Susimail (light): Minor adjustment of notifications in embedded view

* 2017-08-07 0.9.31 released

2017-07-31 zzz
 * Translations update, Debian patch refresh

2017-07-31 str4d
 * Console: fix router family page form (ticket #2022)

2017-07-30 str4d
 * Console
   - light theme:
     - Fix spacing issue with banned peers list
     - Tweak font sizes for Arabic
   - Shrink icons in sidepanel network status span
   - Add single graph view buttons to classic theme
   - Better separation of graphing controls in single graph view
   - Enhance presentation of /oldconsole and /proof

2017-07-28 str4d
 * Console:
   - Enhance presentation of show/hide news links on home page
   - Fix some issues with Arabic CSS (light/dark)
   - Further tweaks to graphs display and fixes for borderless single graphs
     in midnight/dark themes
   - Fix minor coloring issues with light theme post-rework
   - Misc theme fixes
 * I2PSnark:
   - Move </center> tag in fileinfo view that prevented sticky navbar from
     working
   - ubergine:
     - Alternative panel tabs for embedded view
     - Tighten .snarkTorrents thead/tfoot spacing
     - Tweak embedded navbar coloring
     - Reduce height of download bars

2017-07-26 str4d
 * Themes:
   - 'light' theme (console & apps):
     - Rework to reduce contrast (ticket #1996)
     - Add custom radio/checkbox icons for Chrome/Blink
 * Console:
   - Add JavaScript snippet to reset dest address scroll position onblur (fixes
     Chrome/Blink disappearing text bugs in i2ptunnel and susidns)
   - Fix reseed failure notice overlap when "check connection" message shown
   - Enhance presentation of console "error 500" messages
   - Cosmetic tweaks to welcome page presentation, arabic welcome page tidyup
   - Migrate .smallhead th class to tr to simplify markup
   - Sidebar:
     - Remove "Congestion" from default sidebar (still present in default
       advanced sidebar)
     - Fix label wrapping issue with translations
     - Migrate sidepanel news section to tables to permit better control over
       wrapping and placement (ticket #1996)
     - Move news item dates to tooltips to lessen chance of headlines wrapping
       and cleanup presentation
     - Increase maximum length of local tunnel links in the sidebar (and handle
       overflow with CSS) to minimize chance of default tunnels display
       truncating in translations
     - Add the power off icon to sidebar restart button on hover to clarify
       button function (ticket #1996)
   - /configadvanced: Move floodfill status to row above to remove unnecessary
     whitespace and cleanup UI
   - /debug:
     - Add container divs and styling markup
     - Add top navigation menu
     - Add debug icon to h2 headers to aid navigation
   - /graphs: Improve presentation of graph images by removing rendered border
     and setting background color to better integrate with themes
   - /home: Widen div.app to lessen chance of truncation (classic/midnight)
   - /jars:
     - JARs, WARs & individual plugins separated with headers
     - Filenames stripped of path info (path indicated on headers and tooltips)
     - Add container divs and styling markup
     - Minimize table overflow with conditional scaling of content
     - One-click select for revision, sha256 & unsigned mods
   - /logs:
     - Reduce line/entry spacing for router and critical logs (#ticket 1996)
     - Multi-column view for changelog at >=1400px to address horizontal
       whitespace issue
   - /netdb:
     - Multi-column display of Leases in LeaseSet tables
     - Better alignment of Lease elements, iconify gateway
     - Placeholder flag for unknown/unresolved peers for [flag+dest] combos to
       improve presentation / fix deadspace issue
   - Chinese:
     - Fix alignment of table contents in /tunnels (classic)
     - Fix sidebar content display width (midnight)
     - Cosmetic fixes (all themes)
 * I2PSnark:
   - Mitigate truncation of ratings dropdown in comments section (translations)
   - light: Reduce contrast of display text
   - light/classic: Increase contrast of download bars
   - Create Torrent trackers table: Replace "Tracker URL" with "Tracker Type"
     (ticket #1996)
   - Add a persistent warning to the messagelog when JavaScript is disabled to
     indicate potential loss of form data upon refresh (ticket #1996)
   - Migrate "view or change bandwidth" to [Configure] tooltip to standardize
     configuration links, allow for more space for option labels and lessen
     chance of option labels wrapping in translations
 * I2PTunnel:
   - Ensure message log font scales proportionately
   - Fix overflow issue with dropdowns in Chrome/blink (dark/midnight)
 * SusiDNS
   - Reduce width of filter buttons to lessen chance of wrapping (ticket #1996)
   - Add non-selectable items to improve copy/paste of hosts in address books
   - Make dest addresses in host list only display scrollbar on focus to reduce
     screen clutter
   - Hide broken imagegen images
 * SusiMail:
   - Dismiss notifications on click
   - Enhance presentation of 'postman' links on login panel

2017-07-25 str4d
 * Console: Move JRobin default color and font changes into SummaryRenderer

2017-07-16 zzz
 * Imagegen: Test page text fixups

2017-07-15 zzz
 * Console: Fix compile error with Jetty 9.2.22 (ticket #2019)

2017-07-13 zzz
 * Crypto: Preserve CRT parameters for RSA private keys (ticket #2005)
 * Various fixes after review

2017-07-11 str4d
 * Console:
   - Increase displayed changelog lines to help ensure at least one whole
     release cycle is visible
   - /tunnels: Fix display issue with inbound/outbound glyph display in table
     header (classic/light)
   - light: Prevent routerlogs from causing horizontal page overflow
 * I2PSnark:
   - Fix I2PSnarkUtil.getCommentsName() to match its JavaDoc
   - Reduce size of screenlog font at 1400-1600px viewport width to lessen
     chance of text-wrapping (ticket #1996)
   - classic: Fix a linespacing issue in the config section (options:) that only
     triggers in foreign languages that force the options labels to wrap
 * Fix HTML tags across non-default conditional branches

2017-07-08 zzz
 * GeoIP, blocklist, translations update

2017-07-06 str4d
 * Console:
   - /configlogging: Fix log file size config bug (ticket #1996)
   - /logs: Correctly format unavailable crypto warnings (ticket #1996)
   - Show advanced sidebar links by default in advanced mode (ticket #1996)

2017-07-02 str4d
 * Console:
   - Show correct icon for "Firewalled" network status
   - Cosmetic changes to new firewalled network status in sidebar
   - Arabic: ensure the destinations correctly align on /tunnels
 * SusiDNS: Default to the console theme
 * I2PSnark: Ensure .snarkNoneLoaded background color remains constant on
   mouseover in dark theme

2017-07-01 str4d
 * Console:
   - /netdb:
     - All Routers/Leasesets/Sybil sections:
       - Each transport instance on own line
       - Better presentation of address characteristics
       - Place flag in table header
     - Container div for leasesets to allow responsive 2 column display
     - Increased spacing of lease information in leaseset tables
     - Add div for "not initialized" message
     - Reorganize content in sybil db to reduce horizontal whitespace:
       - Conditional 2-column display of sybil families
       - Multi-column view for sybil router characteristics & threatpoints
       - Empty (n/a) fields to maintain visual consistency in column view
   - /tunnels:
     - Tag "Local" for translation (and convert to lowercase in CSS)
     - Arabic: ensure our tunnel tables display correctly
 * I2PSnark:
   - Fix unclosed <label>
   - Standalone:
     - Better target the per-theme and imported console resources
     - List all available themes in config section
   - Themes: tidyups & further optimizations to reduce lag

2017-07-01 zzz
 * Fix family key export (ticket #2011)

2017-06-19 str4d
 * Console:
   - Welcome page readmes:
     - Responsive 2 column layout for eepsite section
     - Minor formatting corrections
     - Ensure urls in Arabic display correctly
     - Fix commenting out of forum.i2p where it impacts surrounding text
     - Cleanup unneeded CSS classes
     - Enhance Chinese legibility
   - Add untagged strings for /tunnels tooltips and local tunnel indicator
     (to be tagged for translation post .31 release)
   - classic: reduce color contrast of main display font
   - classic/dark/midnight: alignment on /peers and /tunnels
   - /tunnels:
     - Add bandwidth tiers definitions
     - Indicator for local tunnels
   - /profiles:
     - Split capabilities and version
     - Minimize wrapping at narrow viewport width
     - Iconify view profile link
     - Add "OK" status indication for functional peers
   - /peers: merge Dir and CWND rows in definitions table
   - /events: when no events found, place result in table
   - All themes: marginally increased width of sidebar to better accommodate
     extra long strings
   - Chinese: ensure buttons do not deviate in height (ticket #1996)
   - Arabic: fix alignment issues on /configui; presentational enhancements
   - Misc: remove erroneous tags
 * i2ptunnel: consistent tooltips and Destinations for editClient and editServer
 * I2PSnark:
   - Disable JavaScript td:onclick (handled by css)
   - Fix minimode bug in vanilla/ubergine
   - Minimode for dark/classic
   - ubergine:
     - Further optimizations to reduce lag/cpu load
     - New hidpi details.png to bypass mix-blend mode in .snarkTorrents
   - Usability:
     - Tab navigation now works for toggle panels
     - Touch target for configure button now extends entire length
   - All themes: cleanups and optimizations

2017-06-15 zzz
 * Data: Cache hostname lookups in RouterAddress (ticket #1998)
 * Job Queue: Make search jobs droppable (ticket #1998)
 * Router: Increase JVM DNS cache time (ticket #1998)
 * Util: Add negative DNS lookup cache, increase cache size (ticket #1998)

2017-06-12 str4d
 * Console:
   - /logs: fixed environment/running info table resize on hover (ticket #1996)
   - Scale theme/language divs so we don't truncate language display
   - Arabic (light) adjust font size for sidebar elements
   - Sidebar network status display (ticket #1996)
   - Usability:
     - Enhance presentation of tables on /peers (header/column alignment,
       center to separator for multi-value rows)
     - Enhance presentation of tables on /tunnels (reliable alignment of mixed
       content in rows, more prominence to bandwidth tiers)
   - /netdb: Fix UI bug with unpublished LeaseSets
 * I2PSnark:
   - Usability: add tabindex="0" to screenlog
   - Update navbar link classes to allow easier targetting of button type
   - Remove disabled cursor for known tracker radio icons (ticket #1996)
   - Fix alignment issue for comments (ticket #1996)
   - ubergine: further optimize theme to reduce scroll lag (ticket #1996)
   - ubergine/vanilla:
     - Add mini-mode at <=800px
     - Small size reduction to navbar links (ticket #1996)
 * Imagegen: Theme tweaks

2017-06-05 str4d
 * Add state classes to network status messages in sidebar
 * Switch light theme to the same top-nav style as the other themes

2017-06-04 str4d
 * De-duplicate strings for translation
 * Minor theme tweaks and bugfixes
 * SusiDNS: Update SVG image to use grouped objects for styling and hotlinks
 * Hardcode language names in their native language (to make them easier for
   users to identify)

2017-06-03 str4d
 * Console:
   - Add spans to /stats page to avoid summary info breaking mid-sentence, and
     to aid presentation
   - Adjust /stats CSS so information isn't over-dense
   - Set graph size for generated graphs on /stats to 600x200
   - Fix netdb leaseset tables
     - Ensure we only iconify add to addressbook links and not b32 dests
   - Individual icons for I2PSnark and I2P Plugins on /home
   - Add div to upnpstatus on peers to comply with layout
   - Fix various unclosed/erroneous tags
 * SusiDNS:
   - Rework SVG image
     - Now features interactive feedback when mouseover objects and hotlinks
   - Update fallback images for en and fr
   - Update overview text
   - added tabindex="0" to destination addresses, highlighted on :focus
 * i2psnark:
   - Reorder .snarkCommentInfo sections so my rating / average rating is located
     directly above posted comments/ratings in .snarkComments
   - If author name for comments is configured, display it in .snarkCommentInfo
     table header
   - Full status tooltips for status icons in .snarkTorrents
   - Rework td/th classes for .snarkTorrents so each column (both th + td) now
     belongs to a given class
   - Stop .snarkTorrentStatus class being incorrectly applied to .peerinfo
     columns
   - Spans for DHT peers / Dest in #totals, .snarkTorrentInfo info hash
   - Delete icon for delete comments td
   - Overhaul .snarkTorrents column widths
   - CSS tidyups
 * Compress some of the larger image files by 40-60%
 * UI feedback:
   * Console:
     - Increase contrast of table rows on profile/tunnels/peers tables
     - Changed pink font to magenta in /logs to increase legibility
     - Soften H3 headings in sidebar
     - Single click to select I2P Version and Running Environment table text,
       with table:hover color change and text cursor to better reflect selection
       - Modify text above to indicate what exactly needs to be included in logs
     - Reduce size of monospace dests in peers/profiles/tunnels, add additional
       spacing (responsive)
     - Fix resizing of sidebar reseed button
     - De-emphasise sidebar app icons with background-blend-mode: luminosity
     - Change sidebar snark icon to match homepage icon
     - Bump div.main text color from #222 to #333 (reduce contrast)
     - (light, dark, midnight) fix minor alignment issues with Arabic CSS
     - JRobin (graphs):
       - Fix font size issue for non-title text on graphs
       - Optimise layout (tweaked padding, legend box size etc)
       - Tweak graph lines (now dotted, slightly less opaque)
   * i2ptunnel:
     - Remove redundant labels and spans for keyaccess
     - Edit Server:
       - Shift Local Destination / Private Key file to share table row
       - Move "Use SSL to connect to target" to Target Port column
     - Add translation tagging for title tags
     - Remove redundant title tags and provide enhanced strings for features
       that benefit from clarification
     - Move title tags to <label> where applicable
     - Fixed Cancel button on registration so it now jumps back to the list page
     - textareas for registration page and local destination on edit server page
       changed to divs
       - Scrollbars hidden until mouseover, 1 click to select content
       - Responsive width, tabindex="0"
     - Fix overflow issue on select dropdowns (edit server/client -> tunnel
       options) in Chrome / Blink
     - More generous vertical padding for th (responsive)
     - Larger h2/h3s (responsive)
     - Increase spacing between panels in iframe mode
   * SusiDNS: Change address helper icon to add book icon
   * i2psnark:
     - Remove font-adjust-size (ubergine/vanilla)
     - Add extra spacing to screenlogger bullets (ubergine)
     - (ubergine) speed up tr:hover events by optimizing css (remove latency)
     - (all) remove fade activation delay for download bars, speed up fade-in /
       fade-out
     - Fix i2psnark link in navbar overflow issue in Arabic (ubergine/vanilla)
     - (ubergine) change default font for screenlog from Noto Mono to Droid Sans
       Mono to soften text/slightly reduce text size

2017-05-25 zzz
 * Crypto: Fix AES NPE on 4-core RPi 2nd try (ticket #1989)

2017-05-24 zzz
 * GeoIP: Fix NPE

2017-05-21 zzz
 * i2psnark: Fix bencoded scrape response for zzzot (ticket #1994)

2017-05-21 str4d
 * i2psnark: Integrate ratings and comments into themes

2017-05-20 str4d
 * Console:
   - Clarify choices on address helper save page (ticket #1940)
   - Add router.hideFloodfillParticipant to advanced settings help
 * i2psnark:
   - Make DHT debug section collapsible
   - Tooltips for downloading/finished torrents
   - Download bars for torrents, torrent parts and peer downloads
   - Friendlier date format (with completed: <date> tooltip for finished torrents)

2017-05-19 zzz
 * Console: Move /peers page rendering from router to console (ticket #1879)
 * i2psnark: Add ut_comment UI and per-torrent configuration

2017-05-18 str4d
Prop from i2p.i2p.str4d.ui:
 * Backend HTML changes to routerconsole and apps:
   - IDs, classes and <span>s for styling
   - <label>s to extend touch targets
   - Table layouts where it makes sense
   - Tooltips
   - Move most of the hard-coded styles to CSS
 * Overhaul all themes:
   - Responsive layouts
   - Standardisation of UI elements, configuration labels, etc.
   - Consistent layouts, spacing, font sizes, etc.
   - Routerconsole themes now present for all bundled plugins
   - HiDPI images
   - Accessibility and localisation improvements
   - Testing on a wide array of browsers and screen sizes
 * Console:
   - /home:
     - Move console links above hidden service links
     - Link are now full touch button targets
     - Add tabindex ="-1" to icon links
   - Sidebar:
     - Include bandwidth in minimal sidebar
     - Optional Advanced section
   - /graphs:
     - Graph image updates
       - Improve contrast
       - Custom fonts with fallback
       - Left-align legend
       - Thinner restart and graph lines for clarity
       - Separate legend and display period date
       - Text tidyups
     - Tweak layout and text of configuration options
     - Default width to 400px to avoid info truncation
     - 15s and 30s refresh options
   - /help:
     - Collate help topics from various routerconsole pages
     - Document various router.config settings
     - Add mini-FAQ
   - /peers: CSS sort buttons, with new icons to avoid conflation of
     tunnel direction and sort direction
   - /profiles: Add definitions for capabilities
   - Limit file inputs to accepted extensions
   - Fix bug in /configui lang selector when not in advanced mode
 * i2psnark:
   - Collapsible "Add Torrent" and "Create Torrent" sections
   - Disable theme selector when "universal theming" enabled
   - Debug info styling
   - <noscript> fallbacks:
     - Use meta-refresh
     - Hide JavaScript-dependent buttons
 * SusiDNS:
   - Disable spellcheck on config editor
   - Additional column on hostname list page for helper address with icon, and
     iconfication of b32 addresses
   - Add minified identicon to hostname column
   - Consolidation of Hostname/host name/name referenced: now all "Hostname"

2017-05-14 zzz
 * Crypto: Fix AES NPE on 4-core RPi (ticket #1989)
 * i2psnark: Fix HTML double-escape (ticket #1992)
 * Router: New method to get bandwidth class

2017-05-12 zzz
 * i2psnark: Better handling of read-only i2psnark dir (ticket #1990)

2017-05-10 zzz
 * Debian: Fix apparmor profile (ticket #1986)
 * SusiDNS: Fix display of default subscription

2017-05-05 zzz
 * Blockfile: Move from i2p.jar to addressbook.jar
 * i2psnark: Initial support for ut_comment, no UI yet
 * Jetty: New default servlet for eepsite, with
   locale-independent directory listing (ticket #1965)

* 2017-05-03 0.9.30 released

2017-04-30 zzz
 * Jetty: Rollover log files at midnight, not noon

2017-04-29 zzz
 * Build: Fix failing release tests
 * Jetty:
   - Revert previous checkin, unrelated to the Jetty Timer bug
   - Add patch to fix Jetty Timer bug, backported from Jetty 9.4
 * Translations update

2017-04-27 zzz
 * Console: Disable Jetty timer thread consolidation
   causing log file rollover to stop (ticket #1068)

2017-04-26 zzz
 * HTTP Proxy: Add delay before jump page

2017-04-14 zzz
 * SSU:
   - Reuse previous introducer expiration if available,
     so we don't force a republish
   - Don't run peer test if configured to force firewalled

2017-04-13 zzz
 * SSU: Publish introducer expiration (proposal 133)

2017-04-06 zzz
 * Debian: Add bash-completion scripts

2017-04-04 zzz
 * Router: Fix config dir location in Gentoo

2017-04-02 zzz
 * Context: Fix ClientAppManagerImpl in AppContext
 * i2psnark: Fix standalone configuration for Jetty 9

2017-04-01 zzz
 * Console: Fix stopping of webapps when console stops (ticket #1893)
 * i2psnark: Only rewrite torrent config file if changed (ticket #1893)
 * KeyStoreUtil: Reduce log level of expired cert error
 * Util: Don't sync config writes on Android/ARM (ticket #1893)

2017-03-31 zzz
 * SSU:
   - When a IPv6 peer connects, trigger a IPv6 peer test, not a IPv4 one
   - Require two consecutive peer test results for some state transitions,
     to prevent frequent transitions to firewalled and back

2017-03-29 zzz
 * SSU: Refactor PeerTestEvent out of UDPTransport
 * Throttle: Reduce threshold for probabalistic throttling
   on slow platforms (ticket #1964)

2017-03-27 zzz
 * Blockfile: Include authentication strings in exports
 * Build: Suppress JarScanner warning during Debian build (ticket #1975)
 * Debian: Add missing addressbook.jar to package (ticket #1973)
 * SusiDNS: Add addressbook.jar to classpath, don't fail
   to start if it's still not found (ticket #1973)
 * Time: Fix crashes on old Androids (ticket #1976)

2017-03-25 zzz
 * Blockfile: Upgrade to Blockfile format 4 on non-Android ARM
 * i2ptunnel: Allow alt priv key file to be added without restarting I2P

2017-03-24 zzz
 * Addressbook: Remove static reference, hide implementation
 * CPUID: Recognize Ryzen

2017-03-23 zzz
 * Plugins:
   - Blacklist i2pbote and BwSchedule
   - Translate exceptions thrown from PluginStarter
   - Add version number to console messages when installing/starting

2017-03-21 zzz
 * i2psnark: Enhancement to support RPC plugin
 * Context: New ClientAppManagerImpl in AppContext, so registration works

2017-03-20 zzz
 * i2psnark: Enhancements to support RPC plugin
 * SSU: More work on introducer expiration (proposal 133)

2017-03-18 zzz
 * Addressbook (ticket #1966):
   - Build as jar, not war
   - Put empty war in updater
   - Move Servlet starter to SusiDNS
   - Skip war in RouterConsoleRunner

2017-03-14 zzz
 * Blockfile: Fix specified-destination deletion from the correct book
 * i2ptunnel:
   - New form to enter private key file for alternate destination
   - Use alt destination for registration if set
 * NBI: Adjust info logging at startup
 * SusiDNS:
   - New button for adding alternate destination
   - Fix nonces on details page with multiple destinations
   - Fix single dest deletion on details page with multiple destinations
   - Set book in all forms to ensure correct book

2017-03-13 zzz
 * i2ptunnel:
   - Add subsession support to servers
   - Reset I2P socket on TCP socket errors
 * SAM: Reset I2P socket on handler errors
 * Streaming: Add reset() to I2PSocket API

2017-03-11 zzz
Prop from i2p.i2p.zzz.jetty9:
 * Console: Fix RouterConsoleRunner for Jetty 9
 * Debian packages:
   - Remove libjetty8-java and ant-optional dependencies
   - Add libjetty9-java and libtomcat8-java dependencies
     Fixes stretch/sid package (ticket #1902)
   - Fix up build files for package builds
 * Eepsite: Update initial configuration files for Jetty 9
 * Jetty:
   - Update to Jetty 9.2.21.v20170120 and Tomcat 8.0.33 (tickets #1512, #1935)
     Fixes jsp compilation on Java 9 (ticket #1870)
     Fixes InstanceManager warning (ticket #1818)
     We now support servlet API 3.1, JSP API 2.3, and EL API 3.0.
     Breaks the following plugins: bwschedule, i2pbote, i2pcontrol, zzzot
 * Startup: Add migration code for eepsite Jetty 8 configuration files

2017-03-09 zzz
 * i2psnark: Prevent RuntimeException caused by corrupt i2psnark.dht.dat file
 * Router: Set default sig type to EdDSA for non-Android ARM
 * Streaming: Don't change buffer size when max message size is adjusted

2017-03-06 zzz
 * CPUID:
   - Fix saving of libjcpuid.jnifile on Macs,
     was incorrectly saving as libjcpuid.so (tickets #1865, #1900)
   - Try to load libjcpuid-x86_64-osx.jnilib for 32-bit Macs,
     because as of 0.9.26 it's a 'fat binary' with 32-bit in it also.
   - Add library search path logging to main()
 * NBI:
   - Try to load the "none" architecture for x86, even if
     CPUID loading fails (tickets #1865, #1900)
   - Add library search path logging to main()
 * Throttle: Fix disable of probabalistic throttling
   (ticket #1963) (thx mysterious)

2017-03-03 zzz
 * Utils: Fix crash in Windows installer

2017-03-02 zzz
 * SSU:
   - Initial work on introducer expiration (proposal 133)
   - Fix bug in error handling for introduction parameters in RI

2017-03-01 zzz
 * Servlet: Catch OOM in MultiPartRequest

2017-02-27 zzz
 * i2psnark: Fix disappearing start button
 * addressbook: Add date parameter to authentication strings

* 2017-02-27 0.9.29 released

2017-02-27 zzz
 * i2ptunnel: Fix generation of advanced authentication strings

2017-02-23 zzz
 * HostTxtParser: Add -q command line option, enhance return codes
 * PrivateKeyFile: Add option to generate addressbook authentication

2017-02-20 zzz
 * GeoIP and blocklist update

2017-02-15 zzz
 * Build: Fix calls to Class.newInstance() deprecated in Java 9
 * I2CP: Return null on decompression failure instead of
   throwing exception (ticket #1915)
 * Utils: Disable caching of ResettableGZIPOutputStreams,
   add more checks for compression failure,
   fix output for zero-length input (ticket #1915)

2017-02-10 zzz
 * Test: Add random delays and drops to LocalClientManager

2017-02-09 zzz
 * Streaming: Fix optional delay and choking (tickets #1046, #1939)

2017-02-08 zzz
 * I2CP: Return local delivery failure on queue overflow (ticket #1939)

2017-02-05 zzz
 * Console: Consolidate timer threads (ticket #1068)
 * NTCP: Don't write to an inbound connection before
   fully established, causing NPE (ticket #996)
 * Streaming:
   - Don't always send optional delay (ticket #1046)
   - Don't hard fail on expired message error (ticket #1748)

2017-02-04 zzz
 * HTTP proxies:
   - Pass through relative referer URIs, convert same-origin
     absolute referer URIs to relative (ticket #1862)
 * NTP: Enable IPv6 support (ticket #1896)

2017-01-30 zzz
 * Router: Run shutdown tasks in parallel,
   increase max time for shutdown tasks (ticket #1893)
   i2psnark: Remove most delay between announces at shutdown

2017-01-29 zzz
 * i2ptunnel CONNECT proxy:
   - Add support for outproxy plugin (tickets #1364, #1895)
   - Add support for ports

2017-01-28 zzz
 * Utils: Detect when running as service on Gentoo

2017-01-26 zzz
 * Build: Set up translations for man pages
 * Javadoc: Fixes (ticket #1894)

2017-01-24 zzz
 * i2prouter: Add root check to restart and condrestart (ticket #1770)

2017-01-17 zzz
 * Utils: Java 9 yakkety workarounds

2017-01-12 zzz
 * DTG: Don't try to start if headless (ticket #1924)

2017-01-07 zzz
 * i2ptunnel: Fix NPE on proxy.i2p/add when no params

2017-01-06 zzz
 * EepGet: Recognize more status codes

2017-01-04 zzz
 * Crypto: Enforce correct seed and hash lengths in EdDSAPrivateKeySpec
 * Data: No longer sort addresses in an RI by SHA256
 * Router: Replace random tunnel keys when rekeying

2016-12-24 zzz
 * Utils: Add RKG command line tool

2016-12-23 zzz
 * Console: Add Referrer-Policy header

2016-12-22 zzz
 * Blocklist:
   - More efficiently check blocklist when receiving new RI
   - Check blocklist when loading RIs
   - Ensure blocklist is initialized before netdb
 * Clock: Fix duplicate notification of clock shift listeners
 * Console: Limit age of news entries displayed
 * Update: Fix JVM crash and i2p.jar corruption when updating from -1

2016-12-21 zzz
 * NTP:
   - Verify source address and port
   - Add to command line
   - Add KoD support (ticket #1897)
   - Add initial IPv6 support (ticket #1896)

2016-12-20 zzz
 * Build: Fix installer compile failure

2016-12-16 zzz
 * Router: Synchronize graceful exit code access
 * Update: Save blocklist version in UpdateManager

2016-12-16 zzz
Prop from i2p.i2p.zzz.test2:
 * BOB:
   - Refactor NamedDB implementation to HashMap
   - Refactor NamedDB locks to ReentrantReadWriteLock
   - All unlocks in finally blocks, remove redundant unlocking
   - Remove throw declaration from methods that don't
   - Read under write lock when that's simpler
   - Use Boolean fields rather than valueOf()
   - Fix unlock order inversion in I2PtoTCP and MUXlisten
   - Remove unused locking in TCPtoI2P
   - Add missing locking in status command
   - Remove redundant locking
   - Remove unnecessary catch-and-rethrows
   - Spelling fix in error message
   - Make some methods static
 * Console: Sort banlist and floodfills in true binary order, not by base64 string
 * Utils:
   - Consolidate stream copy code
   - Consolidate base64 alphabet string

* 2016-12-12 0.9.28 released

2016-12-09 zzz
 * Translation updates

2016-12-06 zzz
 * GeoIP: Update from Maxmind 2016-12-06

2016-12-05 zzz
 * Router:
   - Revert default family sig type back to ECDSA
   - Update blocklist

2016-12-02 zzz
 * Cleanup: Single char indexOf()
 * Console: Version the css links

2016-12-01 zzz
 * NetDb: Peer selection tweaks

2016-11-27 zzz
 * NetDb:
   - Add same-port check in peer selector
   - Add MTU, SSU caps, IPv6 prefix, and cost lookups

2016-11-26 zzz
 * NetDb:
   - Add advanced lookup form
   - Add port and sig type lookups
   - Fix /16 and /8 lookup
   - Fix tab highlighted for all lookups
   - Add sybil points for banlist

2016-11-25 zzz
 * SU3File: Add types for blocklist (proposal #130)

2016-11-24 zzz
 * Sybil tool enhancements
 * Blocklist feed tweaks

2016-11-23 zzz
 * Console: Support RI lookup by caps or IP
 * NetDB: Penalize new and slow peers
 * News: Add command line utility support
 * Router: Support blocklist in the news feed (proposal #129)

2016-11-21 zzz
 * NetDB: Fix detection of bandwidth class with multiple values specified

2016-11-20 zzz
 * NetDB: When doing lookups, don't use floodfills too close
 * Router: Change default family sig type to EdDSA

2016-11-17 zzz
 * Build: Add attributes for java version to all jars and wars
 * Blocklist: Add support for IPv6 in blocklist.txt
 * Console: Add netdb lookup by family
 * NetDB: When verifying store, don't use floodfills too close
 * Tomcat 6.0.48

2016-11-16 zzz
 * Console: Remove dead home page links (ticket #1882)
 * Profiles: Pull same-IP detection into a utility class
 * Router: Add methods to verify and track members of our family

2016-11-15 zzz
 * Certs: Add Let's Encrypt ISRG Root X1 cert

2016-11-14 zzz
 * Logs: Fix output of dup message after 30 minutes

2016-11-13 zzz
 * Console: Add initial news to bottom of news page (ticket #1153)
 * i2psnark: Periodically save DHT nodes (ticket #1328)
 * UPnP:
   - Prevent exception on bad HTTP header (ticket #1480)
   - Prevent NPE on socket creation fail (tickets #728, #1681)

2016-11-12 zzz
 * Console:
   - Fix inadvertent config save when clicking sidebar
     buttons on /configstats
   - Add IPv6 firewalled setting on /confignet
 * I2CP: Reduce error level on session closed while signing LS (ticket #1606)
 * JRobin: Move DeallocationHelper logging from wrapper log to router log
 * Profiles: Periodically save, delete old ones after saving (ticket #1328)
 * Susimail:
   - Add logout button to more pages (ticket #1374)
   - Fix nonce error on login after logout
   - Fix internal error after cancel button on settings form when not logged in

2016-11-11 zzz
 * Build: Truncate history.txt bundled in installers

2016-11-10 zzz
 * Transport: Use NTCP for some outbound connections even before
   SSU minimums are met (ticket #1835)

2016-11-09 zzz
 * Transport: Add stats for inbound v4/v6 connections (ticket #1854)
 * Tunnels: Reduce default VTBM records from 5 to 4

2016-11-08 zzz
 * Build: Fix minimum Java version for Windows
 * Install: Add max memory option to runplain.sh
 * Crypto: Change serial number in selfsigned certs from int to long
 * Router: Fix low-memory log messages for non-wrapper (ticket #1795)
 * Transport: Improve IPv6 address selection logic

2016-11-06 zzz
 * Console: Add Java 9 log warning (ticket #1870)
 * Security: Consistently log authentication failures for all interfaces
 * Util: Consolidate linux service detection code

2016-11-05 zzz
 * Build: Add support for using libtomcat8-java package
 * Console: Add message to ignore InstanceManager warning (ticket #1818)
 * SusiDNS: Fix jsp EL syntax error with EL 3.0 (Tomcat 8) (ticket #1870)

2016-11-04 zzz
 * Console: Improve handling and logging of webapps that fail to start
 * i2psnark: Add launch-i2psnark.bat (ticket #1871)
 * Transports:
   - New config i2np.allowLocal, fixes test networks (ticket #1875)
   - New configs i2np.udp.minpeers and i2np.udp.minv6peers, for testing (ticket #1876)

2016-10-29 zzz
 * Console: Java 9 fixes for classloader (ticket #1870)

2016-10-28 zzz
 * Build: Fix typo in jcpuid build.sh for Mac (ticket #1865)
 * Crypto:
   - Generate more-conforming selfsigned certs (ticket #1853)
   - Remove deprecated Sha256Standalone as scheduled
 * Utils:
   - Fix Java version detection for Java 9 (ticket #1870)
   - Add Addresses methods for multiple DNS results (ticket #1050)

2016-10-26 zzz
 * Build: Mac jbigi/jcpuid improvements and docs (ticket #1865)
 * JRobin 1.6.0-1
 * Systray: Remove old 32-bit Windows implementation, replaced by DTG

2016-10-25 zzz
 * i2psnark: Better calculation of total upload limit
 * SSU: Increase max IPv6 MTU (proposal #127)
 * Zxing 3.3.0

2016-10-23 zzz
 * Crypto: Create keystore directory when making SSL keys (ticket #1866)

2016-10-22 zzz
 * Build: Fix jbigi build in Arch Linux and others for Java 8 (ticket #1863)
 * Console:
   - New Korean translation
   - New Chinese (Taiwan) translations for susidns, susimail, debian
   - New initial news translations: Czech, Greek
 * Jetty 8.1.21.v20160908

2016-10-21 zzz
 * Console:
   - New Galician translation
   - Remove calls to deprecated two-arg setStatus()
 * Crypto: Actually use a random nonzero byte in ElGamal
 * Data: Cache serialized leasesets on floodfills
 * NetDB: Disallow RSA for RI or LS
 * Tomcat 6.0.47
 * Utils: Add MTU to command line utils
 * Wrapper 3.5.30

2016-10-20 zzz
 * Build: Add library jars to i2p.jar classpath for Debian builds
 * Console: Fix HTML error on /configservice
 * Debian: Update package descriptions, allow Java 9
 * i2psnark: Add ids to rows, add to per-torrent show peers link
 * SSU: Fix minimum version check for IPv6 peer test (tickets #1829, #1861)

* 2016-10-17 0.9.27 released

2016-10-16 zzz
 * Fix test for IPv6 firewalled configuration

2016-10-14 zzz
 * Translations: Update from Transifex

2016-10-10 zzz
 * Debian: Don't use glassfish-javaee.jar for jstl.jar (ticket #1793)

2016-10-06 zzz
 * GeoIP: Update from Maxmind 2016-10-04

2016-10-02 zzz
 * Crypto: Add EdDSA private key spec constructor for hash
 * i2psnark: Add standalone shutdown method
 * i2ptunnel: Registration page layout fixes
 * SusiMail:
   - Show settings button even if no messages
   - Add nonce to forms (thx Kevin Froman)

2016-09-24 zzz
 * DesktopGUI: Enable by default on Windows
 * i2ptunnel:
   - Don't accept default 'mysite.i2p' as a valid spoof host
   - Don't wrap destination in status message box
 * Reseed: Remove user.mx24.eu as requested
 * Utils: Move SipHashInline from util to crypto

2016-09-22 zzz
 * Crypto: Don't NPE in encoding when field not set
 * DataHelper: Fix read() for nonzero offset
 * i2ptunnel: Whitelist IRC AWAY inbound

2016-08-21 zzz
 * Console: Add jsps to view entire router.log and wrapper.log files

2016-08-19 zzz
 * CPUID: Add IDs for Kaby Lake
 * JettyStart: Fix main()
 * Router: Fix return code in getShutdownTimeRemaining()
 * Tunnels:
   - Enable tunnel testing when in hidden mode (ticket #1192)
   - Enable tunnel testing when without addresses (ticket #1835)
   - Use fast peers for inbound tunnels when without addresses (ticket #1835)

2016-08-14 zzz
 * i2ptunnel:
   - Register actual listen host with port mapper
   - Register POP and SMTP ports with port mapper
 * Reseed: Add new 'atomike' reseed

2016-08-12 zzz
 * i2ptunnel:
   - Add outproxy plugin support to SOCKS (ticket #1824)
   - Use preferred sigtype for new SOCKS tunnels

2016-08-09 zzz
 * Console: Fix UPnP NPE on /peers (ticket #1830)

2016-08-02 zzz
 * i2psnark: Fix SIOOBE on bad announce URL (ticket #1823)
 * SSU: Fix peer test stuck when IPv6-only (ticket #1819)
 * Streaming: Fix debug NPE (ticket #1821)

2016-07-20 zzz
 * SSU:
   - Increase minimum peers if we have a IPv6 address
   - Check for 'B' cap for peer test
   - Fix peer test IP length check

2016-07-18 zzz
 * i2ptunnel: Block 'Proxy' header
 * SU3File: Also look in config dir for signer certificate

2016-07-16 zzz
 * I2CP Client: Handle disconnect properly if received before first LS
 * Streaming: Kill accept() when session disconnects

2016-06-25 zzz
 * SSU peer testing: Add IPv6 implementation (ticket #1752; proposal #126)
 * Utils: Improve random seed initialization

2016-06-22 zzz
 * SSU peer testing:
   - Forget the test and don't keep retransmitting to Charlie
     if we receive the Bob reply after the 2nd Charlie reply
   - Only fire a peer test on connection if address has changed

2016-06-16 zzz
 * Console: Split up configclients, add configi2cp,
   configplugins, configwebapps (ticket #1804)

2016-06-15 zzz
 * Utils: Add method to set language in standalone app context
 * i2psnark:
   - Add form to set language in standalone context
   - Add Ukrainian and Japanese translations

2016-06-11 zzz
Prop from i2p.i2p.zzz.test2:
 * CPUID: Add CLI output for new AMD tests
 * i2psnark standalone (ticket #1191):
   - Cherry-pick fixes from psi's github i2psnark_rpc branch
   - Fix up Jetty XML file for Jetty 8
   - Start with JettyStart
   - Add UrlLauncher to launch browser
   - Fix up paths in CSS files during build
   - Force startup delay to 0
   - Fix theme selection
   - Adjust CSS and image paths
   - Add shutdown hook to delete temp dir
 * i2ptunnel CLI: Don't set the listen host to the I2CP host
 * jbigi:
   - Fix GMP version reporting for shared library (ticket #1800)
   - mbuild-all script fixes
 * NetDB: Improve handling of deferred search result jobs

* 2016-06-07 0.9.26 released

2016-06-03 zzz
 * Update translations from Transifex

2016-06-01 zzz
 * Build: Fix Debian build on ARM (ticket #1801)

2016-05-29 zzz
 * Console: Fix /configfamily form (ticket #1797)

2016-05-29 str4d
 * CertUtil: Dynamically load javax.naming classes to avoid
   VerifyErrors on some Androids
 * LogWriter: Dynamically load Android writer

2016-05-26 zzz
 * Build: Launchpad build fixes

2016-05-25 zzz
 * DesktopGui: Add monochrome icons for Windows and Mac
 * Reseed:
   - Require two sources minimum (ticket #1794)
   - Update list of sources requiring SNI
 * Translations: Update English po files

2016-05-22 str4d
 * I2CP: Dynamically load Android domain socket code

2016-05-20 zzz
 * DesktopGui:
   - Fix systray menu redraw on Mac;
   - Switch to AWT by default on Mac;
   - Hide DTG enable on Mac until we fix dock

2016-05-19 zzz
 * Config files, eepsite help: Add path information for OS X
   and Windows as a service. (ticket #1495)

2016-05-12 zzz
 * NTP:
   - Don't put random data in zeroed fields
   - Increase random data in originate timestamp from 1 byte to 2 bytes
   - Verify originate timestamp to prevent injection
   - Verify received packet size
 * SSU:
   - If configured with a hostname, bind to all v4/v6
     addresses found for that hostname.
   - Fix binding if more than one IP or host was configured.

2016-05-09 zzz
 * Console:
   - Fix escaping of search URLs on /confighome
   - Fix HTML error on /configui
 * DesktopGui: Add 9 new translations
 * i2psnark: Limit cases when we display tracker errors;
   include host name of tracker when we do

2016-05-08 zzz
 * Console: Fix UTF-8 passwords, partial fix for usernames

2016-05-07 zzz
 * Build:
   - Add DTG to updater
   - Fix and bundle DTG license info
   - Remove jstl.jar and standard.jar from updater,
     last changed in 0.9
   - Fix bundling of Tomcat license info
   - Add back the old way to build bundles for gettext < 0.19
 * Console:
   - Change to new DTG constructor
   - Don't attempt to start systray or DTG when running as a service
   - Show systray controls for all OSes on /configservice
   - Implement backend for systray control
 * DesktopGui:
   - Implement second TrayManager menu implementation in Swing.
   - Use Swing except on Windows
   - Hide restart menu items if no wrapper
   - Add graceful restart and shutdown menu items
   - Add basic adjustment of menu based on shutdown state
   - Disable wrapper notification for now
   - Remove Swing DesktopguiConfigurationFrame,
     move to a submenu.
   - Remove LookAndFeel setting
   - Make Main class a RouterApp
   - Remove all static log, context, and instance fields
   - Remove unused ConfigurationManager class
   - Translate tooltip, disable tooltip on linux
   - Use safer exec call to start i2p
   - Remove all images, use itoopie
   - Don't start spinner thread in router context
   - Handle various startup errors better
   - Synchs, finals, javadocs, cleanups

2016-05-04 zzz
 * i2prouter: Set JAVA_HOME correctly on Mac OS X 10.5 and later (ticket #1783)
 * Utils: Fix bug in periodic timers triggered by
   a backwards clock shift, caused graphs to be blank
   and various router, streaming, and i2ptunnel
   degradations over time (tickets #1702, #1776)
 * Wrapper: Update to wrapper 3.5.29, except for Windows.
   Fixes wrapper failure on FreeBSD 10 (ticket #1118)

2016-05-01 zzz
 * Build: Compile resource bundles from ant, not msgfmt,
   speeding up builds with translations by 20x
 * Debian: Back out libhttpclient-java dependency,
   requires 4.4 which is too recent for most distros

2016-04-30 zzz
 * Blocklist: Add RFC 6598 addresses
 * Console:
   - Only display cpuid information on x86
   - Readme page link fixes (tickets #1789, #1790)
 * Data: Fix NPE calculating the hash of a RI of unknown sig type
 * Debian:
   - Add runtime dependency on libhttpclient-java,
     link to /usr/share/java/httpclient.jar and httpcore.jar
 * Eepsite: comment out gzip filtering in cgi context,
   causes hung threads, root cause unknown
 * Router: Reduce log level of RI sig failure
 * SAM: Log tweaks (ticket #1778)

2016-04-29 zzz
 * Debian:
   - Add runtime dependency on gettext-base,
     link to /usr/share/java/libintl.jar
   - Add runtime dependency on libgetopt-java,
     link to /usr/share/java/gnu-getopt.jar
 * SysTray:
   - Remove systray4j.jar from linux installers
   - Move SysTray.java to SysTrayImpl.java
   - New SysTray.java that instantiates SysTrayImpl
     by reflection, so the SysTrayImpl.java source is optional
   - Remove systray4j.jar, systray4j.dll, and SysTrayImpl.java
     from Debian source packages
   - Remove systray4j.jar from Debian binary packages
 * Update: Enable libjbigi update for ARM

2016-04-28 zzz
 * News: Parse and store CRLs in news feed

2016-04-28 zzz
Prop from i2p.i2p.zzz.gmp6-prop:
 * CPUID:
   - Added source of CPUID information
   - Made CPUIDCPUInfo non-abstract to support looking for
     CPU features during CPU identification
   - Add support for extended feature registers EBX/ECX
   - No such thing as EBX for 0x80000001 call; remove getExtendedEBXCPUFlags(),
     replaced with getExtendedEBXFeatureFlags()
   - Check for support of 6 required Core i3/i5/i7 instructions to enable Haswell,
     since GMP Haswell requires Core i3/i5/i7 support.
     There are Pentium/Celeron Haswells that do not support these instructions.
   - Added AVX, AVX2, AVX512, TBM, ADX, BMI1, BMI2, MOVBE, FMA3 feature detection
   - More diagnostic output in CPUID.main()
   - More javadocs
   - Only call getCPUVendorID() once in getInfo()
   - Recognize Skylake
   - Do the same checks for Broadwell and Skylake that we do for
     Haswell, and check ADX as well, which will be used in GMP 6.1
 * Crypto:
   - Use constant time modPow() for signing and decryption
   - Use native modInverse()
 * libjbigi:
   - Added nativeJbigiVersion(), nativeGMPMajorVersion(),
     nativeGMPMinorVersion(), nativeGMPPatchVersion(),
     nativeModInverse(), nativeModPowCT()
   - Support negative vaules in conversion functions
   - Support negative base value in modPow()
   - Throw ArithmeticException for bad arguments rather than crashing
   - New build targets
   - Drop 32-bit corei libs where they are identical to the
     core2 lib, since we now have a generic fallback in NBI:
     libjbigi-freebsd-corei.so, libjbigi-linux-corei.so,
     libjbigi-osx-corei.jnilib
   - Revamped downloading of gmp files
   - Revamped cross-compilation support
   - Added 'osx' alias for darwin
   - Added FreeBSD cross-compilation instructions
   - Removed NetBSD, kFreeBSD, Solaris, OpenBSD binaries
   - Added coreihwl, coreisbr, bulldozer, steamroller,
     cortex a9, and cortex a15 support
   - Rebuilt all binaries with GMP 6.0.0a
 * libjcpuid:
   - Add nativeJcpuidVersion()
   - Clear ECX register to ensure it will work with EAX=7
   - Added jcpuid build instructions for linux/osx/freebsd/windows
   - Improved build script
   - Imported Microsoft Visual Studio Community 2015 project files.
   - Fixed OSX include search path
   - Rebuilt all binaries
 * NativeBigInteger:
   - Version reporting
   - Total redesign of fallback code
   - core2 is always a fallback for corei, and
     core2_64 is always a fallback for corei_64
   - Remove special case for core2/corei in getMiddleName2()
     since it's now a fallback in getResourceList()
   - Added support for new CPUs:
     Intel Sandy Bridge, Haswell and Broadwell;
     AMD Bulldozer, Piledriver, Steamroller, Excavator and Jaguar;
     ARM Cortex A5/A7/A8/A9/A15; ARM A12/A17 using the A15 libs
   - Test improvements:
     Output versions; Only warmup crypto once;
     Add -n option to test native only;
     Reduce output if only native or only Java tested;
     Try to prevent not-coprime errors

2016-04-26 zzz
 * Addressbook:
   - Finish implementation of signed actions
   - Move HostTxtEntry to net.i2p.client.naming for use by i2ptunnel
   - Add tests for Daemon to read local subscription file
   - Store last-modified date
   - Logging cleanups and consolidation
 * Blockfile: Remove unused code and classes
 * BlockfileNamingService:
   - Implementation and fixes for new API methods
   - Add support for long property values, backward compatbile, no version bump
 * DataHelper: Properties methods cleanup
 * i2ptunnel:
   - New page for registration authentication
   - Remove old, unused hostname signature generation
 * NamingService: Add new API methods for reverseLookupAll()
 * PrivateKeyFile:
   - Add InputStream constructor for i2ptunnel
   - Ensure initialization before returning private keys
 * SusiDNS:
   - Display signature validation on details page
   - Add support for multiple dests per hostname

2016-04-20 zzz
 * Addressbook:
   - Add sign/verify methods for inner signature
   - Add preliminary handling of incoming actions
 * Blockfile:
   - Add generics
   - Add method to change serialization schema for a skiplist
   - Fix delIndex() method
 * BlockfileNamingService:
   - New database version 4, for multiple destinations per hostname
   - Disallow database version higher than supported
 * NamingService: Add new API methods for multiple Destinations per hostname

2016-04-17 zzz
 * Addressbook:
   - Several cleanups and refactoring
   - Add initial support for signatures in subscriptions
   - Fix main-class in addressbook.jar
   - Fix corrupted manifest in addressbook.jar
 * Build: Fix broken build from scratch in jetty build.xml
 * Console:
   - Add JSTL version to /logs
   - Update version warnings
   - Add OpenJDK check for ARM
 * PrivateKeyFile: Add method to specify sig type on creation
 * SingleFileNamingService: Store signature properties on write
 * TunnelId: Add max value check

2016-04-13 zzz
 * SOCKS: Fix NPE on lookup failure in SOCKS 4a

2016-04-07 zzz
 * Debian builds:
   - Prep for depending on tomcat packages
   - Minor fixes

2016-04-04 zzz
 * Debian builds:
   - Depend on glassfish-javaee for JSTL 1.2 by default

2016-04-03 zzz
 * Debian builds:
   - Add build options to depend on various packages
   - Depend on geoip-database and libjetty8-java by default
   - Add debian-alt directory with configurations for alternate series
   - Prep for depending on additional packages
   - Improvements in ant debian build targets
 * Transport:
   - Add library to read standard Maxmind geoip database format
   - Use system Maxmind geoip files if available

* 2016-03-22 0.9.25 released

2016-03-14 zzz
 * Console: Replace pastethis with zerobin
 * Peer selection: Don't truncate data used for random slice
 * Router: Fix corner cases maintaining local leasesets (ticket #1768)
 * Susimail: Fix NPE
 * UPnP: Fix NPE in HTML output on /peers (ticket #1779)

2016-03-01 zzz
 * i2psnark: Fix handling of HAVE messages received before metainfo
 * i2ptunnel: Don't default to a private key file that exists (ticket #1628)
 * NetDb:
   - Search for new leaseset before expiration;
   - Reduce expiration for router infos with introducers
   - Add missing reseed cert
 * SSU: Switch introducers less often

2016-02-26 zzz
 * Console:
   - Add X-Content-Type-Options header everywhere (ticket #1763)
   - Don't display error after clicking restart on /graph page (ticket #1582)
 * i2ptunnel:
   - Fix default shouldBundleReplyInfo for non-HTTP servers
   - Fix display of hostname signature
   - Add QR code generation
 * Router: Log full path to wrapper.log when dumping threads
 * Transports: Increase connection limits for class N and higher
 * Utils: Add main classes to i2p.jar and router.jar
   for simple command line access to utilities

2016-02-22 zzz
 * Console: Improve news CSS (ticket #1710)
 * Crypto: Blacklist certificates by SHA1 hash, not by serial/CN/OU
 * I2CP: Improve client error message when internal router connection fails
 * Graphs: Increase font size
 * Transports: Increase default max inbound bandwidth,
   increase minimum in/out bandwidths

2016-02-19 zzz
 * Clock: Add sanity checks to detect invalid system clock

2016-02-18 zzz
 * Console: Clean up display and form handling
   for specifying a fixed host name or IP on /confignet
 * Crypto: Add utilities for loading CRLs from disk;
   check for revocation when reading in certificates
 * Transport:
   - Implement mayDisconnect() for outbound connections also,
     use when publishing RI directly to floodfill
   - Run SSU idle disconnect check faster if floodfill or near connection limit
 * NetDB: Fix bug publishing router info too often

2016-02-17 zzz
 * i2psnark: Increase max files per torrent to 2000
 * I2PTunnel: Improve layout of blacklist radio buttons
 * Router: Switch to new lease sooner before expiration
 * SAM: Don't log an error on datagram send success

2016-02-13 zzz
 * I2PTunnel:
   - Add options to block by referer and user-agent
   - Log blocked destinations in b32, not b64
 * Imagegen: Add text to QR codes

2016-02-10 zzz
 * Crypto: Use new internal key generation instead of calling
   out to keytool; save CRL for new su3 amd family keys

2016-02-09 zzz
 * Crypto: Fix raw (su3) signing, broken in test2 prop (-2)

2016-02-08 zzz
 * BOB: Fix invalid output after getnick (ticket #1204)
 * SAM v3.3:
   - Add support for MASTER sessions
   - Add support for per-packet optins SEND_TAGS, TAG_THRESHOLD, EXPIRES, and SEND_LEASESET
   - Refactoring and cleanups
   - Client test enhancements
   - Fix bug receiving datagrams on v3 sessions with UTF-8 session IDs

2016-02-03 zzz
Prop from i2p.i2p.zzz.test2:
 * Build: More checks in release target
 * Console:
   - New /configfamily for export/import and setup (ticket #1510)
   - Custom icons for non-webapp plugins (ticket #1550)
   - Add secure.thethinhat.i2p to console home page and hosts.txt
 * Crypto:
   - Implement EdDSA key encoding and decoding (ticket #1723, github issue #13)
   - Fix I2P crypto provider and add it
   - Specify I2P provider in keytool arguments when necessary
   - Add EdDSA key generator support to provider
   - Synch fix in EdDSA (github issue #10)
   - Add hashCode() and equals() everywhere it was missing in EdDSA
   - Put unknown class name in EdDSA exceptions
   - Implement one-shot methods in EdDSA so we don't copy
     the data if all the data is available (ticket #1750)
   - Fix API violation if EdDSA signing object is reused (ticket #1750)
   - Add ElGamal classes, from Bouncy Castle 1.53, for provider
   - Implement Java ElGamal keys built on the BC classes
   - Add KeyFactory and KeyPairGenerator for ElGamal
   - Add ElGamal signature implementation, to be reviewed
   - KeyGenerator: Check that dsax is greater than zero
   - SHA256Generator: Don't fall back to Sha256Standalone,
     SHA-256 support must now be in the JRE.
     Deprecate all uses of Sha256Standalone, schedule for removal.
     This will require a new Syndie release.
   - New utils to support private key import/export
   - Add support for CRL generation and export
   - Consolidate PEM encoding
   - Improve ASN.1 signature encoding/decoding utilities
   - New selfsigned key and cert generator,
     to be hooked in to KeyStoreUtil to replace keytool.
   - Add EdDSA_SHA512_Ed25519ph sig type
   - Add OIDs to sig types
 * I2PTunnel: Fix exception message choice that was backwards
   for router/non-router context
 * Jetty: Add gzip filter to eepsite Jetty (new installs only)
 * Random: Don't bother trying to seed from /dev/urandom on Windows
 * Router: Make network ID configurable
 * Utils: New ArraySet implementation

2016-02-01 zzz
 * Imagegen:
   - Return 403 if no code specified in QR or RA
   - Mode parameter for html or text in RA
   - Set RA text-mode character encoding
   - Fix up test page

2016-02-01 zzz
Prop from i2p.i2p.zzz.imagegen:
 * Console:
   - New imagegen webapp, including servlets for identicons, QR codes,
     and random art. Bundles a small part of zxing, most of identicon,
     and a rewrite of randomart from gnutls (ticket #1652)
   - Add identicons to sybil page.
 * i2ptunnel: Add identicons to i2ptunnel address helper conflict page.
     Clean up text on the conflict page for readability.
 * SusiDNS:
   - Display QR and identicon images on details page
   - Fix title whitespace

* 2016-01-27 0.9.24 released

2016-01-27 zzz
 * SocksHeader: Fix arraycopy argument order
 * SSU: Fix minimum version for extended options

2016-01-20 zzz
 * SusiDNS: Replace image (ticket #1301)

2016-01-17 zzz
 * BuildHandler: Disable tunnel removal on next-hop timeout
 * Console:
   - Fix mime type for svg in themes directory
   - Add zh_TW translation
 * Fortuna: Add getByte() method
 * i2psnark: add opendocument mime types
 * i2ptunnel: Remove unused stats
 * Utils: Move CachedIteratorArrayList from core to router

2016-01-13 zzz
 * BuildHandler: More early-disconnect cases
 * Family: Add i2p-dev cert

2016-01-10 zzz
 * Tunnels: Fix build request Bloom filter (ticket #1746)

2016-01-07 zzz
 * Console: Fixed summary bar overflow (ticket #1739)

2016-01-06 zzz
 * Build: Remove big geoip files from release again
 * Console: Properly register listen hosts with PortMapper
 * DataHelper: Optimize checks in storeProps()
 * I2PTunnel: Fixup console links in error pages if console is
   on a non-standard host or port, or on https
 * Jetty: Change default source logging from b64 to b32.
   To change back to b64, add the following to the RequestLogImpl
   section of jetty.xml: <Set name="b64">true</Set>
 * NetDB: Don't query floodfills if they are too old to
   support sig types or encrypted replies (ticket #1742)
 * PortMapper: Add method to convert wildcard host to actual host

2015-12-21 zzz
 * SSU: Hand all messages pending after establishment to the
   outbound queue at once, for efficiency.
   Don't sort outbound messages by size, keep priority order instead.

2015-12-20 zzz
 * BuildHandler: Additional fixes (ticket #1738)
 * CertUtil: Add methods to export private keys
 * Console: Sybil tool enhancements
 * Transports:
   - Disconnect faster when first message is a
     tunnel build request which we reject
   - Display SSU sent/received messages, not packets,
     on /peers to be consistent with NTCP

2015-12-18 zzz
 * BuildHandler: Fix NPE (ticket #1738)

2015-12-16 zzz
 * Profiles:
   - Don't use same family in a tunnel
   - Reduce IPv6 mask from 8 to 6

2015-12-13 zzz
 * Data: Optimize router info writes, disable caching

2015-12-12 zzz
 * Router:
   - Add family public key to router info (ticket #1510)
   - More deadlock prevention (ticket #1722)

2015-12-11 zzz
 * Logs: Windows line ending fixes
 * Router:
   - Fix family verification, partially hook into netdb store()
   - Limit wait for NTP to 45 seconds (ticket #1725)
   - Increase lookup cache max sizes,
     reduce max lookup depth, and increase non-floodfill profile bonus
     to attempt to reduce load on floodfills
   - Don't let context clock shifts affect calculated uptime
 * Transport: More deadlock prevention (ticket #1722)
 * SSU: Fix outbound IPv6 errors on Windows without a real v6 address
   when explict host is set. Validate addresses before confirming that
   we have an IPv6 address. Possibly related to ticket #1538.
 * Wrapper: Listen for Windows Service shutdown events to stop router

2015-12-10 zzz
 * Router:
   - Change addCapabilities() to getCapabilities()
   - Add netdb family sign/verify utility (ticket #1510)
 * RouterInfo:
   - Remove addCapability() and delCapability()
 * StatPublisher:
   - Remove Service interface, not required
   - Consolidate getCapabilities() and network ID here
   - Add family signatures

2015-12-08 str4d
 * Core: Fill in basic datastructure length tests
 * Ministreaming: Add unit tests
 * Streaming:
   - Add more unit tests
   - Separate out integration tests

2015-12-08 zzz
 * Crypto: Consolidate certificate import methods

2015-12-06 zzz
 * Console: Don't force profile creation when loading floodfill tab
 * Installer: Add wrapper deadlock detection to default wrapper.config
 * NetDb: Stub out a "family" indicator (ticket #1510)
 * Profiles: More changes to reduce memory usage
 * Startup: Increase rekey probability
 * Sybil tool: Tweaks and enhancements

2015-12-04 zzz
 * Console: Fix NPE on /profiles
 * Profiles:
   - Fix first heard about to be earliest, undeprecate
   - Fixup first heard about at profile readin
   - Persist good/bad lookup/store DBHistory stats added in 0.7.8
   - Remove unused DBHistory methods and fields to save memory
   - Change bonus longs to ints to save memory
   - Extend profile expiration time from 3 days to 15
   - Consolidate getLong()
   - Synch fixes
 * Sybil tool: Tweaks and enhancements

2015-12-03 zzz
 * Console: Add experimental Sybil analysis tool
 * NetDb: Fix deadlock (ticket #1722)

2015-12-01 zzz
 * i2psnark:
   - Consolidate default tunnel length definition
   - Increase max peers and uploaders per torrent
   - Increase default max total uploaders
   - Increase max peers sent and returned in DHT
 * SAM:
   - Don't map keys to upper case in parser, corrupts I2CP options
   - Register SSL and UDP ports with PortMapper
 * SSU: Allow IP and port in relay request if it matches the source
 * Transport: Interrupt DH refiller thread when pool is empty,
   to speed refilling and reduce pumper stalls

2015-11-30 zzz
 * SAM:
   - Timeout for first command after HELLO
   - Send error message if no NAME key in LOOKUP
   - Destination caching enhancements
   - Client: Add SSL forward support, handle header line in forwarded stream

2015-11-29 zzz
 * i2ptunnel:
   - Change preferred sig type to Ed
   - Set permissions on backup tunnel keys file

2015-11-28 zzz
 * i2psnark:
   - Fix NPE caused by URL-to-URI conversion in -2 (ticket #1715)
   - Increase max pieces to 32K
   - BEP 21 support (upload_only)
 * SAM:
   - Fix parser to allow spaces in quoted values (tickets #1325, #1488)
   - Handle UTF-8 in ReadLine (ticket #1488)
   - 3.2 complete (ticket #1574)

2015-11-27 zzz
 * SAM:
   - Use DataHelper to load/store sam.keys
   - Move sam.keys to config dir (ticket #677)

2015-11-27 zzz
Prop from i2p.i2p.zzz.sam:
 * PasswordManager: new methods for use by SAM
 * SAM:
   - Use getopt for SAM args processing
   - Change default host from 0.0.0.0 to 127.0.0.1
   - Add SSL support with -s option (ticket #1106)
   - Add -c configfile option, default sam.config
   - Add protocol and port notification (ticket #1323)
   - Add authorization options in HELLO (ticket #1106)
   - Add AUTH commands: ENABLE, DISABLE, ADD, REMOVE
   - Add PING, PONG commands (tickets #1572, #1573)
   - Add QUIT, STOP, EXIT commands
   - Add SSL option for STREAM FORWARD
   - Move DatagramServer from SAMv3Handler to its own file
   - Make DatagramServer a Handler, register with bridge
   - Use ReadLine with timeout for SAMHandlerFactory
   - Support parallel STREAM ACCEPTs
   - Add HEADER option for RAW forwarding
   - Better exception handling
   - Extensive enhancements to Java client for testing
   - Bump version to 3.2 (ticket #1574)
 * Streaming: Fix recognition of PoisonPacket in ConnectionHandler

2015-11-22 zzz
Prop from i2p.i2p.zzz.test2:
 * Build:
   - More release checks
   - Add systray dependency tracking to build
   - Remove commons-logging classes from commons-logging.jar (ticket #1679)
 * Lint:
   - Replace URL with URI where possible
   - Don't use DataHelper.fromLong() for 1-byte reads, for efficiency
   - Don't catch Exception, catch RuntimeException or checked exception.
 * i2psnark:
   - Minor details page reformatting
   - Add skipped length on details page
 * NewsManager: Make it a ClientApp, not a RouterApp
 * Profiles: Don't allow creation of our own profile
 * Router: Revert JobTiming being a clock shift listener, not needed
 * SSU:
   - Support extended options
   - Add support for requesting a relay tag via
     Session Request extended options (tickets #1465, #1656)
 * Tunnels:
   - Locking fixes
   - Don't set stats in our own profile
   - Minor optimizations
 * Utils:
   - Centralize time zone code in DataHelper
   - Add caching string split()

2015-11-21 zzz
  * Console: Fix escaping of plugin description on /configclients (ticket #1711)

* 2015-11-19 0.9.23 released

2015-11-19 str4d
  * build.xml: Stop building SUD and SU2 update files in "ant release" (ticket #1709)

2015-11-15 kytv
 * Updates to geoip.txt and geoipv6.dat.gz based on Maxmind GeoLite Country
   database from 2015-11-03.
 * Translation updates

2015-11-13 zab
 * Interrupt() when cancelling scheduled tasks (tickets #1694, #1705)

2015-11-13 zzz
 * Console: Fix lifetime participating bandwidth display (ticket #1706)

2015-11-12 zzz
 * Console /configclients:
   = Fix filtering and escaping
   - Fix autostart setting on new client, was inverted

2015-11-11 zzz
 * i2psnark:
   - Change log level to hide socket closed error at tunnel shutdown (ticket #1687)
   - Increase max pieces
 * Timers: State fix 4th try (tickets #1694, #1705)

2015-11-05 zzz
 * I2CP: Fix additional connections getting rejected during tunnel open (tickets #1650, #1698)
 * Streaming: Split blacklist into one for EC and one for Ed

2015-11-04 zzz
 * Threads: More conversions to I2PAppThread
 * Timers: Improve OutboundMessageRegistry locking (ticket #1694)

2015-11-02 z3r0fox
 * EepGet: Fix command line filename selection (ticket #1616)

2015-11-01 zzz
 * Utils: Double IP lookup cache size (ticket #1700)

2015-10-31 zzz
 * Convert remaining Threads to I2PThread or I2PAppThread
 * UPnP: Fix deadlock in callbacks (ticket #1699)

2015-10-30 zzz
 * Router: Fix cascading I2CP error (ticket #1692)

2015-10-21 zzz
 * i2psnark: More consistency and torrent links in messages
 * Router: Increase timer thread priority

2015-10-17 zzz
 * Crypto:
   - Consolidate duplicate unlimited strength crypto check code
   - Disable TLS_DHE_DSS_WITH_AES_128_CBC_SHA

2015-10-16 zzz
 * Console: Add Java 6 warning to summary bar
 * i2psnark:
   - Fix deadlock (ticket #1432)
   - Add "smart sort" option, set sort based on language (tickets #637, #1303)
   - Don't balloon files on ARM (ticket #1684)

2015-10-14 zzz
 * Update:
   - Require Java 7 to download dev builds (ticket #1669)
   - Fix persistence of the available dev version

2015-10-13 zzz
 * Startup: Delete our old RI from netDB when rekeying

2015-10-11 zzz
 * Crypto: Test for broken Gentoo ECDSA support

2015-10-10 zzz
 * i2psnark: Increase max piece size to 16 MB, max files to 999,
   close files faster based on file count (tickets #1626, #1671)
 * JobQueue: Only adjust timing for negative clock shifts
 * NamingServices: Add support for lookups prefixed with "www."
 * Startup: Increase rekey probability

2015-10-08 zzz
 * SimpleTimer2: Additional fix for uncaught IllegalStateException
   affecting streaming timers (ticket #1672)

2015-10-02 zzz
 * Router: Don't check config files for reload on Android

2015-09-28 zzz
 * Addressbook: Fix isValidDest() for EC/Ed dests
 * i2psnark: Support adding plain base 32 hashes
 * Susimail: Hide headers and buttons if search results are empty

2015-09-27 dg
 * Router: Fix soft restarts for 'massive' clock jumps (over +150s or -61s) and recover from standby
   and hibernate (ticket #1014).

2015-09-27 zzz
 * Console:
   - Export SSL cert on creation
   - New /certs page to show local SSL certs
   - Show 'none' if no leasesets
 * SimpleTimer2: Fix bug in forceReschedule() that caused subsequent uncaught IllegalStateException,
   affected streaming timers
 * Streaming: Move throttler from context timer to streaming timer
 * Tunnels: Use max of 2 not-failing peers in an exploratory tunnel,
   use high cap for the rest; change outbound exploratory
   default length from 2 + 0-1 to 3+0.
 * Util: Speed up IP address validation by using Apache's implementation (ticket #1198)

2015-09-25 dg
 * Rename _() for translation to _t() for Java 9 compatibility (ticket #1456)

2015-09-24 zzz
  - Rename bad .torrent files instead of deleting them

2015-09-20 dg
 * /configreseed: Add 'Reset URL list' button for revert to default hosts (ticket #1554, thanks dzirtt@gmail.com)

2015-09-19 zzz
 * i2psnark: Add recheck/start/stop buttons to details page (ticket #372)

2015-09-18 zzz
 * EepGet:
   - Send Accept-Encoding: gzip even when proxied
   - Fix man page (ticket #1631)
 * i2psnark:
   - Don't display "Tracker Error" if torrent is stopped (ticket #1654)
   - Improve directory listing efficiency (ticket #1079)
 * i2ptunnel:
   - Pass Accept-Encoding header through HTTP client and server proxies,
     to allow end-to-end compression
   - Don't do transparent response compression if response
     Content-Encoding indicates it is already compressed
 * Streaming: Move remaining timers from the context to streaming's SimpleTimer2

2015-09-17 zzz
 * i2psnark:
   - Store magnet parameters across restart (ticket #1485)
   - Don't delete torrent config file after error on initial startup (tickets #1575, #1658)

2015-09-16 zzz
 * Build:
   - Include geoip in update files for next release
   - Add created-by string to release torrents
 * i2psnark:
   - Store torrent added and completed times in config files, display on details page
   - Add metainfo creation command line support for created-by string
 * Profiles: Bias slightly away from floodfills

2015-09-15 zzz
 * Console:
   - Store news feed items separately on disk in XML, like a real feed reader
   - Limit display to 2 news items in summary bar, /home and /console
   - New /news page to show all news (ticket #1425)

* 2015-09-12 0.9.22 released

2015-09-11 kytv
 * Updates to geoip.txt and geoipv6.dat.gz based on Maxmind GeoLite Country
   database from 2015-09-02.
 * Translation updates pulled from Transifex

2015-09-04 zzz
 * UPnP: Fix "content not allowed in trailing section"
   (tickets #481, #1653)

2015-08-31 zzz
 * Data: Cache P256 and Ed255i9 key certificates
 * i2psnark: Change default sig type to Ed25519

2015-08-29 zzz
 * Router:
   - Change default RI sig type to Ed25519, with a 10% chance od
     rekeying from DSA at each restart
   - Don't initialize KeyManager before selecting sig type
   - Don't log KeyManager error when changing sig type

2015-08-25 zzz
 * i2psnark:
   - Return partial piece to coordinator after reject
   - Fix tracking of downloaded portion of piece after reject
   - Send reject on receipt of bad request
   - Mark piece unrequested after receiving bad data, so it
     will be requested again, but not from the same peer
   - Fix NPE in Request constructor on error
   - Fix stuck before completion due to reject handling (ticket #1633)
   - Fix orphaned temp files due to reject handling (ticket #1635)

2015-08-02 zzz
 * Console: Fix SSL excluded ciphers (thx lazyg)
 * SU3File: Add keystore password command line option

* 2015-07-31 0.9.21 released

2015-07-27 zzz
 * Update: Fix processing of translated news su3 files

2015-07-26 zzz
 * Update translations

2015-07-25 zzz
 * i2psnark: Fix total_size in metadata message (ticket #1618)
 * NetDB: Fix NPE (ticket #1619)

2015-07-21 str4d
 * Core: Throw DFE in Certificate.create() instead of AIOOBE (ticket #1016)

2015-07-21 str4d
 * Core: Fix parsing bug in KeyCertificate

2015-07-16 zzz
 * Console: Add dates to news headings

2015-07-12 zzz
 * Findbugs all over

2015-07-08 zzz
 * Tunnels: New Bloom filter size, increase bandwidth limit (ticket #1505)

2015-07-07 zzz
 * Crypto: Check for error return from sign()
 * i2psnark: Tweak dest display in footer
 * Streaming: New config to add to DSA-only list
 * Updates: New news URL

2015-07-05 zzz
 * SSU: Compete better with NTCP for outbound bandwidth allocations
 * Transport: Adjust thread priorities to prevent I/O stalling

2015-06-29 zzz
 * Transport: More fixes for SSU stalling

2015-06-28 zzz
 * Apache Tomcat 6.0.44

2015-06-25 zzz
 * Console: Use registered host/port for eepsite link (ticket #1604)
 * Jetty starter: Register host/port when started
 * PortMapper: Add hostname support

2015-06-24 zzz
 * Transport: Add failsafe to prevent complete SSU stall waiting
   for bandwidth limiter

2015-06-23 zzz
 * Console: Fix NPE on /configtunnels
 * GeoIP: Add countries and flags for Asia/Pacific, Bonaire, St. Barts,
   St. Maarten, South Sudan
 * I2CP: Don't try to decrypt an LS before it's encrypted (ticket #1608)
 * Router: Increase default outbound bandwidth to 60 KBps;
   raise class L/M boundary to match so defaulted routers are still L

2015-06-22 dg
 * NetDB: Partially revert last NetDB change: flood because we don't want
   to create a hole in the DHT before publisher resends to somebody else.

2015-06-20 dg
 * I2PSnark: Auto-start now only starts torrents which were running at shutdown (#766)
 * NetDB: Don't say we stored, and don't flood, if we're shutting down

2015-06-19 zzz
 * I2CP: Fix simple session lookups, broken in prop
 * I2PSocketEepGet: Do hostname lookups in-session for efficiency
 * Tunnels: Increase default max tunnels

2015-06-18 zzz
 * I2CP:
   - Don't send the first LS request to the client until we have
     at least one OB tunnel, so the client waits until we are ready.
   - Fixes to prevent multiple pending LS requests
   - Move client-side implementation classes to
     new package net.i2p.client.impl, leaving only the
     factories and interfaces in net.i2p.client
 * Update: Add language param to news fetch for translated news (ticket #1425)

2015-06-17 zzz
Prop from i2p.i2p.zzz.multisess:
 * Router, I2CP, Streaming, i2ptunnel:
   - Multisession support and multiple destinations in one tunnel pool
   - Connections to Hardcoded blacklist of destinations that do not
     support ECDSA will use the DSA session
   - Change shared clients to ECDSA by default, with a DSA subsession
   - Add support for 'aliased' local destinations that use the same tunnel pools
   - No UI or config support, no server support, may be added later
   - Catch uncaught exceptions in ClientConnectionRunner and stop connection
   - When socket is closed, set sessionID and LS to null,
     close subsession and set its sessionID and LS to null
   - Checks on client side for null session ID
   - Check for null session in Destroy Session message

2015-06-13 zzz
 * i2psnark: Fix NPE (ticket #1602)
 * NetDB:
   - Improve routing of DatabaseStoreMessage acks
   - Send our own RI unsolicited in reply if we aren't floodfill
   - Don't ack or flood a store of an unknown type
   - Don't say we stored, and don't flood if we're shutting down
 * PeerTestJob: Don't generate zero reply token
 * Timestamper: Reduce NTP timeouts to shorten startup time
   when NTP is blocked
 * Tunnels: More checks of messages received down exploratory tunnels

2015-06-08 dg
 * Language fixes
 * Make netDb.storeFloodNew graphable for testing (#1195)
 * Directly connect to nearby floodfills to share our RI
   to speed up integration of new floodfills (#1195)
 * Silence Irc{Inbound,Outbound}Filter warnings about 'no streams'
   when we can't connect to an IRC server. Change to WARN.

2015-06-07 zzz
 * Logs: Correct wrapper.config location when running as a service
 * NetDB: Fix early NPE
 * SSU: Possible fix for NPE in establisher

2015-06-06 zzz
 * Console: Add indication of current ff status on /configadvanced,
   change immediately when config changes, force republish

2015-06-06 str4d
 * newsxml: Don't use XXX for parsing dates on Android

2015-06-04 str4d
 * i2ptunnel:
   - Don't connect manager to router in constructor (ticket #815)
   - Don't call startup() in chained constructor (ticket #1593)

2015-06-03 zzz
Prop from i2p.i2p.zzz.sam:
 * I2CP: Set keepalive on sockets (ticket #1573)
 * SAM:
   - Close sockets and stop tunnels when router-side SAM stops (ticket #1572)
   - Better checks for quoting status message strings (ticket #1488)
   - Set encoding for sam.keys file
   - Don't throw NPE on rare stream errors
   - Comment out unused dumpProperties()
   - Cleanups, log tweaks, thread name tweaks
   - Set keepalive on sockets (ticket #1573)
Prop from i2p.i2p.zzz.test2:
 * Console:
   -  Don't allow unbanning of all-zero hash
   -  Nicer "move" icons on /configsidebar, add tooltips
   -  Prevent bad line-wrap of very long menu items
 * HTTP Client: Greatly simplify decompression by using InflaterOutputStream
 * I2CP: Prevent sending messages before handshake with router is complete
 * i2psnark:
   - Add support for fast extensions (BEP 6)
   - Don't say 'download finished' unless we downloaded something
   - Don't lose sort param when hiding peers
 * i2ptunnel: Strip top-level supercookies too
 * LogWriter: Write dup message to wrapper log and crit buf also (ticket #1585)
 * Reseed: Only log reseed network disconnected warning once
 * Router: Add gzip and translate caches to clearCaches()
 * Susidns, addressbook: Don't attempt to fetch subscriptions if
   HTTP proxy is down (ticket #1530)
 * SSU: More synchronization in PeerState
 * Stats: Reduce number of rates in required stats to save memory
 * UPnP: Only log network disconnected warning once

* 2015-06-02 0.9.20 released

2015-05-31 zzz
 * Fortuna: Catch AIOOBE (ticket #1576)

2015-05-30 zzz
 * i2ptunnel: Fix +/- variance config (ticket #1587)

2015-05-29 zzz
 * HTTP client: Fix occasional truncation of compressed responses

2015-05-27 zzz
 * Banlist: Ban all-zero hash
 * DataHelper: Add year output to formatDuration()
 * Graphs: prevent NaNs if we are skewed ahead of system time
 * NetDb: Drop all-zero lookups and stores, add stats
 * SSU:
   - Fix debug logging of dumped packets
   - Drop sessions with bad clock skew, banlist peer, add stats
   - Drop sessions with corrupt DSM, banlist peer, add stats

2015-05-23 zzz
 * I2CP: Add an INIT state for session, so a newly created session
   isn't treated as CLOSED and immediately replaced by i2ptunnel,
   which caused dup shared clients in a race at startup
   (possible related tickets #642, #650, #815, #1545)

2015-05-21 kytv
 * Updates to geoip.txt and geoipv6.dat.gz based on Maxmind GeoLite Country
   database from 2015-05-06.
 * Translation updates

2015-05-13 zzz
 * Console: Fix URLs caught in XSS filter on /confighome (ticket #1569)
 * i2psnark: Fix deletion of single-file torrent outside snark dir (ticket #1544)
 * NTCP: Catch race in Reader (ticket #1534)

2015-02-12 dg
 * Job Queue/stats: add stat/graph for amount of scheduled jobs (router.tunnelBacklog)
 * FloodfillMonitorJob:
   - Use avg of router.tunnelBacklog instead of current backlog
 * Some language/spelling fixes

2015-05-11 zzz
 * Util: Fix corruption of cached ReusableGZIPInputStreams

2015-05-09 zzz
 * i2ptunnel: Improve error handling in UDP tunnels
 * Plugins: Add support for custom icons (ticket #1550)

2015-05-08 zzz
 * Reseed: Don't reseed while shutting down (ticket #1565)

2015-05-07 zzz
 * SAM: Close datagram or raw session when underlying
   I2P session closes (tickets #1455, #1563)
 * Update: Add support for su3-signed development builds (ticket #1381)

2015-05-06 zzz
 * Datagram: Convert IOE to DFE and throw on error (ticket #1562)
 * Naming services: Export address books with Windows
   line endings on Windows (ticket #1557)
 * Transport: Add config to force IPv4 (only) to firewalled (ticket #1541)

2015-05-04 zzz
 * i2ptunnel:
   - Close input stream when HTTP client decompressor
     terminates (ticket #1506)
   - Add Connection: close headers to errors and proxy.i2p responses
     where it was missing (ticket #1531)

2015-05-03 zzz
 * Console: Add floodfill configuration form to /configadvanced
 * Router: Allow class M to become floodfill;
   add bandwidth classes P and X (ticket #1447)
 * SusiDNS: Add export button

2015-05-02 zzz
 * Console: Fix Indonesian translations
 * Jetty 8.1.17.v20150415
 * Transports: Cleanup of ticket #1458 fixes

2015-04-30 zzz
 * Transports: Correctly handle IPv4 firewalled, IPv6 not (ticket #1458)

2015-04-29 zzz
 * Clock: Make forward slewing work better
 * I2CP: Periodically send a SetDate message to external clients
 * Transports:
   - Fix clock skew calculations
   - Track IPv4/v6 reachability separately (ticket #1458)

2015-04-28 zzz
 * JobQueueRunner: Don't call System.exit() on OOM,
   let the shutdown progress normally;
   Make it an I2PThread instead of a Runner so we can
   call fireOOM() for consistent logging (ticket #1549)
 * Router: Don't add OOM listener on Android so
   we don't hang onto the context

2015-04-27 zzz
 * NamingService: Add export methods
 * SusiDNS: Add export support, no UI yet
 * Transports:
   - Convert internal state to enums, prep for tracking
     IPv4/v6 reachability separately (ticket #1458)
   - Don't set TCP keepalive for IPv6

2015-04-26 zzz
 * i2ptunnel: Reduce sleep time in runners to reduce latency

2015-04-25 zzz
 * I2PSSLSocketFactory: Add hostname verification
 * SSLEepGet:
   - Rework recent setSoTimeout code changes, as they broke SNI
   - Add option to save certs even if no errors
   - Add option to disable hostname verification

2015-04-24 zzz
 * Util: Catch and convert OOM in I2PThread.start()
 * i2ptunnel:
   - Fix Socks and SocksIRC tunnels not starting
   - Fix shutdown of client tunnels on server socket errors,
 * Updates: Fail fast if HTTP proxy is not running (ticket #1530)

2015-04-23 zzz
 * Streaming:
   - Reduce min RTO for quicker recovery after packet loss
   - Reduce default initial ack delay
   - More efficient checking for input buffer overflow

2015-04-22 zzz
 * i2psnark: Fix deletion of config files, cleanup old ones (ticket #1498)
 * I2PSocketEepGet: Fix i2psnark NPE caused by -6 (ticket #1543)
 * NTCP: Reduce min send finisher threads to 1
 * PortMapper: Status output for /debug

2015-04-21 zzz
 * i2ptunnel: Log uncaught errors in thread pool
 * Reseed: Disable non-su3 reseeding
 * Router timestamper:
   - Add country-to-continent mapping
   - Add continent zones as fallback
   - Don't start threads in constructors
 * Transports: Reduce idle timeouts

2015-04-20 zzz
 * Blockfile: Unroll recursive initialization
 * EepGet: Set soTimeout for non-proxied fetches to enforce
   header timeout and prevent long reseed hangs
 * Reseed:
   - Honor SSL/non-SSL setting when custom reseed list is set (ticket #1136)
   - Remove all default HTTP URLs (ticket #1514)

2015-04-17 zzz
Prop from i2p.i2p.zzz.test2:
 * Console: Set session cookies to HttpOnly
 * i2psnark: Remove extra mime types in i2psnark web.xml;
   added to Jetty's default by now, or in our mime.properties file
 * i2ptunnel:
   - Send HTTP server port 443 traffic to the server
     transparently, to support HTTPS over the same tunnel, if so configured
   - Add check for total header size in HTTP server
   - Return specific error pages to client on errors
     in HTTP header processing in the HTTP server (ticket #1507)
 * Jetty:
   -  Add extensive help to jetty-ssl.xml
   -  Set session cookies to HttpOnly in all webapps
 * JobQueue: Make number of runners configurable
 * Router: Move update extraction code to new class in tasks/
 * Tunnels:
   - Add bloom filter warning if high bandwidth but low memory
   - Add new Bloom filter size, increase bandwidth limit (ticket #1505)
   - Add config to disable Bloom filter for testing

2015-04-16 zzz
 * I2CP: Run DistributeLocal jobs inline (ticket #1506)
 * i2psnark: Increase max tunnels to 10
 * i2ptunnel: Don't start tunnels in constructors (ticket #815)
 * NetDB: Reduce max search depth
 * Transport: Fix active peer count for NTCP

2015-04-15 tuna
 * SimpleScheduler: Deprecated, functionality moved to SimpleTimer2 (ticket #1069)

2015-04-13 zzz
 * Router: Fix NPE on bad share bandwidth config (ticket #1524)
 * Streaming: Handle reset packets without a FROM field, validate
              signature using connection's destination
 * Update: Don't log an error for the "dummy" updater (ticket #1525)

* 2015-04-12 0.9.19 released

2015-04-11 zzz
 * Updates after review

2015-04-09 kytv
 * Updates to geoip.txt and geoipv6.dat.gz based on Maxmind GeoLite Country
   database from 2015-04-07.
 * Translation updates

2015-04-05 zzz
 * IRC Server: Better timeout handling reading initial lines (ticket #723)

2015-04-04 zzz
 * i2ptunnel:
   - Better timeout handling when reading headers in HTTP server (ticket #723)
   - Fix NoSuchElementException processing proxyList caused by 03-31 checkin
 * Streaming:
   - Fix read timeout on input stream (ticket #723)
   - Fix read() returning 0 instead of -1 on read timeout (ticket #335)

2015-04-03 zzz
 * i2ptunnel: Fix stopping tunnel on bad args when starting
 * wrapper.config: Remove old mortbay Jetty parameters

2015-04-01 zzz
 * I2CP: Allow larger client clock skew (ticket #1503)
 * i2psnark: Fix changing data directory on Windows (ticket #1503)

2015-03-31 zzz
 * API: Fix some client-side APIs to honor defaults in Properties;
   add javadocs to specify where we do and don't (ticket #1491)
 * i2ptunnel: Fix multiple SSL outproxies in HTTP client

2015-03-29 zzz
 * I2CP: Prevent NPE (ticket #1503)

2015-03-25 zzz
 * i2ptunnel HTTP client: Replace all getBytes() calls
   with a Writer or getBytes("UTF-8") (ticket #457)

2015-03-24 zzz
 * Streaming: Throw I2PSocketException when connection is reset,
   display new error page in HTTP client (ticket #643)

2015-03-23 zzz
 * Javadoc: Add missing package.html files (ticket #1109)
 * Summary bar: linkify news headings, remove 'show news' link

2015-03-22 zzz
 * Console: Better status feedback on manual reseed from URL
 * NetDB: Don't become floodfill w/o ECDSA support
 * Reseed: Better status feedback and cleanup in summary bar

2015-03-21 zzz
 * Console: Support plugin installation from local file

2015-03-20 zzz
 * Reseed:
  - Move multipart form support from susimail to jetty-i2p.jar
    so console can use it
  - Finish manual reseed from local file

2015-03-19 zzz
 * Reseed (ticket #1369):
  - Add form to manually reseed from zip or su3 URL
  - Add form to manually reseed from local zip or su3 file
  - Add form to create reseed zip file to share
  - Backend support and refactoring in reseed code

2015-03-18 zzz
 * NetDB:
  - Send exploratory lookups directly to the floodfill if
    we are already connected to him
  - Don't encrypt RI lookups when overloaded
  - Don't explore when overloaded
  - Don't publish non-ff RI on exit if we are coming right back
 * Router: Allow disabling the setting of some System properties, for embedded applications
 * StatisticsManager: Publish dummy LS count if we just started
 * Streaming: Reduce min RTO again
 * Tunnels: Drop instead of reject requests on high job lag
 * UPnP: Update to cyberlink 3.0

2015-03-16 zzz
 * Apache Tomcat 6.0.43
 * NetDB: Send RI lookups directly to the floodfill if
   we are already connected to him
 * Router:
   - Republish RI early if capabilities change
   - Increase exploratory tunnel quantity if floodfill
 * Throttle: Reject tunnels based on job lag

2015-03-15 zzz
 * Job Queue:
   - Fix overload dropping
   - Add drop count to job stats
   - Decrease overload threshold again
 * NetDb: Track flood success

2015-03-13 zzz
 * i2psnark:
   - Auto-reduce tunnel quantity based on peer count
   - Increase max tunnels
 * Job Queue:
   - Drop garlic message decryption jobs on overload
   - Decrease overload threshold

2015-03-13 dg
 * Router: create router.integratedPeers (floodfills) stat, and
   allow graphing of it.

2015-03-08 zzz
 * i2psnark: Increase min and default bandwidth
 * Throttle: Tweak messages during probabalistic rejection
 * Transport: Add missing bogons to IP validity check

* 2015-02-22 0.9.18 released

2015-02-18 kytv
 * Updates to geoip.txt and geoipv6.dat.gz based on Maxmind GeoLite Country
   database from 2015-02-04.

2015-02-15 dg
 * FloodfillMonitorJob:
   - Use lifetime average value for job lag
   - Change the job lag limit to less than 25ms
   - Consider and set the limit of backlogged tunnels to less than 5

2015-02-10 dg
 * I2PSnark, Jetty, SAM, crypto: findbugs resource leaks.

2015-02-07 zzz
 * SSU: Limit range for valid clock skew
 * Transport: Ban routers if they are too old and we are non-DSA

2015-02-06 zzz
 * NetDB: Reduce max job lag for floodfill
 * NTCP: Block IP for a while when incoming connection is dropped before
   receiving a message. Possible workaround for tickets #551, #1075, #1411.
 * Transport:
   - Decrease DH refiller initial delay and increase buffer size
     to reduce chance of running out on high-bandwidth routers
   - Add event log for reachability change

2015-02-01 zzz
 * Crypto: Catch IAE in generateCertificate()
 * NetDB: Don't flood an RI back to itself. While Java ffs self-flood,
   other implementations may not.
 * OCMOSJ: Pick a OB tunnel at random, not with the OBEP closest
   to the lease, as that may be hurting connection reliability.
 * Router: Call warmupCrypto() earlier in the initialization

2015-01-31 zzz
 * Console:
   - Don't display invalid IPv6 addresses as options on /confignet
   - Disable changing log path
 * NetDb:
   - Encrypt lookups for 32-bit x86 also
   - Disable floodfill in laptop mode
 * PRNG: Don't hang forever at startup waiting for SecureRandom init
 * Transport: Set 4 MBps max bw due to bloom filter

2015-01-30 zzz
 * HTTP Proxy: More error page changes
 * NTCP: Throttle event pumper if looping too fast (tickets #551, #1075, #1411)

2015-01-29 zzz
 * SSU:
   - Fix replaceExternalAddress churn when firewalled
   - Sort introducers in router address, so we won't force a republish
     due to a different ordering of the same introducers
   - Don't publish an address if we need introducers but don't have any,
     so the user won't see a 'firewalled with inbound NTCP enabled' message
   - Fix transition from firewalled to non-firewalled

2015-01-28 zzz
 * UPnP:
  - Rescan for devices periodically and when reachability changes (tickets #661, #959)
  - Callback when device removed
  - Consolidate callbacks
  - Clear ignored devices after primary device removed
    to allow one to be promoted on rescan
  - Don't put "I2P" in registered protocol name
  - Add uptime to UPnP info
  - HTML escaping
  - Remove static log on Android

2015-01-11 zzz
 * i2psnark: Skip incompatible welterde tracker if we are ECDSA
 * I2PTunnel: Add option for multihoming optimization

2015-01-10 zzz
 * NetDB: Stubs for bandwidth estimation during reseed (ticket #935)

2015-01-09 zzz
 * NetDB: Publish RI faster when costs change (ticket #1437)

2015-01-08 zzz
 * Console, i2ptunnel, proxy: Renaming of various things to "hidden services"

2015-01-07 zzz
 * ClientAppConfig: Start i2ptunnel sooner (ticket #1162)
 * NetDB: Possible fixes for reseed completion not recognized (ticket #1384)
 * Router:
   - Add startup/shutdown state machine
   - Don't reset uptime after a soft restart
 * Startup: Accept tunnels after 10 minutes instead of 20 (ticket #1152)
 * Tunnels:
   - Cleanup, catch more cases of zero-hop configuration
   - Temporarily increase exploratory tunnel quantity at startup,
     so that netdb refresh will work better

2015-01-05 zzz
 * Blocklist:
   - Rewrite to read and merge multiple files
   - Include in update, use version in base dir too
   - Increase limits
   - Bug fixes
 * EepGet: Change command line default to 0 retries
 * Latency reduction all over:
   - SSU: Reduce ack delay
   - Streaming: Reduce min RTO and flusher delay
   - Tunnels: Reduce GW batching time
 * Streaming:
   - Add API for sending/receiving payload in ping/pong
   - Fix PcapWriter
 * UrlLauncher:
   - Configure browser with routerconsole.browser (ticket #1159)
   - Convert to ClientApp interface

2015-01-03 zzz
 * I2CP: Use configured leaseset keys if available
 * I2PTunnel: Persist leaseset keys

2014-12-15 zzz
 * Console: Prevent two-word translations from splitting across lines in summary bar
 * Crypto: EdDSA cleanups
 * i2psnark: Unchoke new peer sooner
 * SSU: reduce log level of uncaught errors processing I2NP message
 * SU3:
   - Don't require specification of sig type when signing
   - Implement 'extract -k'
   - Fix getContentOffset()
   - Fail on excess data after signature
 * Tunnels: Raise concurrent build limit

2014-12-08 zzz
 * HTTP Proxy: Fix parsing of ECDSA address helper
 * NetDB: Increase lookup throttle time

2014-12-05 zzz
Prop from i2p.i2p.zzz.test2:
 * Console:
   - Show b32 for local leasesets also on netdb LS tab
 * Data:
   - Disallow duplicate keys in a Mapping
   - Add RouterInfo.getVersion()
 * I2NP:
   - Move some data structures away from ByteArray; offsets were always zero
     - New BuildRequestRecord constructors
     - BuildRequestRecord field becomes final byte[222]
     - IV becomes byte[16]
     - Build record becomes EncryptedBuildRecord
   - Remove extra copy in BuildRequestRecord.encryptRecord()
   - Remove unused BuildRequestRecord.readOurIdentityMatches()
   - DatabaseStoreMessage: Mask the unused bits in the type field for future use
 * i2psnark: Reduce auto-stop threshold for update torrent
 * I2PTunnel: Reduce i2ptunnel threads, more thread pooling.
   - Move client pool from static inI2PTunnelClientBase to TCG.
   - Use client pool for some server threads
   - Run some things inline that were formerly threads
 * KeyGenerator: main() test improvements
 * Logger: Configurable flush interval
 * Plugins: Another fix for restarting a ClientApp plugin
 * Profiles: Change slice selection argument from an int to an enum for clarity
 * SusiMail:
   - Add save-as button
   - Fix encoding for filename in Content-Disposition header
 * Transport:
   - Disallow standard I2P application ports as the router port
   - Increase default class O conn. limits to 350 NTCP, 1050 SSU
 * Update: Use last-modified instead of last-checked for the next
   if-modified-since fetch, to fix failing to fetch the latest news

* 2014-11-30 0.9.17 released

2014-11-28 kytv
 * Updated PO files from Transifex
 * Updates to geoip.txt and geoipv6.dat.gz based on Maxmind GeoLite Country
   database from 2014-11-05.

2014-11-26 zzz
 * BuildRequestor: Reduce delay when client build can't find
   a paired tunnel (ticket #1412)
 * Data:
   - Fix NPE on unknown sig type in destination
   - Fix hashcode and equals for typed data
 * Tunnels: Disallow changing allowZeroHop setting for exploratory

2014-11-24 zzz
 * i2ptunnel: Fix automatic setting of random key
 * PrivateKeyFile: Don't rewrite file in main() if no options

2014-11-23 zzz
 * Reseed hosts update

2014-11-22 zzz
 * PeerSelector: If non-DSA, don't use incompatible peers
   for exploratory tunnels or closest-hop in client tunnels
 * SAM: Fix v3 bug accepting incoming connections

2014-11-17 zzz
 * NetDB: Exclude A1/A2 "countries" from auto-floodfill

2014-11-15 zzz
 * I2NP:
   - Set lookup type flags even if no reply tunnel specified
   - Reduce object churn when writing some messages

2014-11-13 zzz
 * I2PTunnel:
   - Fix bug that left server acceptor thread running after close
   - Add destroy() methods to release all resources when closing a tunnel for good,
     particularly the streaming timer threads
   - Use COWAL to prevent concurrency problems
 * PluginStarter: Simplify detection of active threads
 * Streaming:
   - Don't return null from accept() any more; actually throw
     ConnectException as the Javadocs have always specified
   - Throw ConnectException from accept() if interrupted; previously caught and ignored
   - Throw exceptions from ConnectionHandler.accept(), not higher up
   - Close ServerSocket when ConnectionManager is shut down
   - Synchronize setActive(), clear queue when starting to accept,
     better handling of calls that don't change state

2014-11-12 zzz
 * Data: Clear more caches when under memory pressure and at shutdown
 * Plugins: Fix bug in stopping a ClientApp plugin with $parameters in the args

2014-11-09 zzz
 * i2psnark: Fix tracker config form issues
 * Router, i2ptunnel: Add option for per-pool persistent random key,
   so peer ordering does not change across restarts

2014-11-08 zzz
 * EdDSA: Bump minimum router version to 0.9.17
 * i2psnark: Add support for specifying data dir in add form (ticket #1028)
 * ProfileOrganizer: More efficient slice calculation
 * SSU: Fix bug preventing inbound connection from non-DSA router (ticket #1408)
 * Transports: If non-DSA, check for compatibility before connecting out

2014-11-06 zzz
Prop from i2p.i2p.zzz.test2:
 * Blockfile:
   - Add block size to superblock
   - Add span size to skiplist block
   - Bump version to 1.2
 * Console:
   - Log warnings for Java 6 or no Pack200
   - Add ECDSA warning to sidebar
   - Don't disable updates when restarting from /configupdate
   - Recognize router.newsRefreshFrequency=0 as "never"
 * Crypto: Drop dummy crypto stubs
 * i2psnark:
   - Convert '+' to ' ' in magnet dn param
   - Fix NPE when deleting torrent if the data directory
     was deleted out from under us (ticket #1407)
   - Add new opentrackers, remove welterde
   - Support multiple default opentrackers
   - Don't link to opentrackers at the top
 * i2ptunnel:
   - ECDSA default for all new server tunnels
   - ECDSA default for streamr client tunnels
   - Fix display of server destination on edit page when not running (privkey file path wasn't absolute)
   - Fix display of persistent client key b32 on edit page when not running
   - Fix display of server sig type on edit page when we have a privkey file
 * jbigi: Save and report extracted library name
 * Reseed: SSL-only by default
 * Router:
   - Make recognition of a hidden router consistent,
     whether specified in the caps or the cert
   - Job Queue: Only drop lookup jobs if lagged
 * SSU:
   - Don't resend ACKS that are too old (ticket #772)
   - Dont OOM if ACK sender dies
   - Don't publish direct info if introducers are required
 * SU3File: Show content and file types in showversion
 * Transports:
   - Consolidate port checking code
   - Disallow SSDP port
 * Update: Implement signed news in su3 format with trusted signers,
   wrapping an Atom XML format
 * Util:
   - Use write-sync-close-rename for config file writing
   - Null check in zip entry name

2014-11-04 zzz
 * SSU: Fix corruption of ack-only packets containing bitfields

* 2014-11-01 0.9.16 released

2014-10-30 kytv
 * Updates to geoip.txt and geoipv6.dat.gz based on Maxmind GeoLite Country
   database from 2014-10-07.
 * Arabic, Chinese, Czech, Dutch, French, German, Russian, and Spanish
   translation updates from Transifex

2014-10-30 zzz
 * Router: Fix rare NPE building garlic message (ticket #1403)

2014-10-26 zzz
 * SSU: Fix ACK Sender thread dying on corrupt packet

2014-10-24 zzz
 * i2ptunnel: Fix description entered via wizard

2014-10-23 zzz
 * SessionKeyManager:
   - Raise inbound limit
   - Delete oldest tagsets when limit is hit
   - Don't delete recent tagsets when limit is hit
 * SSL: Don't prohibit SSLv3 ciphers if that's all we have

2014-10-20 zzz
 * Console: Fix lockups (ticket #1395)
 * Eepsite Jetty: Switch back to QueuedThreadPool (ticket #1395)

2014-10-17 zzz
 * NTCP: Deadlock fix 3rd try (ticket #1394)

2014-10-16 zzz
 * NTCP: Deadlock fix 2nd try (ticket #1394)

2014-10-15 zzz
 * Console, I2CP, i2ptunnel, SSLEepGet: Set allowed SSL
   protocols and ciphers. Disable SSLv3 and older ciphers.
   Enable TLSv1.1 and TLSv1.2 on Java 7,
   where it is disabled by default client-side.

2014-10-14 zzz
 * I2NP: Implement DatabaseLookupMessage search type field

2014-10-13 zzz
 * i2ptunnel: Set default sig type to ECDSA-P256 for client types
   Standard, IRC, and Socks IRC, if non-shared.

2014-10-10 zzz
 * Banlist: Remove unused banlist tracking in the profile
   causing deadlock (ticket #1394)
 * GeoIP:
   - Don't rate peers in some countries as high capacity
   - Don't enable auto-floodfill in some countries
   - Don't prefer floodfills in some countries

2014-10-08 zzz
 * UPnP: Comment out unused parsers

2014-10-07 zzz
 * CPUID: Remove Intel model 2 again, this is spoofed in the VM
 * Graphs: Catch an error caused by missing fonts
 * i2ptunnel: Handle named sig types from i2ptunnel.config in the GUI
 * SSU: Improve handling of socket that gets closed (ticket #1385)
 * Startup: Delay ReadConfigJob another minute

2014-10-05 zzz
 * Crypto: EdDSA cleanup

2014-10-04 zzz
 * i2psnark: Disable changing types for predefined trackers
 * i2ptunnel: Fix js confirm for delete button

2014-10-03 zzz
 * Console: New add-to-addressbook links on leaseset page
 * CPUID: Fix Intel processor identification
 * i2psnark: Fix adding magnet links with % encoding (ticket #1391)

2014-09-30 zzz
 * Logs: Fix displayed filename when empty (ticket #1386)
 * SAM: Fix v3 LS publish, broken in -4 (ticket #1390)

2014-09-29 zzz
 * CPUID:
   - Fix main() model and family calculation
   - Add model string fetch from processor
   - AMD model string tweaks
 * i2psnark: Show subdirectory in table header on details page

2014-09-27 zzz
 * CPUID:
   - Fix model and family calculations
   - Fix most AMD family 15 IDs
   - Add AMD Llano, Jaguar, Bulldozer 2
   - Add Intel Ivy Bridge, Haswell, Broadwell, Penryn,
     Pineview, Cedarview, Bay Trail, Avoton, and others
   - Set best-guess capabilities for most Intel processors
   - Supply best-guess model string in most cases
   - Processors listed above, and some others, may see crypto speedups as a result

2014-09-26 zzz
 * EdDSA: Use our PRNG by default for keygen
 * i2psnark:
   - Increase default to 3 hops (ticket #966)
   - Show info hash on details page
 * NetDB: Increase max age of RIs to reduce number refreshed after restart
 * SAM:
   - Don't publish LS for DIRECTION=CREATE
   - Set default tunnel name
 * Tests: Fix junit compile fails due to data structure moves
 * Transport: Hooks for pluggable transports (ticket #1170)

2014-09-23 zzz
Prop from i2p.i2p.zzz.test2:
 * Addressbook: Improve parser efficiency
 * Data structures: Move several router-only classes from i2p.jar to
   net.i2p.data.router in router.jar. This will break existing
   versions of the i2pcontrol plugin.
 * HTTP Client: Add error page for unsupported encryption
 * I2CP:
   - Verify crypto key pair in LS
   - Verfiy same dest as before in LS
   - Enforce strict authorization when auth is enabled
 * i2psnark:
   - Set-all priority buttons (ticket #1376)
   - Comment out command-line code
   - Consolidate and clean up parameters code
   - Click to sort by column
   - Display upload ratio when sorted by ratio, and on details page (ticket #1298)
   - Consolidate code for creating img entities
   - Switch from checkbox to radio for tracker configuration form
   - Sort themes in config form
   - Consolidate HTML header code
   - Set no-cache headers
   - Don't set HTML headers for redirects
 * I2PTunnelGUI: Test tool deleted, moved to i2p.scripts
 * Jetty 8.1.16.v20140903
 * KeyGenerator: Add support for converting
   all signing key types from private to public
 * NetDB:
   - Encrypt RI lookups and request encrypted reply on
     faster boxes, to prevent scraping by OBEPs and IBGWs
   - Encrypt exploratory lookups too
   - Better handling of unsupported encryption in destinations
   - Implement handling of unsupported encryption in router identities
   - Banlist forever all RIs with unsupported encryption
   - New negative cache of all dests with unsupported encryption
   - New methods for destination lookup that will succeed even if
     the LS is expired or encryption is unsupported
   - Use new dest lookup so client will get the right error code
     later, rather than failing with no LS when we really got it
     but just couldn't verify it.
   - Don't auto-enable floodfill if ARM or if ElG decrypt is too slow
 * NTCP EstablishState:
   - Prep for future enhancements by refactoring to a state machine model
   - Reduce object churn; use SimpleByteCache
   - Synchronization
 * OCMOSJ: Detect unsupported encryption on dest and return the correct failure code
     through I2CP to streaming to i2ptunnel
 * PrivateKeyFile:
   - New constructor with padding
   - New router extension to add getRouterIdentity()
   - Add validateKeyPairs()
 * Router:
   - New router.sigType config
   - Generate / regenerate router keys based on config
   - New router.keys.dat file in PKF format for sig types and padding
   - Fix RouterInfo.readBytes() signature verification with sig types
   - Catch unset padding in KeysAndCert.writeBytes()
   - Catch key errors in ReadRouterJob
   - Show RI sig type on /netdb in console
   - Move some things from Router to startup classes
   - Startup classes package private
   - Buffer readin of key files
   - Remove configurability of router.info and router.keys file locations
   - Consolidate router keys readin code
   - Update killKeys file list
   - Validate router key pairs read in from file
   - Don't try to use an unavailable sig type for the router,
     even if it's the default
 * RoutingKeyGenerator:
   - Move from core to RouterKeyGenerator in router.jar
   - Leave RoutingKeyGenerator as a simple abstract class
   - DatabaseEntry now uses timestamp instead of mod data
     to determine if mod data has changed. Don't expose
     mod data to DatabaseEntry any more.
   - I2PAppContext.routingKeyGenerator() now returns null;
     you must be in RouterContext to get a generator.
 * SSU:
   - Implement bundling of multiple fragments in a single data message.
     This has always been in the spec and implemented in the receive side
     since the beginning, so it is compatible with all versions.
   - OutboundMessageState: Fix SSU Output Queue errors in PacketBuilder:
     Remove all buffer caching as it can't be made thread-safe.
     Just allocate buffer in constructor and let GC handle it
     Do fragmenting in constructor and make all fragment fields final
     Don't track per-fragment retransmissions as it wasn't used
     Move ack tracking from an array to a long
     Sync all ack methods; Entire class now thread-safe
   - InboundMessageState: Rewrite PartialBitfield for efficiency, less space and object churn
   - PeerState.fetchPartialACKs() improvements
   - Don't allow more than 10 bytes when reading in bitfield
   - Don't send a corrupt ack packet if the partial ack got completed (race)
 * Streaming: Re-enable message status override, but treat LS lookup failure
     as a soft failure for now.
 * Transports:
   - Handle RI sig types
   - Banlist unsupported RI sig types
   - Return unused DH keypairs to the pool
 * Tunnels:
   - Enforce request record timestamp
   - Randomize timestamp to prevent hop detection at top of hour

2014-09-22 zzz
 * SSU: Fix 100% CPU after socket failure
 * UPnP: Catch reported error on FreeBSD

* 2014-09-20 0.9.15 released

2014-09-17 kytv
 * Updates to geoip.txt and geoipv6.dat.gz based on Maxmind GeoLite Country
   database from 2014-09-04.
 * Translations:
   - updates pulled from Transifex (cs, es, fi, fr, ja, nb, pl, ro, ru, uk)
   - en po files updated and pushed to Transifex

2014-09-16 zzz
 * i2psnark: Don't send HTML-only headers for icons (2nd try)

2014-09-13 zzz
 * i2ptunnel:
   - Fixes for stopping client tunnels
   - Fix status display for shared clients

2014-09-12 zzz
 * i2psnark: Escape fixes
 * i2ptunnel: Fix updating session options on a running delay-open client tunnel

2014-09-09 zzz
 * i2psnark: Escape fixes

2014-08-31 zzz
 * Build: Add support for bundling router infos in the package
 * I2PTunnel: Allow changing of spoof host and target host/port without
              restarting server tunnel

2014-08-30 zzz
 * Console:
  - Re-enable plugin installation by default
  - Don't show configuration section or update-all button if no plugins installed
  - Show unavailable crypto on /logs
 * Router: Log warnings for unavailable crypto at startup
 * RouterInfo: Backport fix for verification of EdDSA RI sig type

2014-08-28 zzz
 * Streaming: Fix verify of Ed25519 signatures in CLOSE packets

2014-08-27 zzz
 * i2psnark:
   - Persist uploaded count (tickets #1034, #1298)
   - Don't retry announce if we get back HTML
   - Recognize Vuze tracker rejections
   - Don't retry rejected announces unless seeding
   - Better UI handling of announces with ports or full destination
 * NetDB: Don't abort initialization on an unsupported RI sig type
 * Streaming: Fix P521 and RSA sig types

2014-08-23 zzz
 * Console, i2psnark, i2ptunnel: Escape fixes and cleanups
 * SSU: Drop peer tests as Bob from unestablished Alices

2014-08-22 zzz
 * SigTypes:
   - Add isSupportedSince(), use in floodfill selection
   - Handle mixed-case 25519 enum
   - Fix 25519 type code
   - Add dup type code check

2014-08-21 str4d
 * Add Ed25519 SigType

2014-08-21 zzz
 * i2psnark:
   - Escape control chars in encodePath()
   - Increase max piece size to 8 MB (ticket #1347)
 * i2ptunnel: Add local SSL support for std. and IRC client tunnels (ticket #1107)

2014-08-19 zzz
 * i2psnark:
   - Don't filter create torrent form, and
     fix exception on ':' in file names (ticket #1342)
   - Don't remap file names on torrents we created, and
     save remap setting in torrent config file (tickets #571, 771)
   - Escaping fixes since names may not be remapped
   - Use better encodePath() from Jetty
   - Don't say create torrent succeeded when it didn't
   - Add more sanity checks for base path of created torrent

2014-08-18 zzz
 * i2psnark:
   - Don't send HTML-only headers for icons
   - Catch IllegalStateException for icons
 * Tunnels: Use consistent tunnel pair for Delivery Status Message
   to reduce network connections (ticket #1350)

2014-08-15 zzz
 * Console: Escaping fix (ticket #1348)
 * I2CP: Lookup synch cleanups

2014-08-13 dg
 * Console, EventLog: add BECAME_FLOODFILL and NOT_FLOODFILL, they are now shown
   at the /events page when the router changes its floodfill state

2014-08-13 zzz
 * Console: Escaping fix (ticket #1346)
 * i2psnark: Fix add torrent NPE

2014-08-10 zzz
Prop from i2p.i2p.zzz.snarkconfig:
 * i2psnark:
   - Move config file and DHT persistence file to a config dir
   - Move per-torrent configuration from "zmeta" in the main config file
     to a per-torrent config file (ticket #1132)
   - Split timestamp and bitfield into separate configs
   - Fix misspelling of autoStart config
   - Remove two unused SnarkManager methods
   - Refactor file deletion in prep for better file name handling (ticket #571)
   - Don't use canonical files in directory listings,
     for speed and to avoid file comparison problems (tickets #1079, #1148)
   - Set base file/dir in Storage constructor, make final,
     in prep for arbitrary locations (ticket #1028)
   - Add missing nonce protection for file priority setting
   - Add torrent mime type

2014-08-10 zzz
Prop from i2p.i2p.zzz.test2:
 * Console: Show share options below 30% (ticket #1329)
 * Crypto: Move TransientSessionKeyManager from core to router.
   I2PAppContext will return the dummy SessionKeyManager which
   is sufficient for non-tag uses (e.g. Bote).
   Client use of end-to-end encryption using SessionTags was
   disabled in release 0.6, 2005-07-27.
 * KeysAndCert: Change hashcode to prevent possible collisions
   caused by apps with zeroed pubkey
 * Plugins: Start of SU3 support (ticket #1227)
 * SAM:
   - Don't spawn a thread for each transmitted datagram
   - Set protocol field for raw and signed datagrams
   - Enforce a 60s timeout for HELLO
   - Use naming service cache to reduce Destination object churn
   - Get Log object from the log manager
 * SigType: Add static isAvailable() methods
 * SSU: Speed up introductions by responding to HolePunch (ticket #1333)
 * SU3File:
   - Add support for XML and NEWS types
   - Fix NPE on EOF reading input
   - Add -x option to bypass signature verification
   - Add -k option to use specified private key cert for verification
   - Don't verify signature in showversion
 * UPnP: Disable external entities in XML parser

2014-08-10 zzz
 * Console: Hide client delete buttons unless advanced on /configclients

* 2014-08-09 0.9.14.1 released

2014-08-07 kytv
 * Updates to geoip.txt and geoipv6.dat.gz based on Maxmind GeoLite Country
   database from 2014-08-06.

2014-08-03 zzz
 * Console:
   - Fix update buttons
   - Don't filter parameter names starting with "nofilter_"
   - Re-allow configadvanced, news URL, and unsigned update URL if routerconsole.advanced=true
   - Re-allow plugin install if routerconsole.advanced=true or routerconsole.enablePluginInstall=true
   - Only allow whitelisted plugin signers, unless routerconsole.allowUntrustedPlugins=true
   - Re-allow clients.config changes if routerconsole.advanced=true or routerconsole.enableClientChange=true
   - More escaping
 * i2psnark: Fix add torrent form

2014-07-31 zzz
 * ExecNamingService: Remove
 * Plugins: Add whitelist of keys

* 2014-07-26 0.9.14 released

2014-07-26 zzz
 * Console:
   - Fix several XSS issues (thx Exodus Intelligence)
   - Add Content-Security-Policy and X-XSS-Protection headers
   - Disable changing news feed URL from UI
   - Disable plugin install from UI
   - Disable setting unsigned update URL from UI
   - Disable /configadvanced
 * DataHelper: Disallow \r in storeProps() (thx joernchen of Phenoelit)
 * ExecNamingService: Disable (thx joernchen of Phenoelit)
 * Startup: Add susimail.config to migrated files

2014-07-23 kytv
 * Updates to geoip.txt and geoipv6.dat.gz based on Maxmind GeoLite Country
   database from 2014-07-02.

2014-07-19 zzz
 * i2psnark: Don't prefer leeches during end game, to
   prevent slowdowns or stalls
 * SAM: Add support for RAW on the bridge socket in v3 (ticket #1334)
 * Streaming; Disable fail-fast for now.
 * SusiMail: Better error message on decode fail

2014-07-15 str4d
 * I2CP: Stubs for I2CP connections over Unix domain sockets

2014-07-11 zzz
 * Datagrams:
  - Redefine the repliable datagram signature for non-DSA_SHA1 sig types;
    was the sig of the SHA-256 of the payload, now the sig of the payload itself.

2014-07-03 zzz
 * Base64:
  - Catch numerous decoding errors that were previously misdecoded (ticket #1318)
  - Improve decoding efficiency, reduce copies
  - encode(String) now uses UTF-8 encoding
  - decode() now accepts short strings without trailing '='
  - whitespace in decode will now cause an error, was previously ignored
 * Console: Add event log viewer (ticket #1117)

2014-07-02 kytv
 * Update Java Service Wrapper to v3.5.25
    - Windows: x86 and x64 versions self-compiled with VS2010 in
      Windows 7. The icon has been changed from Tanuki's default to Itoopie.
    - Linux ARMv6: Compiled on a RaspberryPi using gcc 4.6.3-14+rpi1,
      Oracle Java 1.7.0+update40 and stripped
    - All other binaries are from the "community edition" deltapack offered by
      Tanuki.

2014-06-29 zzz
 * NetDB: Fix handling reseed URLs with ports (ticket #1278)

2014-06-28 zzz
 * NetDB: Add support for reseeding with su3 files (ticket #934)
 * SAM:
   - Support SIGNATURE_TYPE, bump to 3.1 (ticket #1318)
   - Private key checking fixes (ticket #1318)
   - Parameter parsing fixes (ticket #1325)
   - Cleanups

2014-06-24 zzz
 * Streaming; Drop the preliminary channel implementations,
   as they don't work and can't ever work as designed.

2014-06-23 zzz
 * Streaming:
   - Bundle new socket messages for translation
   - Fix connection error message
 * Tunnels: Reject participating tunnels when hidden (ticket #1314)

2014-06-21 zzz
 * i2psnark:
   - Display webapp name in html title (ticket #1311)
   - Use tracker from magnet link in display (ticket #1313)
   - Clarify auto-start (ticket #1293)
   - Include tracker in magnet link on details page (ticket #964)

2014-06-13 zzz
 * i2psnark: Fix NPE when fetching invalid torrent (ticket #1307)
 * Transports: Disallow Carrier Grade NAT (RFC 6598) addresses
 * Tunnels: Don't get stuck only building tunnels
   for an empty pool (ticket #1300)

2014-06-10 zzz
 * i2psnark: Fix decoding of negative numbers (ticket #1307)
 * NewsFetcher: Only treat correct status codes as success

2014-06-09 zzz
 * i2psnark:
   - Show client version if available
   - Linkify all announce URLs on details page
   - Sanitize announce URLs
 * Jetty 8.1.15.v20140411
 * Tomcat 6.0.41

2014-06-07 zzz
 * Console: Fix NPE in summary bar
 * Eepsite: Updated French help page (thx hummingbird)
 * i2psnark: Fix errors when checking read-only files
 * NetDB: Reduce negative lookup cache time
 * OCMOSJ:
   - Increase timeout if we must lookup leaseset
 * Streaming:
   - Shorter expire time in TCBCache
   - Don't fail a connection once it is up

2014-06-01 zzz
 * i2psnark:
   - Store seed/leech status in DHT tracker (ticket #1280)
   - Increase max received DHT nodes (Vuze sends more)

2014-05-31 zzz
Prop from i2p.i2p.zzz.test2:
 * Console: Fix shutdown error on old wrappers (ticket #1285)
 * CPUID:
   - Add hasAES()
   - Fix bugs in unused hasSSE3(), hasSSE41(), hasSSE42()
 * Crypto:
   - Use JVM AES when faster
   - Don't start YK thread in constructor (ticket #973)
 * HTTP client:
   - Fix 'connection reset' browser messages
     after an error in the first line (ticket #1277)
  - Add GUI options for user-agent, referer, accept
  - Disable SSL to i2p addresses by default, add GUI option
  - Fix NPE in error handler
 * I2CP: Per-message reliability settings (ticket #788):
   - Store message nonce in ClientMessage, so we may send
     a MessageStatusMessage with a failure code to the client
     without sending an ACCEPTED MessageStatusMessage first.
     All MessageStatusMessages sent in response to outbound messages will now have a valid nonce.
   - Clean up and reuse MessageState for asynch notification
   - New I2PSession sendMessage() method and listener
   - Move VerifyUsage from SimpleScheduler to SimpleTimer2 for efficiency
   - New I2PSessionException
   - Streaming PacketQueue requests status for SYNs on outbound conns
   - PacketQueue throws I2PSessionException in streams
 * i2psnark:
   - Support ports in announce URLs (ticket #1283)
   - Change "private" value in infohash from string to number,
     to match what everybody else does
   - Send seed/leech status in DHT announces (ticket #1280)
   - Extend DHT tracker expire time from 45m to 3h
   - Extend DHT announce interval from 10m to 40m
   - Increase announces from 1 peer to 4 (ticket #1281)
   - Respond to get_peers with an empty peers list instead of
     a nodes list if the requester was the only peer (ticket #1279)
   - Fix sendError() (still unused)
 * i2ptunnel:
   - Show key cert settings
   - Display custom error pages for I2PSocketExceptions (ticket #788)
   - Tag I2PSocketException text for translation (no bundles yet)
   - Move methods from superclasses to I2PTunnelHTTPClientBase
   - Fix connect client error pages, but they aren't displayed anyway
   - Don't start I2PTunnelRunner threads in constructor (ticket #973)
 * SusiMail: fix NPE (ticket #1296)
 * SystemVersion: Add isJava7() and isX86()

* 2014-05-22 0.9.13 released

2014-05-20 zzz
 * Fixes after code review
 * SSU: Fix peer test deadlock (ticket #1286)

2014-05-15 kytv
 * Translations, imported from Transifex:
   - Dutch, French, German, Italian, Japanese, Norwegian Bokmål, and Ukrainian
     translation updates
   - Start of Slovak language translation
 * Updates to geoip.txt and geoipv6.dat.gz based on Maxmind GeoLite Country
   database from 2014-05-06.

2014-05-14 kytv
 * Update the UserAgent that we send for users that go out through the outproxy
   to match that of the current Tor Browser Bundle.

2014-05-13 zzz
 * BOB, SAM, i2psnark: Fix datagram NPE (ticket #1275)
 * i2psnark: Escaping fixes on details page
 * SusiMail:
   - Fix AIOOBE (ticket #1269)
   - Don't let an exception on one mail break others

2014-05-10 zzz
 * NTCP: Fix NPE (ticket #996)
 * SusiMail: Remove deleted mails from memory

2014-05-09 zzz
 * SusiMail: Add more locking (ticket #1269)

2014-05-08 zzz
 * i2psnark: Add log message if directory does not exist (ticket #1263)
 * i2ptunnel: Display warning for duplicate client ports (ticket #1265)

2014-05-07 zzz
 * Console:
   - Add hiddengate.i2p
   - Fix console getting disabled when saving client config (ticket #1260)
 * Router: Add warning at startup if console is disabled
 * SSU: Extend establishment phase retx timeout
 * SusiMail:
   - Don't fetch headers from folder sorters
   - Update debug setting when saving config
 * Transports: Use constant time method for HMAC verification
 * Tunnels: Revert expl. OB default back to 2 + 0-1 for now

2014-05-01 zzz
 * SusiMail: js enhancements, build cleanups, css tweaks

2014-04-30 zzz
 * Plugins: Retry deletion at restart if it fails (ticket #1257)

2014-04-29 zzz
 * SusiMail:
   - Add print css
   - Hide header and footer in mobile css
   - Fix 'from' address in compose

2014-04-28 zzz
 * UDP:
   - Locking fixes on peer testing
   - Slow down peer test frequency, esp. when firewalled

2014-04-27 zzz
 * NTCP: Remove published NTCP address if SSU becomes firewalled,
         to fix the "Firewalled with NTCP enabled" message,
         broken during IPv6 implementation in 0.9.8
 * Router: Set killVMOnEnd before runRouter() (for azi2phelper)
 * RoutingKeyGenerator: Don't assume UTC (for azi2phelper)
 * SusiMail:
   - Add locking for disk cache
   - Remove cancel button from login page
   - New configuration page (ticket #1158)
   - Move set page form to configuration page
   - Theme and js enhancements
 * UDP:
   - Locking fixes on rebuilding address
   - Don't rapidly churn address when we don't have enough introducers

2014-04-25 zzz
 * SusiMail:
   - Add icons for new messages, attachments, and spam
   - Different colors for new mail and spam
   - Tweak sort button display based on current sort
   - Display image attachments inline
   - Don't rezip certain attachment types, just offer link
   - Move delete and confirmation buttons
   - Increase max size for full download again
   - Fix repeated re-saves of mail to disk
   - Enable auto-deletion of downloaded mails
   - Send delete to server for mails already downloaded

2014-04-24 zzz
 * SusiMail:
   - Add background mail checker
   - Add idle timeout connection closer
   - Rely on idle checker for most delayed deletions
   - Cleanup resources better when shutting down session
   - Don't add deleted mails to folder
   - Set socket soTimeouts
   - Display errors after check mail button pushed

2014-04-23 zzz
 * SusiMail:
   - Queue deletions for a later thread
   - Synch all folder access
   - Fix fetching of new mail

2014-04-22 zzz
 * SusiMail:
   - Add persistent cache
   - Fix encoding in sent mails on non-UTF8 platforms
   - Show sender name in folder view
   - Add support for configured sender name
   - Add HTML escaping of '&'
   - Fix Folder sorting so UP is up and DOWN is down
   - Fix capture by show page after back button
   - Load all mails from disk at startup
   - Add offline mode

2014-04-21 zzz
 * SusiMail:
   - Pipeline all deletes and quit
   - Don't reconnect after delete and quit
   - Verify connected before each POP3 operation
   - Don't clear messages if a reconnection fails
   - Use locale-based sorting for strings
   - Increase limit for full fetch again
   - Increase default page size back again

2014-04-21 dg
 * findbugs: mostly stream closure fixes in router, apps, core

2014-04-20 zzz
 * SusiMail:
   - Implement extensive pipelining in POP3 for a big speedup
     of the initial connection
   - Don't require an attachment to be "uploaded" to send it
   - Move delete attachment button, hide if no attachments
   - Save BCC-to-self preference in the session
   - Fix date format in reply
   - Close any open POP3 socket when session is unbound
   - Don't keep returning user to compose page (ticket #1252)
   - Add javascript capture of back button on compose page

2014-04-19 zzz
 * Console: Remove the classpath workarounds for SusiMail,
   since it isn't using the jetty classes any more
 * SusiMail:
   - Increase max size of mails that are fetched in full,
     previous limit was so small it never happened.
   - Move page nav to top of folder view, hide if only one page
   - Refuse to send mail with no "to"
   - Reduce default page size as it slows startup
   - CSS and layout fixes
   - Flush writes in POP3 and SMTP
   - Don't wait for SMTP response after QUIT
   - Tell the user if there are no messages
   - Fix the message view layout
   - Message view attachment cleanups
   - Pipeline USER and PASS to save a round-trip at startup
   - Better synchronization in POP3
   - Properly de-byte-stuff in POP3
   - Remove unnecessary caching in POP3
   - More efficient handling of POP3 responses
   - Remove 60s timeout for fetching a message,
     so retrieval of large messages doesn't fail
   - Use pipelining in SMTP
   - Rewrite SMTP response processing
   - Translate SMTP error messages

2014-04-18 zzz
 * configclients: Don't allow console disable
 * I2PTunnel IRC Client: Prevent AIOOBE (ticket #1254)
 * SusiMail:
   - Extend session expiration (ticket #1253)
   - Handle non-UTF8 encoding on header lines (ticket #508)
   - Display dates in current locale and time zone
   - Display sender name on message view
   - Remove sort-by-ID buttons
   - Hide "reload config" button unless config file is present
   - Increase default page size
   - Don't force reconnection on folder view (ticket #1253)
   - Button theme tweaks
   - Only show logout button on folder view
   - Add dependency tracking to build

2014-04-17 zzz
 * i2psnark: Randomize announce list order and limit size
 * SSU: SessionRequest replay prevention (ticket #1212)
 * SusiDNS:
   - Locking on config file accesses
   - Remove static log and context
 * SusiMail:
   - Button styling for prev,next,list
   - Log errors to router log too
 * Tunnels: Increase OBEP throttle limit

2014-04-06 zzz
 * NetDB: Iterative search improvements

2014-04-05 zzz
 * I2PTunnel:
   - Add server option for unique local address per-client
   - Fix changing outproxy without stopping tunnel (ticket #1164)
   - Fix add-to-addressbook hostname link in i2ptunnel (ticket #688)
 * NetDB: Skip key cert LS stores and verifies for floodfills that don't support them

2014-04-01 zzz
 * Console: Fix summary bar html when displaying an update constraint
 * NetDB: Handle RI response from non-floodfill router down a client tunnel

* 2014-03-31 0.9.12 released

2014-03-28 zzz
 * i2ptunnel.config: Remove irc.freshcoffee.i2p
 * StatManager: Don't start thread for an empty config
 * StatisticsManager: Don't publish client tunnel stats

2014-03-28 kytv
 * Updates to geoip.txt and geoipv6.dat.gz based on Maxmind GeoLite Country
   database from 2014-03-05.
 * Brazilian Portuguese, French, Norwegian, and Russian translation updates imported from Transifex

2014-03-23 str4d
 * Console: Handle stopping plugin ClientApps

2014-03-16 zzz
 * SSU: Fix corruption of introducer keys

2014-03-15 zzz
 * Certificate: Fix null cert hash code
 * Hash: Cleanup of cached hash
 * NetDB: Randomize returned DSM timestamp

2014-03-13 zzz
 * SAM: Class, field, findbugs cleanups

2014-03-12 zzz
 * Console: Handle ISO-639-2 language codes (ticket #1229)
 * I2PTunnel: Send message to client on HTTP Server OOM or out of threads
 * Streaming:
   - Track recently closed connections (ticket #1161)
   - Workaround for jwebcache and i2phex (ticket #1231)
 * Wrapper: Fix failed restarts on ARM (ticket #1230)

2014-03-08 zzz
 * PeerManager: Restore profileOrganizer.sameCountryBonus advanced config,
                inadvertently removed in 0.9.10

2014-03-07 zzz
 * Router:
   - Look for DeliveryStatusMessages beyond the message expiration,
     so we don't throw out a tagset that gets acked late
   - Allow re-adding of a "failed" tagset to the SKM
   - Extend max message age in MessageValidator
   - Remove unused and confusing timeout param when registering a selector

2014-03-06 zzz
 * Router: Encrypt DeliveryStatusMessages sent in garlics (ticket #1217)

2014-03-05 zzz
 * Transports: Don't send a duplicate store of our RI at
     start of a connection (ticket #1187)
 * NTCP:
   - Lower send priority of the RI at exchange
   - Bob will now send his RI even if he doesn't have Alice's
   - Send RI again sooner on long-lived connections

2014-03-05 str4d
 * Console: Updated website URLs in readme.html files
 * susimail: Removed remaining Jetty dependencies in susimail
   (patch from wockenfuss) (ticket #1165)

2014-02-24 zzz
 * NetDB: Slow down router refresh after startup to reduce load
   on exploratory tunnels
 * NTCP:
   - Add check for replayed session requests (ticket #1212)
   - Disable inbound check connection
   - Reduce object churn in EstablishmentManager
   - Don't pollute Hash cache in EstablishmentManager
 * Transports: Use SigUtil.rectify() in DH
 * Tunnels: Rate-limit connections at the OBEP (ticket #1134)

2014-02-23 dg
 * I2PTunnel: add 'irc.dg.i2p' to the default IRC2P tunnel (for more
   information, see http://echelon.i2p/docs/IRC2p/irc2p_userguide.txt)

2014-02-21 zzz
 * Build: Add property for target version
 * I2CP Client: Generate revocation key of same type as signing key
 * i2ptunnel: Only offer SigType options that are available in the JVM
 * LeaseSet: Add check for SigType mismatch
 * RouterAddress: Restore storage of expiration and use in signature
   calculation, broken in 0.9.3, in anticipation of using it someday
 * SigType: Add isAvailable()

2014-02-20 zzz
 * i2ptunnel: Add inproxy block option to HTTP server
 * Router: Allow null args to main() (broke Android)

2014-02-17 zzz
 * HMAC:
   - Replace BC MD5 with JVM version, refactor I2PHMAC to use
     MessageDigest instead of BC Digest (ticket #1189)
   - Use JVM HmacSHA256 instead of I2PHMAC for Syndie since it is standard
 * SSU:
   - Use session key for relay request/response if available (ticket #1206)
   - Restrict authentication with Bob's intro key to session created packet
   - Remove packetAuthTime stats
 * Initial support for key certificates and arbitrary types and lengths
   of signing keys and signatures in RouterIdentities and Destinations.
   - Fixup of Destination.create() and Destination.size()
   - Add generic off/len methods in DSAEngine, needed for streaming
   - Support i2cp.destination.sigType option in TunnelController and
     I2PSocketManagerFactory
   - Fixup of sign/verify in streaming Packet
   - Add setting in i2ptunnel server edit page (hidden for now)
   - Comment out cert setting on i2ptunnel server edit page
   - Show key type on susidns details page and LS debug page
   - Hide setting in i2ptunnel edit pages unless advanced user
   - Only store LS with key certs to routers that support it
   - Only store LS with more than 6 leases to routers that support it
 * Jetty:
   - Update to Jetty 8.1.14.v20131031, Servlet 3.0, JSP 2.2
   - Use Servlet and JSP jars from Jetty instead of Tomcat
   - Tomcat remains at 6.0.37 supporting Servlet 2.5 / JSP 2.1
   - Remove Jetty dependency in console error pages
   - Require Java 6

2014-02-14 zzz
 * I2CP:
   - Add session limit, add new status code for refused
   - Ramdomize session ID, prevent dups
   - Make SessionId immutable

2014-02-13 zzz
 * Router: Convert to getopt (ticket #1173)
 * Tunnels: Change expl. OB default to 3+0

2014-02-11 zzz
 * HTTP client proxy: Don't flush after headers for a POST,
   so the POST data is included in the SYN packet,
   to improve speed and reliability of small POSTs

2014-02-10 zzz
Prop from i2p.i2p.zzz.test2:
 * Addressbook: Rewrite subscriptions.txt for new default URL
 * Build: Honor require.gettext=false for i2prouter translations
 * Core: Add lightweight getopt command line parsing lib (ticket #1173)
 * EepGet:
   - Convert to getopt (ticket #1173)
   - New option -c for clearnet (no proxy), same as -p:0
   - Proxy option -p with host name arg only (no ':') now allowed
   - Proxy password option is now -x, not the second arg to -u
   - Prompt for proxy password if not supplied in options
   - Line length option is now -l, not the second arg to -m
   - Error on nonproxied .onion hosts
   - Update man page, sort options (ticket #1173)
   - Support Digest proxy authentication (ticket #1173)
   - Move authentication parsing method from I2PTunnelHTTPClientBase
 * EepHead, PartialEepGet, SSLEepGet: Convert to getopt (ticket #1173)
 * EepHead, PartialEepGet:
   - New option -c for clearnet (no proxy), same as -p:0
   - New option -o, same as EepGet
   - Proxy option -p with host name arg only (no ':') now allowed
   - Add proxy auth support with -u and -x options (ticket #1173)
 * I2Ping:
   - Convert to getopt (ticket #1173)
   - Add support for from/to ports
 * i2psnark: Cache PeerID.toString()
 * I2PTunnel:
   - Convert to getopt (ticket #1173)
   - Add more argument sanity checking and a usage output
 * PrivateKeyFile:
   - Convert to getopt (ticket #1173)
   - New option -e for hashcash effort, replaces -h with arg
   - Stub out -t option, to be propped from ecdsa branch
 * Streaming:
   - Set ports on many packets that were missing them
   - Use connection throttling methods on pings too (ticket #1142)
   - Add methods to set ports on pings
   - Argument checking on ping methods
 * SU3File: Convert to getopt (ticket #1173)
 * UpdateManager: Convert to RouterApp and remove update hooks from context
     (ticket #1185)

2014-02-10 zzz
 * Console:
   - Don't reset graph settings when clicking restart or shutdown on graphs page
   - Don't recommend guest login on trac, it's disabled
   - Catch and remove corrupt jrb file (ticket #1186)
   - Always set default language on /configui
 * Transports: Reduce target connection count again to reduce
               tunnel reject rate further

* 2014-02-08 0.9.11 released

2014-02-07 zzz
 * Services:
   - Move backup news to psi.i2p
   - Move default addressbook subscription to i2p-projekt.i2p
   - Remove www.i2p2.i2p from default update lists
   - Add psi.i2p to hosts.txt
   - Update links on help pages to avoid redirects on new website
     and select the correct language
 * SusiDNS: Fix whitespace issues

2014-02-06 kytv
 * Brazilian Portuguese, Danish, French, Japanese, Polish, Russian, Ukrainian
   translation updates
 * Updates to geoip.txt and geoipv6.dat.gz based on Maxmind GeoLite Country
   database from 2014-02-05.

2014-01-31 zzz
 * /logs: Fix encoding of wrapper log section (ticket #1193)
 * NetDB: Fix cases where corrupt RouterInfo files were not deleted (ticket #1190)
 * SOCKS: Remove static logs

2014-01-30 zzz
 * InboundMessageDistributor: Set reply flag on LeaseSets

2014-01-28 zzz
 * /configclients: Add link to plugins.i2p; don't show delete button for console
 * Tunnels: Change expl. IB default to 2 + 0-1

2014-01-28 dg
 * I2PSnark: Make 'kitty.png' transparent

2014-01-28 zzz
 * I2CP: Use client tunnels for b32 lookups (ticket #1166)

2014-01-27 zzz
Prop from i2p.i2p.zzz.i2cp:
 * I2CP:
   - Add support for hostname lookups over I2CP with new
     HostLookup and HostReply messages.
   - Move username / password from CreateSession to GetDate for
     early authentication; this is an incompatible chage.
     Outside router context with authentication enabled,
     new clients will not work with old routers.
     Early authentication is not yet enforced, enable with
     i2cp.strictAuth=true. Will change default to true in a later release.
   - Block all actions before authentication.
   - Better disconnect messages to clients for diagnostics
   - Improve lookup command, add auth command in i2ptunnel CLI for testing
   - Don't start ClientWriterRunner thread in constructor
   - Don't flush in ClientWriterRunner unless necessary
   - Send GetDate even in SimpleSession outside of RouterContext
   - Improve SetDate wait logic to reduce locks and break out when Disconnect received
   - Add Disconnect handler to SimpleSession
   - Add SessionID to HostLookup/Reply messages, for future
     use when we have multiple sessions
   - Throw IAE on invalid SessionID values
   - Add support for b64 conversion in destLookup()
   - Catch invalid message length sooner
 * I2Ping:
   - Extend I2PTunnelClientBase so non-shared-client,
     I2CP options, and other features will work
   - Fixes for fields and threading
   - Cleanups
 * Streaming:
   - Send LS with ping (broken since 0.9.2)
   - Set the NO_ACK flag on pings and pongs

2014-01-27 zab
 * Move message serialization later in the SSU sending pipeline
   (Ticket #1183)
 * Up version to -5

2014-01-27 zzz
 * i2ptunnel HTTP Proxy: Fix default enable for outproxy plugin

2014-01-25 zzz
Prop from i2p.i2p.zzz.outproxy:
 * i2psnark: Lower threshold for auto-stop
 * i2ptunnel HTTP Proxy:
   - Add support for HTTPS
   - Add support for outproxy plugins
 * Installer: Update links
 * NetDB: Fix NPE after client shutdown (ticket #1174)
 * Router: Lower frequency for publishing stats
 * Update: All updates via torrent

2014-01-25 zab
 * Move OutNetMessage buffer preparation to the Writer threads
   (Ticket #1183)
 * Up version to -1

* 2014-01-22 0.9.10 released

2014-01-20 kytv
 * Translation updates
 * Updates to geoip.txt and geoipv6.dat.gz based on Maxmind GeoLite Country
   database from 2014-01-08.

2014-01-20 zzz
 * Console: Change www.i2p2.i2p links to i2p-projekt.i2p
 * Reseed: Remove netdb.i2p2.de

2014-01-12 zzz
 * NetDB: Fix handling of DSRM and DSM down client tunnels

2014-01-11 zzz
 * NetDB:
   - Reduce min part tunnels for ffs to 35
   - Use client tunnels for LS lookups from OCMOSJ (ticket #1166)

2014-01-11 str4d
 * BOB: Pass through I2CP host/port (ticket #827)

2014-01-10 str4d
 * BOB: Implement ClientApp interface (ticket #347)

2014-01-09 zzz
 * Kademila: Fix NPE in remove()

2014-01-09 kytv
 * Translations
  - Updates to French, German, Romanian, and Russian
  - New Brazilian Portuguese translation
  - Mass pull of translations from Transifex
  - Update of English strings

2014-01-09 str4d
 * susimail:
  - Fixed pagination with zero entries (ticket #1168)
  - UTF-8 support from wockenfuss (ticket #508)
 * Console: Fixed overlapping text issue in midnight theme

2014-01-07 zzz
 * Streaming: Fix StandardServerSocket.close() and isClosed()

2014-01-04 zzz
 * Peermanager: Disable small same-country bonus
 * Tunnels: Change client default to 3 hops in router;
   change expl. default to 2+0 IB and 2 + 0-1 OB

2014-01-04 dg
 * Streaming: Move streaming to new package (ticket #1135)
 * Console: Change /configclients 'advanced warning' to include 'toopie, no red

2013-12-25 dg
 * Console: Add 'advanced warning' to /configclients
 * SOCKS5Server: Remove redundant, commented out line from my previous findbugs

2013-12-19 zzz
 * NetDB: Fixes for ExpireRoutersJob
  - Don't expire if too few routers
  - Don't expire if net is disconnected
  - Don't run in VMCommSystem

2013-12-15 zzz
* EepGet: Allow override of the User-Agent
* i2psnark: Set User-Agent

2013-12-14 zzz
* NetDB:
 - Just before midnight, flood to new location too so lookups
   don't fail after keyspace rotation (ticket #510)
 - Refactor RoutingKeyGenerator and UpdateRoutingKeyModifierJob
   in support of the above

2013-12-13 zzz
 * i2ptunnel: Show destination for persistent client key only if available;
              show b32 for the key as well
 * NetDB:
   - Increase new kad size to K=24, B=4
   - Fix router count by counting in the data store, not the kbuckets
   - Randomize the order we load router infos at startup so we
     don't bias the kbuckets

2013-12-10 zzz
Prop from i2p.i2p.zzz.test2:
 * Config files: Allow empty values
 * Data: Deprecate Signature.FAKE_SIGNATURE
 * GeoIP: Thread the periodic lookup so it doesn't clog the timer queue
 * I2CP router-side: Disconnect client on attempt to publish invalid leaseset
 * i2psnark:
   - Make a set of the default trackers so the config array
     can be private and the lookup for the form is more efficient.
   - Disable streaming pings (ticket #1142)
 * i2ptunnel: Disable streaming pings for clients (ticket #1142)
 * i2ptunnel IRC client: Do not filter server PING or client PONG (ticket #1141)
 * Jetty 7.6.14.v20131031
 * PeerManager: Thread the periodic reorg so it doesn't clog the timer queue
 * PrivateKeyFile: Fix ISE (ticket #1145)
 * Startup: Wait a while and recheck if a recent ping file is there,
            so that a crashed router doesn't prevent a restart (ticket #633)
 * Transport: Reduce target connections from 60% to 45% of limit
   to improve network capacity. Apparent problems with lower limits were
   actually due to unrelated bugs, fixed in 0.9.8.1-22.
 * Translations:
   - Add support for country variants (ticket #1133)
   - Refactor data in ConfigUIHelper
 * UDP PeerState: findbugs volatile/atomic/synch
Prop from i2p.i2p.zzz.netdbkad:
 * NetDB:
   - Move net.i2p.kademlia package from i2psnark to core, and convert
     netdb to use it.
   - Delete old implementation in netdb
   - Fixups in netdb for generics
   - Add debug output to /debug
 * Kad unit tests:
   - Move KBucketSetTest to new directory
   - Fix testSelf() as new implementation will never include myself
   - Delete KBucketImplTest, not applicable/useful now
   - Port KBSTest from i2p.zzz.kademlia branch
   - Fix RandomTrimmer so it always returns true, so it may be used
     as the trimmer in the unit tests

* 2013-12-07 0.9.9 released

2013-12-04 zzz
i2psnark: Fix ConnectionAcceptor not restarting after tunnel
  restart, preventing incoming connections

2013-12-01 kytv
 * Update geoip.txt based on Maxmind GeoLite Country database from 2013-11-05.
 * French, Italian, Romanian, Spanish, and Swedish translation updates from transifex

2013-11-28 dg
 * I2PTunnel: Don't send 'X-Powered-By' on HTTP server tunnels for anonymity reasons.

2013-11-25 str4d
 * Reseed: Listen to "Require SSL" config option

2013-11-23 zzz
 * i2ptunnel: Clean up old timer threads

2013-11-23 str4d
 * susimail: Fix NPE when deleting last message (ticket #414)

2013-11-19 kytv
 * Translation updates and start of Japanese translation pulled from Transifex

2013-11-14 kytv
 * Update Java Service Wrapper to v3.5.22
    - Windows: Self-compiled with VS2010 in Windows 7. The icon has been
      changed from Tanuki's default to Itoopie.
    - Linux ARMv6: Compiled on a RaspberryPi using gcc 4.6.3-14+rpi1,
      Icedtea6 6b27-1.12.5-1+rpi1 and stripped
    - All other binaries are from the "community edition" deltapack offered by
      Tanuki.

2013-11-14 zzz
 * Tunnels: Fix reception of encrypted responses to LS lookups (ticket #1125)

2013-11-07 zzz
 * i2psnark: Fix file links, broken in -12 (ticket #1114)
 * Logging: Track duplicates across flush interval (ticket #1110)
 * NetDB: Fix RI publish interval, broken in -7

2013-11-03 zzz
 * NetDB: Allow store of leaseset as long as one lease has not expired
 * Transport:
   - Expire wasUnreachable entries, so inbound tunnel build failures
     don't escalate
   - Add network status to event log

2013-11-01 zzz
 * Transport: Fix GeoIPv6 (ticket #1096)

2013-10-31 zzz
 * i2psnark: Always verify file lengths at startup (ticket #1099)
 * Transports: Increase threshold for idle timeout reduction
   (partially back out change from -10)

2013-10-29 dg
 * i2psnark: Start torrents by default (ticket #1072)

2013-10-29 zzz
 * i2psnark: Fix start and start-all buttons on text-mode browsers
   and Opera (ticket #1093)
 * InboundMessageDistributor:
   - Don't discard an encrypted DSRM received
     down a tunnel, just strip the hashes like we do for unencrypted
   - Send a store of our own encrypted LS received down a tunnel to
     the InNetMessagePool so the FloodfillVerifyStoreJob will see it.
 * NetDB: Fix LS store verifies with encrypted replies
   by storing the tagset with the correct SKM for the inbound tunnel used.
   Broken since 0.9.7 when it was introduced.
 * Tunnels:
   - Build a new exploratory fallback tunnel in the BuildExecutor
     loop if we run out.
   - Don't use closest expl. tunnel as the paired tunnel for a build,
     use a random one instead (partially back out change from -12)

2013-10-29 meeh
 * Adding no.i2p registrar

2013-10-28 dg
 * I2PTunnel: Enable persistent keying for SOCKS tunnels (ticket #1088)

2013-10-27 zzz
 * Streaming; Fix crash caused by previous blacklist fix (ticket #1070)

2013-10-26 zzz
 * i2psnark: Display base name, not torrent file name (ticket #985)
 * I2PTunnel HTTP server: New POST limiter
 * Profiles: Ensure we select random peers even before the first reorganization
 * Streaming: Randomize end of first conn limit period
 * Tunnels:
   - Don't use fallback expl. tunnels as the paired tunnel
     for a client tunnel build.
   - Fix selection of an expl. tunnel close to a hash

2013-10-25 zzz
 * Router: Only log ping file error once (ticket #1086)
 * Streaming:
   - Check blacklist/whitelist before connection limits, so
     a blacklisted peer does not increment the counters
   - Don't increment total throttle if peer is throttled
   - Fix blacklist NPE after config change (ticket #1070)
 * Transports: Reduce connection idle time sooner

2013-10-24 zzz
 * i2psnark: Drop incoming connections on HTTP port
 * I2PTunnel: Don't let uncaught exception kill server acceptor (ticket #1070)
 * I2PTunnel standard, HTTP, and IRC servers:
   Route connections to specific targets based on incoming I2P port
   with custom option targetForPort.xxxx=myserver:yyyy
   This allows multiple services on a single server tunnel (ticket #1066)

2013-10-23 zzz
 * I2PTunnel standard and IRC clients:
   - Allow host:port targets; set defaults in i2ptunnel.config (ticket #1066)
   - Don't fail start if hostname is unresolvable; retry at connect time (ticket #946)
   - Output IRC message on connect exception
   - Update target list on-the-fly when configuration changes
 * NetDB:
   - Increase RI publish interval to reduce the connection load on ffs
   - Save RI-last-published time; check it before publishing

2013-10-19 zzz
 * NetDB:
   - Reinstate ExpireRoutersJob
   - Reduce min part. tunnels for floodfill
   - Reduce floodfill redundancy

2013-10-17 zzz
 * I2CP: Move SSL client socket code to util,
   move cert location to certificates/i2cp.
 * I2PTunnel: Support SSL for connection to local server
   for Standard, HTTP, and IRC server tunnels.
   Put server cert in certificates/i2ptunnel if necessary.
 * Streaming: Throw IOE if socket is closed (ticket #1077)

2013-10-14 kytv
 * French translation updates from Transifex

2013-10-14 zzz
 * Translations: Move country names to a new resource bundle

2013-10-13 zzz
 Prop from branch i2p.i2p.zzz.test2:
 * Console:
   - Implement webapp state detection and stop button for webapps
     on /configclients (Ticket #1025)
   - Set per-connector acceptors back to 1, Jetty default changed to 2?
   - Tag strings on /jobs (ticket #969)
 * Data Structures:
   - Make Destination and RouterIdentity keys and cert immutable
   - Add Destination cache
 * i2psnark:
   - Combine getPeers and announce into a single method, as we must announce to
     the closest from the getPeers, not the closest from the kbuckets
   - Stop getPeers when nothing closer is found
   - Increase DHT dest lookup, search timeouts, and max search depth
   - Loop tracker client faster when in magnet mode or if DHT announce fails
   - Don't return an empty peers list in DHT if we only know about the requestor
   - Refactor Storage file data structures
   - Sort files when creating torrents
   - Add torrent auto-stop support; enable for update file
   - Add tunnel auto-close when no torrents are running
   - Close socket before closing output stream to avoid blocking in
     Peer.disconnect(), and prevent Peer.disconnect() loop
 * I2PTunnelHTTPServer: Don't thread a receiver for GET or HEAD
 * Jetty 7.6.13.v20130916
 * Logging:
   - Require strict match of class name component
   - parseLimits() cleanup
 * SSU: More efficient InboundMessageState
 * Streaming:
   - Fix active stream counting so it doesn't count streams
     that are closed and in TIME-WAIT state. Also, break out of the
     counting loop as soon as we know the answer. (Ticket #1039)
   - Consolidate scheduling of DisconnectEvent, and ensure
     we only do it once. (Ticket #1041)
   - Atomics for close/reset send/receive
     so we only do things once. (Ticket #1041)
   - Remove setCloseReceivedOn(), unused outside Connection
   - OR the isFlagSet parameter instead of multiple calls
   - Remove acked packets from _outboundPackets inside synced iterator
   - Short-circuit _outboundPackets iterator if empty
   - Small optimization if not logging in ConnectionPacketHandler
   - Stub out processing of close ack (ticket #1042)
   - Don't queue a message for an unknown connection on the SYN queue
     if it has a send ID set, it must be for a recently closed connection
   - Major rework of connection disconnect process. Tickets 1040-1042.
   - Prevent multiple calls or reentrancy in disconnect() (ticket #1041)
   - Implement processing of close to skip TIME-WAIT, and
     wait for all packets to be acked (not just the CLOSE) before
     doing so, if possible (ticket #1042)
   - Don't call disconnect() or disconnectComplete() from I2PSocketFull.destroy()
     so retransmissions and acks can still happen (removes some close loops)
   - Don't call disconnect() until we have both sent and received a CLOSE (ticket #1040)
   - Don't reset the connection from CPH just because we sent a CLOSE
     and it was acked (ticket #1040)
   - Ack packets even if we sent a CLOSE  (ticket #1040)
   - Retransmit CLOSE if not acked (ticket #1040)
   - Send received packets to the MessageInputStream even if we haven't received a SYN
   - Don't call MessageInputStream.messageReceived() for ack-only packets, that was pointless
   - Don't send a RESET after timeout of an outbound connection
   - Work around bugs on other end by limiting retransmission of CLOSE packets
   - Make I2PSocketFull.close() nonblocking; it will now cause any user-side
     writes blocked in I/O (Connection.packetSendChoke()) to throw
     an exception (tickets #629, #1041)
   - Don't ignore InterruptedExceptions; throw InterruptedIOException
   - MessageInputStream locking fixes
   - Make _isInbound final
   - More cleanups, javadocs, log tweaks
 * Transport: Treat more IPs as local
   - 25/8 Hamachi (moved from 5/8 Nov. 2012)
   - 2620:9b::/32 Hamachi
   - 3ffc::/16 6bone
   - 2001:db8::/32 example (RFC 3849)
   - 0::/8 Includes IPv4 compatibility addresses ::xxxx:xxxx
 * Update:
   - Support notification of updates that cannot be downloaded
     due to "constraints". Add constraint checks for java version,
     router version, configuration, and base permissions. (ticket #1024)
   - Thread news fetcher so it doesn't clog the scheduler
 * Watchdog: Format messages better

2013-10-06 zzz
 Prop from branch i2p.i2p.zzz.ecdsa:
 * Build:
   - Generate su3 file in release target
   - Add zzz's new RSA 4096 pubkey cert for updates
   - Fix checkcerts.sh
 * Console: Move advanced setting to HelperBase
 * DSAEngine changes:
   - Implement raw sign/verify for other SigTypes
   - Add sign/verify methods using Java keys
 * ECDSA Support:
   - Add ECConstants which looks for named curves and falls back to
     explicitly defining the curves
   - Add support for ECDSA to SigType, DSAEngine and KeyGenerator
   - Attempt to add BC as a Provider
   - genSpec: fallback to BC provider
 * EepGet:
   - Fix non-proxied PartialEepGet
   - Prevent non-proxied eepget for an I2P host
 * KeyGenerator changes:
   - Generate key pairs for all supported SigTypes
   - KeyPairGen: Catch ProviderException, fallback to BC provider
   - Add KeyGenerator main() tests
 * KeyRing and DirKeyRing added: simple backend for storing X.509 certs
 * KeyStoreUtil added:
   - Consolidate KeyStore code from SSLEepGet, I2CPSSLSocketFactory,
     SSLClientListenerRunner, and RouterConsoleRunner into new
     KeyStoreUtil and CertUtil classes in net.i2p.crypto (ticket #744)
   - Change default to RSA 2048 (ticket #1017)
   - Set file modes on written keys
   - Overwrite check in createKeys()
   - New getCert(), getKey()
   - Extend keygen max wait
   - Read back private key to verify after keygen
   - Validate cert after reading from file
   - Validate CN in cert
   - Specify cert signature algorithm when generating keys
 * NativeBigInteger: Tweak to prevent early context instantiation
 * RSA support added: constants, parameters, sig types, support in DSAEngine, KeyGenerator, SigUtil
 * SHA1Hash: Add no-arg constructor
 * SigType changes:
   - Add parameters (curve specs) to SigTypes
   - Add getHashInstance()
   - Add RSA, fix ECDSA
   - Renumber, rename, comment out types that are too short.
 * SigUtil added:
   - Converters from Java formats (ASN.1, X.509, PKCS#8)
     to I2P formats for Signatures and SigningKeys
   - Move ASN.1 converter from DSAEngine to SigUtil, generalize
     for variable length, add support for longer sequences,
     add more sanity checks, add more exceptions
   - Move I2P-to-Java DSA key conversion from DSAEngine to SigUtil
   - Add Java-to-I2P DSA key conversion
   - Add Java key import
   - New split() and combine() methods
 * SSLEepGet: Move all certificates to certificates/ssl, in preparation
   for other certificate uses by SU3File
 * SU3File changes:
   - Support all SigTypes
   - Implement keygen
   - Readahead to get sigtype on verify, as we need the hash type
   - Enum for content type
   - Add unknown content type, make default
   - Fix NPE if private key not found or sign fails
   - Store generated keys in keystore, and get private key from keystore
     for signing, in Java format
   - Use Java keys to sign and verify so we don't
     lose the key parameters in the conversion to I2P keys
   - Type checking of Java private key vs. type when signing
   - Use certs instead of public keys for verification
   - Fix arg processing
   - Improve validate-without-extract
   - New extract command
   - Change static fields to avoid early context init
   - Reduce PRNG buffer size for faster signing
 * Update: Preliminary work for su3 router updates:
   - New ROUTER_SIGNED_SU3 UpdateType
   - Add support for torrent and HTTP
   - Refactor UpdateRunners to return actual UpdateType
   - Deal with signed/su3 conflicts
   - Verify and extract su3 files.
   - Stub out support for clearnet su3 updating
   - New config for proxying news, separate from proxying update
   - PartialEepGet and SSLEepGet tweaks to support clearnet update
   - Remove proxy, key, and url config from /configupdate
   - More URI checks in UpdateRunner
   - Add https support for news fetch
   - Add su3 mime type
   - Reset found version in update loop so we don't fetch from
     the next host too.
   - Prevent NPE on version after SSL fetch

* 2013-10-02 0.9.8.1 released

2013-10-01 zzz
 * Startup: Fix rekeying on Windows (tickets #1056, 1057)

* 2013-09-30 0.9.8 released

2013-09-26 kytv
 * French, German, Russian, and Swedish translation updates from Transifex
 * Update geoip.txt based on Maxmind GeoLite Country database from 2013-09-03

2013-09-23 zzz
 * Console: Add /proof page which can copied to prove you run a router

2013-09-20 kytv
 * Chinese, French, German, Russian, and Swedish translation updates from
   Transifex

2013-09-17 zzz
 * Revert expl. default back to 2 hops, wait for next release

2013-09-07 zzz
 * Crypto: Don't use "short exponent" on faster platforms.
   Rebuild router identity if key length doesn't match setting.

2013-09-03 zzz
 * configui: Change pw restart warning to error so people dont miss it
 * Data: deprecate most of LeaseSetKeys
 * i2ptunnel: Reduce buffer size and use cache in HTTPServer
 * Jetty: Increase maxIdleTime
 * profiles: use different sort for floodfill profiles display
 * Utils: Consolidate maxMemory() calls

2013-08-31 zab
 * Streaming: Use only non-retransmitted packets when sampling RTT
   (Ticket 1007, RFC 6298)

2013-08-30 zzz
 * Addressbook: Don't write to log file on Android (ticket #859)
 * Addresses: Treat Teredo addresses 2001:0::/32 as local
 * Console: Display "accepting tunnels" instead of "rejecting tunnels"
            after 20 minutes (ticket #902)
 * i2psnark: Highlight table rows on hover
 * NTCP: Handle race where peer's NTCP address goes away
 * SSU, confignet: Add support for specifiying multiple addresses
 * SusiDNS: Don't require last subscription to be terminated by newline (ticket #1000)

2013-08-11 zzz
 * Jetty 7.6.12.v20130726

2013-08-11 kytv
 * Update Java Service Wrapper to v3.5.20
    - Windows: Self-compiled with VS2010 in Windows 7. The icon has been
      changed from Tanuki's default to Itoopie.
    - Linux ARMv6: Compiled on a RaspberryPi using gcc 4.6.3-14+rpi1,
      Icedtea6 6b27-1.12.5-1+rpi1 and stripped
    - All other binaries are from the "community edition" deltapack offered by
      Tanuki.
 * Translations
   - French, Portugeuse, Russian, Spanish, and Turkish updates from Transifex
   - Start of Romanian translation from Transifex

2013-08-11 zab
 * Streaming:
   - reduce initial ack delay 2000->1000
   - rework the logic of acking duplicate packets

* 2013-08-10 0.9.7.1 released

2013-08-10 zzz
 * Prop from i2p.i2p.0971
 * Update:
   - New update hosts, thanks Meeh and dg
   - Increase update-via-torrent to 30%

2013-07-30 zzz
 * i2psnark: Increase max piece size to 4 MB (ticket #993)
 * Tunnels: Extend local expiration of IB tunnels, to allow for
   more clock skew and not drop valid messages at their destination

2013-07-29 zzz
 * Signatures:
   - Prep for new signature algorithms; new SigType enum;
     Signature, SigningPublicKey, SigningPrivateKey store type
   - New Hash384 and Hash512 classes
   - Remove length field in SimpleDataStructure
   - New SU3File generator/verifier/extractor
 * GeoIPv6: Fix NPE (ticket #992)

2013-07-28 zzz
 * Addresses: Treat RFC 4193 addresses fc00::/7 as local
 * NetDB: Disable RI verifies for now

2013-07-26 zzz
 * Transports:
   - Fix IPv6-only option 2nd try
   - Treat RFC 4193 addresses fc00::/7 as local

2013-07-25 zzz
 * Transports:
   - Prefer IPv6 by default
   - Fix IPv6-only option
   - Don't try NTCP IPv6 addresses unless we have one
   - Fix non-%16 SSU padding; enable by default
 * Tunnels:
   - Make expl. default 3 hops  (ticket #966)
   - Allow expl. fallback up to -2 hops

2013-07-24 zzz
 * GeoIP: Fix lookups, broken in IPv6 branch
 * UPnP:
   - main() tweaks for debugging
   - Fix for devices that return base URLs with trailing '/' (ticket #986)

2013-07-22 zzz
 * BuildReplyHandler:
   - Make non-static
   - Don't pollute Hash cache with build response record hashes
   - Use SimpleByteCache
   - cleanups
 * HashComparator:
   - Don't pollute Hash cache with hashes
   - cleanups

2013-07-21 zzz
 * I2CP:
   - Don't NPE when loglevel=warn
   - Don't enforce property length limits when inside router JVM
 * I2PSnark: Log uncaught error in ThreadedStarter to router log
 * I2PThread: Log uncaught error to wrapper log

2013-07-20 zzz
 Prop from i2p.i2p.zzz.ipv6:
 * Addresses:
   - blocklist 192.88.88.0/24 6to4 anycast
   - invalidate 2002::/16
   - Strip scope from returned IPv6 addresses
 * Blocklist:
   - Add IPv6 in-memory single list
   - Limit in-memory single list size
   - Fix dup check in getAddresses()
 * CSFI: Pass TransportManager instead of CSFI to GetBidsJob; remove unused methods
 * Console:
   - Add IPv6 column on /peers
   - Other minor /peers cleanup
 * FloodfillPeerSelector, ProfileOrganizer: Use 8 bytes for IPv6 check
 * GeoIP:
   - Use cached IP in RouterAddresses
   - Use both NTCP and SSU addresses
 * GeoIPv6:
   - Handle gzipped input data in merge tool
   - Add script to generate compressed data
   - Add local additions
   - Add compressed data file, generated from Maxmind data fetched 2013-05-24
   - Include data in installer and updater
   - Update Maxmind license info, now CC-SA 3.0
   - Enable GeoIPv6 lookup in CSFI
 * NetDb:
   - Add floodfillEnabled() to NetworkDatabaseFacade so callers don't
     have to cast to FNDF, and Dummy NDF will work
   - Remove static FNDF.floodfillEnabled()
 * NTCP:
   - Move SSU address notification handling from CSFI to NTCPTransport
   - Drop NTCPAddress, just use RouterAddress
   - Drop _myAddress field, use super's currentAddress
   - Bad bind config not fatal
   - Fix publishing address when host specified but interface is not
   - Republish even if only changing cost
 * PacketPusher: Minor optimization
 * Peer tests:
   - Use only IPv4 peer for Alice and Bob in peer tests; Charlie may be an IPv6 peer.
   - Enforce IPv4 (Alice's) address inside PeerTest packet
 * RouterAddress and RouterInfo toString() cleanups; don't cache RI in _stringified
 * RouterAddress:
   - hashCode/equals tweaks
   - Add new constructor
   - Add add getHost() and deepEquals()
   - Compare host string, not IP, in equals()
   - Deprecate some setters
   - Add warning about setCost()
   - Change cost storage from int to short
   - Cost range checks
 * RouterContext: Fix disabling client manager with i2p.dummyClientFacade=true
 * SSU:
   - Change from single UDPEndpoint to a List of UDPEndpoints
   - Move (single) receive queue from UDPReceiver to PacketHandler
   - Multiple transmit queues (one for each UDPEndpoint/UDPSender),
     select queue in PacketPusher
   - Throw exception on UDPEndpoint.startup() failure
   - Remove all _external* fields; use _currentAddresses in super
   - Big rework of externalAddressReceived(), rebuildExternalAddress(),
     needsRebuild(), and replaceAddress() for multiple addresses and IPv6
   - Add caching in UDPAddress
   - More IPv6 flavors of utility methods
   - Remove two-arg replaceAddress()
   - Fixes for i2np.udp.allowLocal, log tweaks, sender/receiver thread name tweaks
   - Handle IPv6 in too-close checks
   - IPv6 SSU MTU adjustments
   - Hash IPv6 addresses in IPThrottler
 * SSU Introduction:
   - Document that Alice-Bob RelayRequest/RelayResponse may be IPv4 or IPv6,
     but don't implement IPv6 yet.
     Changes required in IntroductionManager and PacketBuilder to send Alice's
     IPv4 address in the RelayRequest packet over IPv6, and to publish
     IPv6 introducer IPs.
   - Bob-Charlie RelayIntro must be IPv4
   - Only offer/accept relay tags as Bob or Charlie if the Bob-Charlie session is IPv4
   - Alice-Charlie communication must be IPv4
 * SSUDemo:
   - Configuration fixes, delete RI on exit, log tweaks, cleanups
   - Use IPv6; don't use System properties
   - Adapt for NTCP testing too
 * Tests:
   - New buildTest and prepTest targets
   - Fix UDPEndpoint usage in unit tests: Restore receive(); Handle null UDPTransport
   - Fix UDPEndpointTestStandalone: init context; Add unit test buildPacket() method to PacketBuilder;
     Fix NPE in MessageHistory
 * Transports:
   - Add new TransportUtil for getting/setting IPv6 config
   - Prep for supporting multiple RouterAddresses per-transport
   - Prep for multiple address discovery
   - Fix multiple-detection code in externalAddressReceived()
   - Synchronize tracking of last IP/port
   - Don't accept IPv6 address changes from peers
   - Remove unused getLocalAddress()
   - Pkg private getLocalPort()
   - Start transports in a standard order to make testing easier
   - When transports learn of interface addresses before being started, save them
     and use them at startup
   - Pick SSU random port before startListening() and have the TransportManager
     pass it to NTCP before starting
   - Only restart NTCP after changing addresses when necessary;
     prevent thrashing at startup (ticket #459)
   - Always bind NTCP if we have port; not just when not firewalled
   - Only call rebuildRouterInfo() once at startup
   - More checking of min/max SSU port config
   - Invalid SSU bind config no longer fatal
   - Allow "true" for ipv6 config
   - SSU fixes for per-address and IPv6 MTU
   - MTU.main() print all interfaces
   - Add i2np.disable property for testing
 * Transports:
   - Sort multiple peer addresses by cost, with adjustment for local IPv6 preference
   - Add default IPv6Config for ease of changing later
   - Only treat IPv6 addresses as valid if we have a public IPv6 address
 * Tunnel GW pumper: Limit threads when testing
 * UDPAddress:
   - Reduce object churn, check intro key length,
     don't look for ihost3, reject ports < 1024, cleanups
   - Remove dependency in console; make package private
 * UPnP:
   - Fix UPnP address received before startListening(), broken by isAlive() check
   - Pass device IP back in forward port callback
   - Only declare success if forwarded IP is public

2013-07-20 zzz
 Prop from i2p.i2p.zzz.test2:
 * DHSessionKeyBuilder: Fix for session and mac keys if DH key is between 32 and 63 bytes.
   Was: NPE. Now: mac key is hash of session key. Won't ever happen. (Ticket #963)
 * I2CP/I2PTunnel locking fixes (partial fixes for tickets 650. 722, 815, 946, 947, 953):
   - I2PSocketManagerFactory: New createDisconnectedManager(), javadocs
   - I2PSessionImpl: Rewrite state management and locking, prevent multiple
     connect() calls, but allow disconnect() to interrupt connect()
   - I2PSimpleSession: Changes to match I2PSessionImpl
   - I2PTunnelServer: Don't connect in constructor, use createDisconnectedManager()
     for a final manager, finals and cleanups
 * ClientManager:
   - Make classes extensible for router-side test stubs
   - Add router-side local-only test implementation, no full router required.
     Only tested with external clients, probably doesn't work in-JVM.
   - Don't start threads in ClientManager constructor
   - Remove unused Reader param in ClientMessageEventListener methods
   - Cleanups, volatiles, finals, javadocs
 * Translations:
   - New varargs method in Translate
   - New TranslateReader to translate static files on-the-fly using _("") tagging
   - Tag proxy error pages for TranslateReader
   - Drop static translated proxy error pages
   - Add new i2ptunnel bundle for the proxy alone, shipped in the jar.
   - Use TranslateReader in HTTP proxy for error pages
   - Move HTTP proxy strings from the web (war) to proxy (jar) bundle so they will be loaded
     Fixes translations for the lower half of the proxy pages that weren't accessible in the war.
   - Initial translations created by msgmerge from i2ptunnel and routerconsole po files, un-fuzzied
   - Tag initialNews.xml for TranslateReader
   - Drop static translated initialNews pages
   - Add new routerconsole bundle for the news alone, shipped in the jar
   - Use TranslateReader in HTTP proxy for initial news
   - Initial translations created manually from translated xml filesx
   - Add translated proxy error pages and initial news to deletelist.txt
 * Transports: Consolidate translation methods in TransportImpl;
   ngettext fix for "peers" string


2013-07-19 zzz
 * PRNG:
   - Don't delay the refiller if we need more (don't limit max output)
   - Add FortunaRandomSource.main() to output to stdout for testing e.g. with dieharder

2013-07-19 zab
 * Streaming:
   - initialize streaming RTT from sample, trac #979, RFC 6298
   - store rttDev in TCBCache

* 2013-07-15 0.9.7 released

2013-07-11 kytv
 * Chinese, Russian, Spanish, and Turkish updates from Transifex
 * Update geoip.txt based on Maxmind GeoLite Country database from 2013-07-02

2013-07-11 str4d
 * susimail: Improvements to layout in mobile browsers

2013-07-06 zzz
 * TunnelPool: Don't reuse peers for exploratory tunnels

2013-07-04 zzz
 * Streaming:
   - Don't stop timers when session disconnects (tickets #644, #810)
   - Throw exception on attempt to use destroyed socket manager

2013-07-03 zzz
 * Console: Hide dead tunnel pools on /tunnels
 * Updater: Fix plugin update checker (ticket #897)
 * Utils: Reduce logging in wrapper log when extracting zip files

2013-06-30 zzz
 * BuildHandler: Drop build request with bad flags

2013-06-28 zzz
 * i2psnark:
   - Show more metadata on details page
   - Fix rar icon
   - More URL escaping

2013-06-23 zzz
 * i2psnark: When receiving a metainfo via magnet and saving it to disk,
   preserve all non-standard fields (such as those created by Robert) so the
   infohash doesn't change on restart and split the swarm.

2013-06-22 zzz
 * SSU:
   - Pad messages with random data instead of zeros
   - Implement non-mod-16 padding, disabled for now

2013-06-22 meeh
 * I2PTunnel: Change connect proxy default to outproxy-tor.meeh.i2p after h2ik's AWOL

2013-06-21 zzz
 * Crypto: AES decrypt speedups
 * NetDB, i2psnark: Speed up XORComparators
 * SSU: Ignore non-mod-16 padding

2013-06-20 zzz
 * i2psnark: Show start-all button even if tunnel is open,
   if at least one torrent is stopped (ticket #808)

2013-06-17 zzz
 * Console: Don't display 'unsupported' message when restart button clicked
 * I2CP: Don't send SendMessageEndMessages from client to router if
         in fast receive mode and the router doesn't require them.
 * NetDB:
   - Don't instantiate unused success job for republish LS
   - Add debug setting to encrypt RI lookups
 * NTCP: Extend interval for sending time sync messages
 * SusiMail: Fix classpath problem when started manually (ticket #957)

2013-06-14 zzz
 * I2CP: Fix deserialization of new RVLSM; enable by default
 * i2psnark: Fix bug creating torrent with a single file in a directory

2013-06-12 zzz
 * Console: Add missing jetty jars to classpath (ticket #952)
 * I2PTunnel: Add advanced quantity options

2013-06-10 kytv
 * Translations (from Transifex)
   - Start of Turkish language translation
   - Update to French translation

2013-06-10 zzz
 * Installer: Don't install Windows service by default
 * NetDB: Let class N routers become floodfill; scale max connections for non-O floodfills
 * Transports: Reduce idle timeouts to mitigate conn limit issues

2013-06-09 zzz
 * NetDB: Prep for leasesets with different expire times
   - Add new I2CP RequestVariableLeaseSetMessage
   - Send RVLSM if client supports it; handle on client side;
     disabled by default for the moment.
   - Add LeaseSet.getLatestLeaseDate()
   - Check latest, not earliest, date too far in future in KNDF.validate()
   - Check latest date too far in past in KNDF.validate()
   - Only check gateway and tunnel ID for equality in OCMOSJ lease caching to reduce churn
   - Split up KNDF.validate(RI) for efficiency, don't need to check
     signature, netid, etc. before lookups, only on store
   - Remove enforeNetID config
   - Fix major bug causing newer leasesets to be treated as older, and not stored or published
   - Increase max adjustment time of earliest lease
   - TransientDataStore cleanups
   - RouterInfo and LeaseSet equals() speedups

2013-06-07 zzz
 * BlockfileNamingService:
   - Fix bug that kept reverse index from being updated
   - Bump DB version to 3 to trigger repopulation of the reverse index
   - Make metaindex final
   - Add freelist check to the main() test

2013-06-06 zzz
 * BuildRequestRecord: Don't waste entropy on bytes we will overwrite

2013-06-05 zzz
 * DatabaseLookupMessage: Change format for encrypted reply request
   to allow multiple bundled reply tags
 * I2CP: Save client version for future reference
 * InboundMessageDistributor: Cleanups
 * LeaseSet: Don't allow changes after signature added
 * NetDB:
   - Debugging option for encrypting RI lookups
   - Remove unused classes

2013-06-01 zzz
 * EepGet: Used cached byte array in uncompressor
 * i2psnark:
   - Add idle detector, reduce tunnel count when idle (prep for torrent updates)
   - Cancel CoordinatorAcceptor cleaner when halted
   - Make PeerCoordinatorSet an Iterable
   - Reduce max protocol errors to 1
   - Disable unused PeerMonitorTask

2013-05-31 zzz
 * configtunnels.jsp: Allow more hops and tunnels when routerconsole.advanced=true
 * i2psnark: Fix details page on Windows
 * NetDB:
   - Add DLM fields for requesting an encrypted reply
   - Add support for encrypted DSRM and DSM in response to a DLM
   - Fix netDb.alwaysQuery debug setting so it works again, and always
     sends to that router first (move from FNDF to IterativeSearchJob)
 * PRNG: Cleanups using Collections.singletonMap()
 * Router utils: New RemovableSingletonSet
 * TransientSessionKeyManager:
   - Support variable expiration for inbound tag sets
   - Several efficiency improvements
 * VersionComparator: Add static method, use most places

2013-05-30 kytv
 * Update Java Service Wrapper to v3.5.19
    - Windows: Self-compiled with VS2010 in Windows 7. The icon has been
      changed from Tanuki's default to Itoopie.
    - Linux ARMv6: Compiled on a RaspberryPi using gcc 4.6.3-14+rpi1,
      Icedtea6 6b27-1.12.5-1+rpi1 and stripped
    - All other binaries are from the "community edition" deltapack offered by
      Tanuki.
 * Allow themes to be used in IE >= 10

2013-05-29 zzz
 * Console: Remove I2PDigestAuthenticator workaround, as Jetty 7.6.11 has the fix
 * i2ptunnel: Default to 3 hops (ticket #936)
 * Jetty 7.6.11
 * Tomcat 6.0.37

* 2013-05-28 0.9.6 released

2013-05-24 kytv
 * Update geoip.txt based on Maxmind GeoLite Country database from 2013-05-08

2013-05-13 kytv
 * Misc. fixes to i2prouter script
 * German translation updates from Transifex

2013-05-13 zzz
 * i2psnark:
   - Adjust target piece size calculation
   - Tweak to make it easier for new peers to connect
 * NetDB: Increase floodfill count for good
 * UPnP: Detect devices without port forwarding capability (ticket #930)

2013-05-07 zzz
 * Streaming: Chain stored IOE to get correct location

2013-05-06 zzz
 * Console: Fix Jetty thread pool policy and thread name
 * Transports: Clean up internal/external port confusion (ticket #873)
   - Bind SSU to configured internal, not external, port at startup
   - Use only internal ports for UPnP (getRequestedPort() fixups)
   - Don't have NTCP follow frequent SSU port changes
   - Don't use external SSU port for internal NTCP port
   - Display internal SSU port on /confignet

2013-05-01 zzz
 * BuildRequestor: Slow down build loop if we have no exploratory tunnels
                   (ticket #926)
 * IRC Server tunnel: Reject bad protocols immediately

2013-04-30 str4d
 * Console: Updates to readme_ar and a CSS tweak from hamada (ticket #489)

2013-04-29 zzz
 * Transports:
   - Initial prep for multiple addresses per style
   - Simplify NTCP send pool

2013-04-28 zzz
 * i2psnark:
   - Improve page nav
   - Ensure current stats and correct event delivered in announce
   - Only show lower section on first page
   - Dir page CSS tweaks
   - Parameter fixes
   - Support HTTP request ranges

2013-04-26 zzz
 * Console: Show log location on /logs even if not opened yet (ticket #905)
 * HTTP proxy: Verify nonce count in digest auth
 * i2psnark: Use smaller piece size for small torrents
 * installer: Fix DOS line endings on misc. files (ticket #872)
 * Plugins: Track pending plugin clients better, don't hold references,
            start delayed clients from SimpleTimer2 instead of Job queue (ticket #670)
 * SusiDNS:
   - Trim and sort config form data
   - Fix DOS line endings on config files in Linux (ticket #872)

2013-04-25 kytv
 * Portuguese, Russian, Spanish, and Swedish translation updates from Transifex

2013-04-25 str4d
 * i2ptunnel: Allow the "AUTHENTICATE" command in IRC tunnels to enable SASL
              authentication (ticket #904)

2013-04-24 zzz
 * Console, i2ptunnel: Don't register shutdown hook if ClientAppManager is present
 * JettyStart: Fixes for use by plugins
 * RouterAppManager: Add shutdown hook

2013-04-23 zzz
 * Console: Fix Jetty digest auth bug causing repeated password requests
 * i2ptunnel: Block b32.i2p supercookies

2013-04-21 zzz
 * AppManager: Add HTML debug output
 * Installer: Fix installations to a different drive on Windows
   (prop from i2p.i2p.zzz.winfix095; ticket #912)
 * Streaming: Pcap window size fixes

2013-04-21 str4d
 * i2ptunnel: Return "Invalid Request URI" instead of "Non-HTTP Protocol" for
              URIs with illegal characters (ticket #891)

2013-04-19 kytv
 * Installer: Run fixperms.bat under any version of Windows that's not XP or
   2003 to ensure it's run under Vista, 7, 8, and the upcoming "Blue"

2013-04-19 zzz
 * AppManager: Register jetty, console, and SAM with manager
 * i2psnark: Disable spellcheck in more form fields
 * LogManager: Add support for saving properties added in recent releases
 * Updates:
   - Notify manager about all available update methods at once, so the priority
     system works and it doesn't only update via HTTP
   - Start router update download at startup if available
   - Only check plugins when core version increases, not decreases, so we
     don't update plugins when downgrading
   - Limit length of URL shown on summary bar
 * WorkingDir: Correctly strip DOS line endings while migrating,
               to fix eepsite location on 0.9.5 Windows installs (ticket #919)

2013-04-18 zzz
 * i2psnark: Fix params after P-R-G
 * i2ptunnel: Set target=_top in all external links to break out of console iframe
 * SusiMail: Fix loading of Jetty classes

2013-04-17 zzz
 * Console: Better handling of missing font for graphing (ticket #915)
 * Eepsite: Fix jetty.xml configuration of ThreadPool
 * i2ptunnel: Fix default form action (ticket #882)
 * SusiDNS: Set target=_top in all external links to break out of console iframe
 * Systray: Better detection of 64-bit Windows (tickets #756, #912)

2013-04-16 zzz
 * ClientAppManager: Add method to look up clients by class and args
 * Console: Implement stopping of clients using the ClientApp interface
            (ticket #347)
 * SAM: Implement ClientApp interface (ticket #347)

2013-04-15 zzz
 * Console: Move from deprecated Jetty SSL methods to SslContextFactory
 * i2psnark:
   - Add data directory configuration to GUI (ticket #768)
   - Add page size configuration to GUI
   - Multiple instance DHT file cleanup
   - Mime type fixes
   - Remove web classes from jar

2013-04-14 zzz
 * i2psnark:
   - Set unique tunnel nickname for additional instances
   - Increase page size to 50
 * Jetty logging: Fix logging using I2PLogger class;
   log ignored messages at debug level

2013-04-13 zzz
 * Console: Add /graph support for bw.combined, consolidate
            rendering code (ticket #890)
 * i2psnark:
   - Limit number of torrents displayed; add previous/next page buttons
   - Only register one instance with UpdateManager

2013-04-10 zzz
 * Jetty: Upgrade to Jetty 7.6.10.v20130312
    - Jetty build.xml improvements
    - MigrateJetty improvements
    - Lots of changes in RouterConsoleRunner and WebApp classes
    - Lots of eepsite config file changes
    - Changes to I2PLogger and I2PRequestLog
    - Use JettyStart class to start Jetty from clients.config
 * i2psnark: Eliminate Jetty dependencies in i2psnark for good.
    Required due to webapp classloader changes in Jetty 7,
    we can no longer access or extend Jetty classes.
    - Extend javax HttpServlet instead of Jetty's DefaultServlet
    - Implement BasicServlet to replace functions of DefaultServlet
    - Add MimeTypes implementation to add to servlet's defaults
    - Add local mime.properties file, remove checks in I2PSnarkServlet for those
      we were missing
    - Eliminate all use of Jetty utility classes including MimeType, Resource,
      Buffer, Cache, URIUtil, ...
    - Use servlet path everywhere, so the war can be renamed
    - Use servlet path as base for config file and data directory names,
      so we may have multiple instances running together
    - Don't override service(), use doGet() and doPost() instead
 * I2NP: Ignore unused 7 bits of the Database Lookup Message,
   so we can use them later

* 2013-03-08 0.9.5 released

2013-03-03 zzz
 * graphs.jsp: Fix saving settings (ticket #857)

2013-03-03 kytv
 * Update geoip.txt based on Maxmind GeoLite Country database from 2013-02-19

2013-02-22 kytv
 * French, German, Norwegian, and Portuguese translation updates from
   transifex.

2013-02-13 kytv
 * Flag for Curaçao (CW), public domain

2013-02-12 zzz
 * NetDB: Randomize delay before floodfill store verify

2013-02-10 zzz
 * Logs: Again fix setting log filename (ticket #805)
 * Update: Bump torrent update to 3% of routers
 * Wrapper: Update ARMv6 Java Service Wrapper to v3.5.17 (ticket #826).

2013-02-09 zzz
 * NetDB:
   - Encrypt DatabaseLookup messages out exploratory tunnels
     when we already have the RI of the ff
   - Don't use multiple routers from the same /16 in lookups or stores

2013-02-06 kytv
 * German, Polish, Portuguese, Spanish, and Swedish translation updates
   from Transifex

2013-02-04 str4d
 * i2ptunnel:
   - IP -> domain name mapping in SOCKS client tunnel:
     - Change SOCKS5 addressType on a successful mapping
     - Allow any domain name to be mapped, not just .i2p

2013-01-31 kytv
 * Add Norwegian Bokmål language to the router console
 * Add Bokmål translations from Transifex

2013-01-31 zzz
 * EepGet:
   - Fix URL when not proxied to conform to RFC 2616
   - Add port to Host header to conform to RFC 2616

2013-01-29 zzz
 * Console: Catch IllegalStateException storing nonces (tickets #836, #852, #858)
 * Translations:
   - Use JVM language name if available
   - Correct Estonian language code from ee to et

2013-01-27 zzz
 * BuildHandler:
   - Add early throttler based on previous hop
   - Limit concurrent next-hop lookups
 * NetDB: Increase floodfills again
 * RandomSource: Seed from SecureRandom too

2013-01-23 str4d
 * i2ptunnel: Added IP -> I2P URL mapping to SOCKS client tunnel
   (via custom option ipmapping.IP=URL)

2013-01-21 str4d
 * Console:
   - Added option to /configui to force the mobile console to be used
     (for cases where the UserAgent matching fails)
   - Added Opera Mobile to list of mobile UserAgents
   - Added a link to the summary bar for mobile users on /home

2013-01-19 str4d
 * Console:
   - Added proper support for mobile browsers with a CSS override file
     for each theme
   - Tweaked UserAgent detection so Android tablets get normal console

2013-01-17 kytv
* Hungrarian, Italian, Portuguese, Russian, and Swedish translation updates
  from Transifex

2013-01-12 zzz
 * EepGet: Don't retry if proxy isn't there
 * I2CP: Failsafe check for delivery job requeueing forever (ticket #819)
 * jobs.jsp: Add table of pending jobs
 * NetDB: Split up files into subdirectories
 * SAM: Force i2cp.messageReliability=None (ticket #819)

2013-01-02 zzz
 * DataHelper: new getASCII() method
 * DataStructures:
   - Convert SessionTag.hashCode() to SipHash to prevent collision attacks
   - Improve equals()
 * I2CP:
   - Remove unused equals() methods for message classes
   - Remove static logs
   - Fix leak if nonce = 0 but reliability != none (ticket #819)
   - More work on failure codes (ticket #788)
 * Logs: Fix setting log filename (ticket #805)
 * SAM: Synchronize dissector
 * Transport: Fix early NPE (ticket #824)

2013-01-01 kytv
 * Update Java Service Wrapper to v3.5.17 (ticket #826).
    - Windows: Self-compiled with VS2010 in Windows 7. The icon has been
      changed from Tanuki's default to Itoopie.
    - FreeBSD: Self-compiled in FreeBSD 7.4 to eliminate the dependency on the
      compat6x port.
    - Linux x86, Linux x64, Linux ARMv5, Linux-PPC32, MacOSX & Solaris: Binaries
      are from the "community edition" deltapack offered by Tanuki. The Linux
      binaries have been stripped.

2012-12-29 zzz
 * i2psnark: Redirect after post
 * Javadocs: Fix javax links
 * Tunnels: Handle duplicate tunnel IDs (ticket #812)

2012-12-26 zzz
 * I2CP:
   - Prep for delivery of detailed failure codes to the client (ticket #788)
   - Minor optimizations and cleanups
 * i2psnark: Create torrent form tweaks
 * NetDB: Split routerInfo files into subdirectories, disabled for now,
   enable with router.networkDatabase.flat=false
 * Stats: Clean up some duplicate createRateStat calls (ticket #787 comment 2)
 * Tunnels: Catch rare BuildExecutor IAE only in Java 7 (ticket #811)

2012-12-24 kytv
 * Javadocs: Fix javadoc errors in the cybergarage package. Upstream bug #3598391 has been
   filed for this issue.  If these javadoc fixes need to be reverted in the future,
   MTN rev 5bdb7fc27e35f174001bd6105a502fd5094842e5 covers it.

2012-12-22 zzz
 * i2psnark: Add announce list support (BEP 12) (ticket #778)
 * i2ptunnel: Add more tunnel quantity options for servers
 * Jetty: Update to Apache Tomcat 6.0.36

2012-12-22 kytv
 * French language translation update from Transifex

2012-12-19 zzz
 * Update: Hide the update buttons when router.updateDisabled=true, as is the case
   for Debian packages. Broken in 0.9.4. (Ticket #817)

* 2012-12-17 0.9.4 released

2012-12-14 kytv
 * German and Swedish translation updates from Transifex
 * Update geoip.txt based on Maxmind GeoLite Country database from 2012-12-04

2012-12-11 zzz
 * Wrapper: Use Tanuki's binary for armv7

2012-12-08 zzz
 * susimail: Button CSS tweak

2012-12-07 zzz
 * RouterClock: Reduce log level (ticket #790)

2012-12-05 zzz
 * GarlicMessage: Fix notes and log in GarlicMessageHandler and HandleGarlicMessageJob,
   they are used for netdb messages received by floodfills http://zzz.i2p/topics/1282
 * I2CP: Fix external I2CP apps, including i2ping, caused by 0 nonce value,
   broken in 0.9.2 (tickets #799, #801). Allow nonces == 0.
 * Reseed: Don't go on to the next host if we have enough http://zzz.i2p/topics/1287
 * SSU: Fix rare NPE (ticket #798)

2012-11-28 kytv
 * Chinese, French, Italian, Polish, and Ukrainian translation updates from
   Transifex.

2012-11-24 zzz
 * Addressbook: Disable unused wakeup via http
 * Codel: Make stats non-required (ticket #786)
 * Profiles: Small optimization in coalesceOnly() (ticket #765)

2012-11-21 zzz
 * Wrapper: Add armv6 files for Raspberry Pi

2012-11-21 kytv
 * Update Java Service Wrapper to v3.5.16.
    - Windows: Self-compiled with VS2010 in Windows 7. The icon has been
      changed from Tanuki's default to Itoopie.
    - FreeBSD: Self-compiled in FreeBSD 7.4 to eliminate the dependency on the
      compat6x port.
    - Linux PPC32: Self-compiled in Debian Squeeze
    - Linux x86, Linux x64, Linux ARMv5, MacOSX & Solaris: Binares are from the
      "community edition" deltapack offered by Tanuki. The Linux binaries have
      been stripped.

2012-11-20 zzz
 * Transport: Fix bug that inadvertently reduced default max
   SSU connections in 0.9.2, thus reducing tunnel build success rates

2012-11-19 kytv
 * Add support for kFreeBSD to NBI and CPUID
 * Improve kFreeBSD support in jcupid/jbigi scripts

2012-11-19 zzz
 * BuildHandler: Disable CoDel, wasn't helping
 * NetDB: Add negative lookup cache
 * Profiles: Split up files into subdirectories

2012-11-17 zzz
 * error500.jsp: Add servlet version
 * i2psnark: Clear PEX peers set after use, cause of bad peer counts
 * Tunnels: Set default priorities for tunnels (ticket #719)

2012-11-16 zzz
 * i2psnark: Fix rare IOOBE (ticket #777)
 * NetDB:
   - Implement automatic reseeding (ticket #521)
   - Increase minimum routers
   - Log reseeds in event log
 * Tunnels: Fix outbound tunnel message priority (ticket #719)

2012-11-13 zzz
 * Bandwidth Limiter: Fix stats broken in -1
 * HTTP Proxy: Store referrer of new addresses in address book
 * NTCP:
   - Fix NPE (ticket #770)
   - Use ByteCache for buffers
 * SOCKS: Reduce log level of connect errors
 * SSU: Fix bug that would drop 512 byte messages
 * stats.jsp: Link to graph page, not single image

2012-11-10 kytv
 * eepget: Add logic to figure out the path to java.exe (java isn't always added to the system path
   in Windows) (ticket #769)

2012-11-05 zzz
 * Console:
   - Fix NPE after restart (ticket #763)
   - Move more nonces out of system properties
 * i2psnark:
   - More DHT limits
   - Announce to backup trackers if DHT is empty
   - Use PEX and DHT info in torrent peer count
   - Don't use temp files for announces
 * PeerManager: Don't reorganize as often if it takes too long (ticket #765)
 * RequestLeaseSetJob: Only disconnect client after multiple dropped
   lease set requests; reduce timeout, other cleanups
 * Unsigned Update: Fix notification on failure

2012-11-02 kytv
 * German, Portuguese, and Swedish translation updates from Transifex
 * Refreshed English po files to push to TX.

2012-11-02 zzz
 * configstats: Fix group sorting, translate groups
 * I2CP:
   - Better fix for logging dropped messages (ticket #758)
   - Implement fast receive to reduce per-message handshakes
   - Make messageReliability=none the default
 * i2psnark:
   - Split buckets correctly
   - More exploration fixes
 * i2ptunnel:
   - Better privkey backup file name
   - Revert increment of privkey tunnel name
   - Move deleted privkeys to backup dir
   - Fix jsp build dependencies
   - Fix layout issue on Chrome (ticket #757)
 * KeyManager: Eliminate races, buffer I/O, eliminate periodic syncing

2012-10-31 zzz
 * FIFOBandwidthRefiller: Reduce refill interval to smooth output
 * I2CP: Reduce log level when outbound queue is full (ticket #758)
 * i2ptunnel: Fix NPE in zzzot plugin
 * PriBlockingQueue: Enforce max size
 * Streaming: New disableRejectLogging option (default false), enable for snark

2012-10-30 zzz
 * i2psnark:
   - Add kbucket debugging
   - Eliminate redundant explore keys
   - Add more limits to DHT tracker
   - Delay expiration at startup
   - Only enable updates for dev builds and 1% of release builds
 * i2ptunnel:
   - Create backup privkey files (ticket #752)
   - Fix NPE in Android startup
 * Installer: Drop news.xml and old certs
 * logs.jsp:
   - Don't display dup message if last
   - Spacing tweaks
 * OutNetMessage: Properly clean up when dropped by codel (but unused for now
   since codel is disabled for ONM)
 * SSU:
   - Adjust RTT/RTO calculations
   - Better bandwidth tracking
   - Cleanup of OutboundMessageState
   - Stat tweaks
 * StatisticsManager: Publish stats less often
 * Transports: Increase min peer port to 1024
 * Tunnels: Implement per-client outbound tunnel message priority (ticket #719)
 * Update Manager: Warn on dup registration

2012-10-30 sponge
 * cleanups as requested

2012-10-28 zzz
 * Addresses:
   - Add methods for connectivity detection
   - Remove Hamachi restriction
 * Banlist: renamed
 * Clients: New interface for clients started via clients.config, and a new
   manager to track the lifecycle and start/stop clients on demand.
   (ticket #347)
 * Console:
   - Add console password form to configui.jsp
   - Consolidate all the jsp formhandler boilerplate in the new formhandler.jsi
   - Store form handler nonces in the servlet session instead of system properties,
     to prevent cross-session interference
   - Bypass nonces if console password enabled
   - Remove ports from port mapper on shutdown, other changes to
     track actual ports better (ticket #731)
   - Prep for RouterApp interface by storing context in a field,
     shuffle around what's static and what's not (ticket #347)
   - Convert to RouterApp interface
   - Convert from basic to digest authentication (ticket #652)
   - Use new password manager (ticket #731)
 * Core: New password manager for storing passwords in router.config
   in consistent ways, including salting and hashing if possible.
   (ticket #731)
 * i2ptunnel:
   - Convert HTTP and CONNECT proxies from basic to digest authentication
   - Bypass nonces if console password enabled
   - Convert to ClientApp interface
   - Synchronization improvements
 * Streaming: Add pcap debug facility, from i2p.i2p.zzz.pcap
 * Transport:
   - Add a simple network monitor
   - Add new reachability state for network disconnected
   - Prevent any tunnel building when disconnected (ticket #519)
   - Don't unleash watchdog when disconnected
   - Split up NTCPConnection's single _bwRequests Set into inbound and outbound,
     make FIFOBandwithLimiter.Request unidirectional (ticket #719)
 * Update: Major redesign of the update facilities:
   - Generic interfaces for updating and checking things
   - Allow checkers and updaters outside router context
   - Hide update buttons after downloading update (ticket #484)
   - Add update-via-i2psnark facility
   - Don't hold references to updaters after completion

* 2012-10-27 0.9.3 released

2012-10-25 zzz
 * BuildHandler: Fix "too slow" rejections due to internal clock skew

2012-10-24 zzz
 * I2PSnark:
   - Fix several partial piece (temp file) leaks
   - Don't lose all DHT peers if we stop quickly
   - Explore a kbucket if it's less than 3/4 full

2012-10-24 str4d
 * i2ptunnel: Truncate long client destinations (ticket #581)

2012-10-21 zzz
 * Watchdog: Don't dump threads too often (ticket #519)

2012-10-20 zzz
 * Transport: Back out CoDel for SSU PeerState and NTCP

2012-10-19 zzz
 * UDP: Fix peer test NPE (ticket # 748)

2012-10-18 kytv
* Portuguese and Spanish updates from Transifex
 * Update geoip.txt based on Maxmind GeoLite Country database from 2012-10-02

2012-10-15 kytv
* Italian and Swedish updates from Transifex

2012-10-14 zzz
 * Console: Use non-nio connector for Java 5 and JamVM/gij
            (tickets #715 and #743)
 * i2psnark: Fix request tracking bug preventing piece requests

2012-10-11 kytv
* Italian translation updates from Transifex
* i2prouter:
  - Support for installing as a daemon with systemd on Arch Linux and Suse
  - Support installing as a daemon on Slackware

2012-10-10 zzz
 * ShellCommand: Fix launching all browsers at startup (ticket #453)
 * stats.jsp: Sort groups by translated name

2012-10-09 zzz
 * Console, i2ptunnel: Warn on low ports
 * EventLog: Add more events
 * NetDB: Increase floodfills again
 * RouterInfo: Exit 1 on error in main()
 * SSU:
   - Add peer test throttling
   - Peer test packet count fixes
   - Adjust peer test timeouts and add backoff
   - Reject relays and peer tests from same /16
   - More peer test cleanup and log tweaks
 * Transports:
   - Enforce minimum peer port
   - Warn on low router ports

2012-10-08 zzz
 * SSU:
   - Fix relay request handling bug from -10
   - Fix peer test reply handling bug from -10
   - Fix NPE from -6

2012-10-07 zzz
 * I2PAppContext: Improved synching in constructor
 * i2ptunnel:
   - Set default read timeout in standard server
   - Reduce header timeout, enforce total header timeout
     in IRC and HTTP servers (ticket #723)
 * Logs:
   - Flush buffers in logs.jsp
   - Add dup message to buffers, was in file only
 * Streaming: Don't ignore option or force connect timeout to 5 minutes
 * UPnP: Workaround NPE (ticket #728)

2012-10-06 zzz
 * configlogging.jsp: Fix IAE
 * error500.jsp: Fix whitespace
 * i2psnark:
   - Add allocating and checking indications (ticket #695)
   - Add bandwidth message at startup
   - More checks at torrent creation
 * SSU:
   - Throttle outbound destroys on shutdown
   - Limit outbound introduction offers
   - Validate port/IP in received peer tests

2012-10-05 zzz
 * configservice.jsp: Add GC button
 * DataHelper: Sanity checks in storeProps(), use
               storeProps() for router config again
 * SSU:
   - More synchronization fixes
   - Reduce chance of dup acks in a single message
   - Reduce max unsent acks to 50
   - Use last ack time in ping decision too
   - Reduce ack delay
 * TunnelPoolManager: Fix early NPE (ticket #724)

2012-10-03 zzz
 * NTCP: Reduce conLock contention
 * SSU:
   - Increase max outbound establishments based on bandwidth
   - Synchronization fix for Java 5
   - Use multiple buffer sizes in OutboundMessageState to
     reduce memory usage
   - Adjust skew calculation, synchronize too
   - Ping loop improvements

2012-10-02 zzz
 * I2CP: Delay after sending disconnect message to
         help it get through
 * i2psnark: Fix delete download message
 * i2ptunnel: Fix log message
 * NTCP: Only set keepalive if firewalled
 * OOMListener: Dump threads on OOM
 * PRNG, LogWriter: Use I2PThread to catch OOM
 * SimpleByteCache: Fix ABQ/LBQ selection
 * SSU:
   - Fix memory leak in _peersByRemoteHost map caused by not
     removing peers that change IP or port
   - Send keepalives if firewalled
   - Handle peers that change ports on an established session
   - Synchronize adds and drops
   - Don't use peers with high RTTs in clock skew calculation
   - Reduce initial RTT/RTO

2012-09-28 zzz
 * i2psnark:
   - Fix bugs in rarest-first tracking
   - Fix requesting of partial piece when there are multiple seeds
   - Synch fix in BitField
 * i2ptunnel: Fix wrong server IP in log message
 * peers.jsp: Remove SSU "Dev" column
 * SessionKeyManager: Store original tagset size for debugging
 * Streaming: Don't send RST on globally-blackisted conns

2012-09-26 zzz
 * Addresses: Reject numeric IPs of the form n, n.n, and n.n.n
 * Console, i2ptunnel: More validation of address and port in forms
 * ConvertToHash:
   - Add support for b64hash.i2p
   - Cleanup and use cache
 * i2psnark: Enable DHT by default
 * RFC822Date: Synchronization fix
 * Streaming:
   - Implement changing connection limits on a running session
   - Implement global blacklist

2012-09-25 zzz
 * Context: Make files final
 * EventLog: Fix IAE on portable
 * Jetty: Add non-NIO selector option (ticket #715)
 * OutboundEstablishState: Cleanup (ticket #671)
 * SimpleByteCache: Concurrent fix
 * UPnP: Cleanup & final
 * URLLauncher: Add xdg-open (ticket #717)

2012-09-21 zzz
 * BuildHandler: Use CoDel for inbound queue
 * ByteCache:
   - Prevent release of wrong size
   - Move all 16/32 byte users to SimpleByteCache
   - Increase SimpleByteCache default size.
 * ClientConnectionRunner:
   - Run HandleJob and MessageReceivedJob inline for speed
   - Remove payload from message map if availability announce fails
   - Cleanups
 * ClientManager:
   - Concurrent client map for faster lookup
   - Add by-hash client map for faster lookup by hash
 * ClientWriterRunner: Limit queue size
 * Clock: Synchronization, log large shifts to event log
 * Console: Mark all restarts on graphs using the event log.
 * FortunaRandomSource:
   - Fix bug that wasted entropy in nextInt()
   - Improved synchronization
 * GarlicMessage:
   - Add notes about GarlicMessageHandler and HandleGarlicMessageJob
     being unused in practice
 * I2CP:
   - Limit router/client queue sizes and queue wait times
   - Buffer output streams
 * i2psnark:
   - Implement blacklist for unreachable DHT peers
   - Reduce threshold for unreachable
   - Use ByteCache for chunks in/out
 * IP Lookup:
   - Add caching in RouterAddress with secondary caching
     in Addresses; use caches to speed up transport bids,
     blocklist checks, geoip lookups, and profile organizer
     checks (ticket #707)
   - Limit IP cache size in TransportImpl
   - Clear caches at shutdown
 * JobQueue: Reduce lock contention
 * LHMCache: New util, replacing several private versions
 * LogWriter:
   -  Duplicate log message removal
   -  Increase buffer time
 * NTCP: Move NTCPConnection outbound queue to CoDelPriority
 * OutNetMessage:
   - Centralize priority definitions
   - Raise netdb store and reply priority
 * Router:
   - Boost priority of shutdown thread
   - Replace ident log with new, general-purpose event log;
     use for stops, starts, and updates, and others.
   - New AQM CoDel queue utilities
   - Startup/shutdown synchronization fixes
 * RouterAddress: Remove unused expiration field to save space
 * SimpleTimer (ticket #653):
   - Move all remaining uses to SimpleTimer2
   - Deprecate
 * SSU:
   - Move MessageReceiver, UDPSender and UDPReceiver queues to CoDel
   - Separate PeerState outbound message list into a queue for unsent messages
     and a list for sent messages awaiting ack
   - Implement PeerState outbound queue as CoDelPriority
   - Implement backlogged indication like in NTCP
   - Increase initial and max RTO
   - Don't count ack-only packets in bandwidth allocation
 * Streaming: Don't send a RST to an hour/day limited peer,
   or blacklisted, or non-whitelisted, to not waste outbound bandwidth
 * SystemVersion: New util, to consolidate duplicate code,
   and determine Java version on Android
 * TunnelGateway:
   - Refactor TunnelGateway.Pending to its own file PendingGatewayMesasge
   - Move OBGW queue to CoDelPriority
   - Move IBGW queue to CoDel
   - Limit queue sizes
   - Add stat for overflow
   - Remove some stats
   - Change pumper to LinkedHashSet for efficiency
     (like NTCP Reader/Writer)
   - Limit messages pumped per cycle to increase
     round-robin fairness
   - Implement pushback from a backlogged transport
     queue to the pre-fragmentation queue
   - Comment out some unused code

* 2012-09-21 0.9.2 released

2012-09-15 zzz
 * Build: Fix unpack problem on Java 5: http://forum.i2p/viewtopic.php?t=7334

2012-09-14 zzz
 * SSU: Fix shutdown NPE (ticket #709)

2012-09-13 kytv
 * Update geoip.txt based on Maxmind GeoLite Country database from 2012-09-05

2012-09-12 kytv
 * Czech translation updates from Transifex

2012-09-10 meeh
 * Added fix for startup issues on newer versions of launchd (osx startup scripts)

2012-09-05 meeh
 * Added startup scripts for osx

2012-09-04 zzz
 * I2PTunnelServer: Clean shutdown after session exception
 * OutNetMessage: Speedup after profiling (ticket #707 - thx dg, kytv, zab)
 * SSU: Fix some issues with queueing outbound establishments

2012-08-31 zzz
 * i2psnark: Remove * from magnet and download names
 * Router: Lengthen shutdown spinner life
 * Startup: Don't complain about clients.config missing on Android

2012-08-29 zzz
 * ClientManager: Cleanups
 * i2psnark:
   - Fix NPE on destroy() if init() failed
   - Add new flood-resistant KBucket trim policy
   - Limit received MsgID size
 * NTCP: Reduce lock contention (ticket #697)
 * RandomIterator: Workaround for Android bug (ticket #703)

2012-08-27 zzz
 * i2psnark:
   - Notify threads awaiting DHT replies at shutdown
   - Fix cases where we weren't using the session for b32 lookup
 * Reseed: Remove forum.i2p2.de
 * Streaming: Limit amount of slow-start exponential growth
 * SSU:
   - Limit UDPSender queue size
   - Increase UDPSender max packet lifetime
   - Clear UDPSender queue before sending destroys to all
   - Increase PeerState queue size so large streaming windows
     don't get dropped right away, especially at slow start
   - Various improvements on iterating over pending outbound
     messages in PeerState
 * Wrapper: Update armv7 to 3.5.15

2012-08-27 kytv
 * Update Java Service Wrapper to v3.5.15.
    - Windows: Self-compiled with VS2010 in Windows 7. The icon has been
      changed from Tanuki's default to Itoopie.
    - FreeBSD: Self-compiled in FreeBSD 7.4 to eliminate the dependency on the
      compat6x port.
    - Linux ARMv5, Linux PPC32: Self-compiled in Debian Squeeze
    - Linux x86, Linux x64, MacOSX & Solaris: Binares are from the "community
      edition" deltapack offered by Tanuki. The x86 and x64 binaries for Linux
      have been stripped.

2012-08-26 zzz
 * DataHelper: Trim trailing whitespace when loading properties
 * NetDB: Increase floodfills, decrease flood redundancy
 * SendMessageOptions: Increase tag fields to 4 bits and use
                       table lookup for more flexibility
 * Streaming: Use packet type and current window size to adjust
              number of tags sent and tag threshold, to improve
              efficiency and reliability

2012-08-25 kytv
 * Dutch and German translation updates from Transifex
 * Router console typo fixes (#701)

2012-08-25 zzz
 * SDSCache: Reduce min and increase max size
 * SimpleByteCache: Change from LBQ to ABQ to reduce object churn
 * Other object churn cleanups (ticket #699)

2012-08-24 zzz
 * I2CP:
   - Add methods for sending a message with extended options
   - Fix cases where the efficient sendNoEffort() wasn't being used
 * i2psnark:
   - Use extended I2CP options for datagrams
   - Fix timeout for sent datagrams
   - Add link for local torrent file on details page
   - Show totals line even if only one torrent
   - Reduce token timeout
   - Check token age before use
   - Limit incoming token size
 * OCMOSJ:
   - Implement per-message overrides for tag threshold,
     tags to send, and bundle leaseset
   - Fix bug adjusting timeouts
   - Warn on client expiration time bugs

2012-08-23 zzz
 * Crypto: Rename bouncycastle HMAC libs so they don't conflict
   with older Android versions which bundle them
 * NTCP: Reduce lock contention (ticket #697)
 * SSU:
   - Don't relay or introduce to/from privileged ports
   - Various spoof detections

2012-08-22 zzz
 * NetDB: Add hash collision detection
 * SimpleTimer2: Synchronization improvements (ticket #653)
 * SSU:
   - Fail establishment immediately on SessionCreated
     validation fail
   - Defer outbound DH generation until required
   - Validate address/port in RelayIntro messages
   - Throttle hole punches
   - Workaround for Android ICS bug
   - More cleanups

2012-08-21 zzz
 * NetDB: Decrease stat publish probability
 * SSU:
   - Use external, not internal port to sign SessionCreated message.
     Together with previous fix to allow external port change, this
     should fix session establish fails when NAT changes our port
   - Track outbound establishments by both Hash and IP/port,
     to improve lookups of establishments in progress
   - Fix expiration of outbound establishments
   - Validate address/port in RelayResponse messages
   - Change RemoteHostID to store Hash instead of byte[] for the peer hash
   - Log tweaks

2012-08-20 zzz
 * I2CP: MessageStatus cleanup
 * i2psnark: Add minimum tracker and DHT announce intervals
 * I2PTunnelRunner: Remove unnecessary lock (ticket #690)
 * SSU: Allow port change if firewalled
 * Streaming: Increase max connection timeout
 * UPnP:
   - Prep for UPnP returning different external port
   - Better logging of errors

2012-08-18 kytv
 * Fix hang during uninstallation experienced by some users in Windows

2012-08-17 zzz
 * i2psnark:
   - Adjust DHT timeouts
   - Add max peers per-torrent in tracker
   - Remove duplicate clean task for nodes
   - Fix another DHT warning message
 * SSU:
   - Use remote MTU when published (ticket #682)
   - Queue outbound msgs during inbound establish
   - IntroManager cleanups
   - More synchronization

2012-08-17 sponge
 * BOB: just some cleanup of old, dead meaningless commentedout code
        and a little reformatting.

2012-08-16 zzz
 * Utils: Drop unused BufferedRandomSource, PooledRandomSource,
   EepGetScheduler, EepPost and HTTPSendData, moved to i2p.scripts

2012-08-15 zzz
 * i2psnark:
   - Fix bug preventing completion announcement, broken in 0.9.1
   - Fix setting short retry time after initial announce failure
   - Fix DHT announce and getPeers
   - Fix DHT warning message
 * UPnP: Update to CyberLink 2.1 (ticket #427, possibly others)

2012-08-13 zzz
 * SSU EstablishmentManager:
   - Remove use of outbound timers in EstablishmentManager; drive all events in Establisher thread
   - Don't change nonces when retransmitting intro packets
   - More synchronization in EstablishmentManager
   - Increase establishment timeouts and implement timeouts for individual phases (ticket #669)
   - Fix bug where InboundEstablishState.createdPacketSent() wasn't being called,
     so SessionCreated packets weren't retransmitted
   - Increase retransmission timeout for SessionCreated and implement backoff
   - Send destroy if establishment times out in the middle
   - Fix code that pulls outbound states off a deferred queue
   - Improve UDPPacket.toString() for debugging
   - More logging of packets dropped in EstablishmentManager
   - Change establish states to enums

2012-08-12 zzz
 * Jetty: Don't use direct byte buffers that may be leaking (ticket #679)
 * PeerManager: Fix NPE on Android (ticket #687)
 * SSU:
   - Reject some packet types if they came in via fallback introKey
   - Increase retransmission timeout for SessionRequest, SessionConfirm,
     and RelayRequest; implement backoff
   - Move UDPFlooder to test
   - More volatiles, finals, cleanups, stat removals, log tweaks

2012-08-11 zzz
 * DataHelper: toString(byte[]) cleanup
 * i2psnark:
   - Fix DHT nodes not being saved at shutdown
 * RouterContext: Make the contexts list concurrent
 * SSLEepGet: Don't throw UOE in TrustManager
 * SSU MTU (ticket #682):
   - Use local MTU detection
   - i2np.udp.mtu now sets max MTU, not initial MTU
   - Put local MTU in netDb
   - Fix receive MTU calculations
   - Track remote MTU based on actual received packet size
   - Display local MTU on peers page

2012-08-10 kytv
* German and Greek translation updates from Transifex

2012-08-09 zzz
 * Datagrams: Remove static logs
 * i2psnark:
   - Remove static SnarkManager instance
   - Allow DHT-only torrents
   - DHT debugging
 * NTCP: Stat cleanup
 * SAM:
   - Don't use direct byte buffers that may be leaking (ticket #679)
   - Volatiles and finals
 * SSU:
   - Don't send a packet that exceeds the MTU
   - Stub out local MTU detection (ticket #682)
   - More cleanups

2012-08-07 str4d
 * Console:
   - Theme updates from dr|z3d
   - Changed universal theming key so it is not mistaken as a theme
     name by the routerconsole
 * i2psnark:
   - Theme updates from dr|z3d
   - If universal theming is set and routerconsole theme is classic,
     use light theme explicitly
 * susidns: new midnight theme from dr|z3d

2012-08-06 zzz
 * Clone System properties before iterating to avoid
   ConcurrentModificationException (ticket #680)
 * Console: Fix flag links on /console to return to same page
 * i2psnark: Add support for DHT (disabled by default)
 * jbigi: Add ARMv6 libjbigi.so for Raspberry Pi

2012-08-05 zzz
 * I2PSessionImpl: One more volatile (ticket #659)
 * i2ptunnel, I2CP, EepGet: Buffer socket input streams (ticket #666)
 * UDP:
   - Limit PacketHandler threads to 1 (ticket #660)
   - Limit queue sizes between UDPReceiver and PacketHandler,
     and between PacketHandler and MessageReceiver, to prevent OOMs
     and/or excessive queue delays
   - Increase UDPPacket cache size based on max mem
   - Remove more stats

2012-08-03 zzz
 * build.xml: Add buildI2PTunnelJar target for Android
 * i2psnark: Finish migration to I2P logging to reduce object churn (ticket #673)
 * LogManager: Add logger.logBufferSize and logger.dropOnOverflow options (ticket #662)
 * JobQueue: Synch fix (ticket #670)
 * OutNetMessage: Fix NPE when log level = INFO (ticket #676)
 * SimpleScheduler, SimpleTimer2: Replace getInstance() calls
 * UDP:
   - Catch some cases where UDPPackets were not returned to the cache (ticket #675)
   - Fix inverted logging logic (ticket #663)
   - Remove check in UDPPacket.getLifetime() (ticket #664)
   - RemoteHostID cleanup, cache hashcode
   - Remove udp.fetchRemoteSlow stat
   - Remove some time stamping in UDPPacket
   - Other cleanups - see http://zzz.i2p/topics/1198

2012-08-03 str4d
 * Console: universal theming support - packaged apps will try and use the routerconsole
   theme if universal theming is enabled there and the same theme exists for the app.

2012-07-31 str4d
 * core, router:
   - Existing JUnit test framework fixed up and running.
   - Code coverage tools (Clover and Cobertura) integrated into unit test targets.
   - Implemented new test-related targets to provide a ScalaTest test framework.

2012-07-30 zzz
 * build.xml: Move more default properties to build.properties
 * DecayingBloomFilter, DecayingHashSet, xlattice filters:
   - Move from core to router
   - Comment out tests
 * ElGamal/AES/SessionTag:
   - Increase TX expire from 10 to 12 min, while keeping RX expire at 15 min.
     3 minutes should be plenty of clock skew + delay.
   - Move tags-to-send and low-threshold values to be per-SKM
   - New session config options crypto.tagsToSend and crypto.lowTagThreshold
   - Prep for per-packet override of tags and thresholds
   - Cleanups and Javadocs
 * GarlicMessageBuilder:
   - Put data clove last to speed acks and leaseset store on far end
 * I2PTunnel: Add some defaults for the new session config options
 * OCMOSJ:
   - Don't bundle LeaseSet just because we're requesting an ACK
   - Changed session config option shouldBundleReplyInfo to default to true
     and be used to disable bundling altogether when set to false.
     Was previously an undocumented option to force bundling with a certain probability.
   - Don't send tags unless we've already generated a reply token (race)
   - Cleanups and Javadocs
 * RoutingKeyGenerator: Cleanups (ticket #672)

* 2012-07-30 0.9.1 released

2012-07-28 str4d
 * Console: theme fixes

2012-07-26 kytv
* Update geoip.txt based on Maxmind GeoLite Country database from 2012-07-04
* Finnish, French, German, Spanish and Swedish translation updates from TX

2012-07-26 sponge
* BOB Fix static references to Log

2012-07-24 sponge
 * BOB reset spin flag to enable restart from zap command

2012-07-24 str4d
 * Summary bar: disable fallback iframe in summary.jsi (so when JS is disabled
   the summary bar will not refresh at all)
 * Home page:
   - Replaced 16x16 icons with 32x32 ones
   - Updated icon for git.repo.i2p
   - Moved RestartStatus back above LocalDestinations

2012-07-24 zzz
 * LookaheadInputStream: Fix bug causing gunzip fails, esp. on Android
 * Router: Don't create router.ping file on Android
 * SSLEepGet: Fix on Android (ticket #668)

2012-07-21 zzz
 * i2psnark: Remove dark theme
 * Reseed: Add new cert for cowpuncher
 * SSU: Remove exception creation (ticket #665)

2012-07-21 str4d
 * Home page: unlinked the iframed pages for i2psnark and susimail (the pages
   /webmail and /torrents still exist, but the console links to the apps
   directly instead for now)

2012-07-19 str4d
 * Home page: replaced itoopie with an eepsite icon (c/o dr|z3d) for eepsites
   with no icon of their own.
 * i2psnark:
   - New light theme (c/o dr|z3d) which integrates with console light theme
   - Moved table heading text into tooltips to reduce visual clutter

2012-07-18 str4d
 * Home page: Added id3nt.i2p and git.repo.i2p

2012-07-18 zzz
 * Home page: Add colombo-bt.i2p, remove keys.i2p
 * i2psnark: Clear rate stats when restarting torrent

2012-07-16 str4d
 * console: work towards better integration
   - Wrapped the bundled apps in iFrames (with a link in the page header to
     open the app in a new tab):
     - i2ptunnel
     - i2psnark
     - susimail
     - susidns
   - Theme improvements
     - Added theme support to susimail and susidns
       - "susimail.theme=foo" in susimail.config
       - "theme=foo" on susidns config page
     - Extensive work on dark console theme (dr|z3d)
       - Improved integration of i2ptunnel in iframe
       - General improvements
     - New dark themes for i2psnark, susimail and susidns which integrate well
       with dark console theme (dr|z3d)
     - Tweaks to other themes (console and i2psnark) to work with the various
       structural changes (dr|z3d)
     - Added per-theme favicons
     - Updated IE shim to fix some issues
   - Summary bar improvements
     - Updated every console page to use Ajax for the summary bar
       - Falls back to iFrame if JS disabled
       - Ajax refresh time is adjustable
     - The summary bar is now customizable; sections can be added, removed and
       reordered as desired
     - Added/updated tooltips
     - Added a new summary bar section to show news headings when the main news
       display is hidden
   - Changes to structure of /home to bring it in line with rest of console
 * i2psnark
   - Reworked the torrent info/file manager page to improve the layout

2012-07-15 zzz
 * XORComparator: Reduce object churn (Ticket #658)

2012-07-12 kytv
* Translations from Transifex:
  - Add new Greek translation
  - Dutch translation update

2012-07-01 zzz
 * i2psnark:
   - Don't send a keepalive to a peer we are going to disconnect
   - Disconnect peer when idle a long time
   - PeerCheckerTask cleanup
   - Static ref cleanup
   - Don't show a downloaded torrent file as "seeding"
   - Better torrent file download icon

2012-06-29 zzz
 * HTTP Proxy: Change the error code for unknown host from 404 to 500
 * SimpleTimer: Fix logging
 * Streaming:
   - Allow at least 3 packets and up to half the window to be active resends
     instead of just 1, to reduce stall time after a packet drop
   - Increase fast retransmit threshold back to 3 to reduce retransmissions
   - Don't fast retransmit if we recently retransmitted it already
   - Allow double the window as long as gaps are less than the window
   - Don't set the MSS in a resent packet (saves 2 bytes)
   - Remove redundant calls to updateAcks()
   - Update activity timer when resending a packet
   - Reset unackedPacketsReceived counter at all places where acks are sent
     so it isn't wrong
   - Fix some places where the activeResends count could become wrong
   - Prevent storm of CLOSE packets
   - Never resend the whole packet in ackImmediately(), just send an ack
   - Cancel flusher timer in MessageOutputStream when closed
   - Move some createRateStats to ConnectionManager to reduce repeated calls
   - Cleanups, javadocs, logging, volatile, finals
 * Update: Increase eepget timeouts

2012-06-24 zzz
 * ElGamalAESEngine: Fix bad size estimate when tags are included,
                     resulting in trailing zeros after the padding
                     in the unencrypted data
 * i2psnark: Don't create a new PeerCoordinator after restart, as the
             TrackerClient holds on to the old one and that causes it
             to not get peers. Possibly fixes ticket #563.
 * I2PTunnel: Fix NPE on shared client creation, thx kytv
 * Transport: Add Ethiopia to hidden mode list

2012-06-21 zzz
 * I2CP: Make separate message ID counters per-destination, use atomic,
         increase max (could have caused "local loopback" problems)
 * IRC Client: Don't flush output unless out of input, so the
               streaming messages don't get split up unnecessarily
 * OCMOSJ, ElG, Streaming: log tweaks
 * TunnelInfo: Change msg counter from long to int
 * TunnelPeerSelectors: Minor refactoring to store context
 * TunnelPool: Fix bug where a tunnel was marked as reused when it wasn't
 * TunnelPoolManager: Use one ClientPeerSelector for all pools

2012-06-20 zzz
 * I2PSession:
   - Greatly simplify the VerifyUsage timers
   - Constructor cleanup

2012-06-19 zzz
 * i2psnark:
   - Hide buttons while stopping all
 * Socks: Pass remote port through
 * Streaming:
   - Listen only on local port if set
   - Listen only for streaming protocol if configured (new option)
   - Javadocs re: ports

2012-06-18 zzz
 * i2psnark:
   - Improve torrent shutdown handling to maximize chance of
     announces getting to tracker
   - Thread task to open tunnel and improve UI feedback while open is pending
   - Clean up delete-torrent messages
   - Remove redundant shutdown hook
   - Avoid NPE in PEX message handling
   - Log tweaks

2012-06-15 zzz
 * I2PSocketEepGet: Use specified port
 * I2PTunnel:
   - Don't strip port from an I2P URL
   - More client options cleanups
   - Options changes now propagate to running
     socket managers and sessions, and through to the router
   - Better parsing of jump server URLs
 * NetDB: Only publish stats every so often, to improve
   anonymity while preserving the ability to monitor
   the network (effective next release)
 * SocketManager:
   - Simplify factory, use 4-arg constructor,
     make fields final, deprecate 0-arg constructor
   - Improve how options are updated
   - Javadocs

2012-06-13 zzz
 * I2PSocketEepGet: Set port to 80
 * I2PTunnel:
   - Pass port through HTTP client proxy
   - HTTP server proxy sets host header to
     the value of "spoofedhost.xx" option for port xx
   - Set client options more efficiently
 * i2psnark: Possible fix for piece-after-choke
 * Streaming:
   - Channel cleanups and comments
   - New I2PSocketAddress

2012-06-11 zzz
 * i2psnark:
   - Display torrent file downloads in torrent area
   - Sort magnets and downloads first
   - Fix sorting problem when torrent dir is a symlink
   - Reduce max file idle time
   - Reduce TrackerClient threads
   - Reduce delay between peer adds for faster startup
   - Thread the announces and reduce timeout when stopping
 * NativeBigInteger: Workaround for Raspberry Pi to load the correct lib
 * Router: Don't let shutdown tasks hang the shutdown (tickets #564, #566)

2012-06-08 zzz
 * i2psnark:
   - Move private tracker config from create box to torrent config
   - Refactor private and open tracker configuration
   - Add private indication on details page
 * netdb.jsp: Don't show our info on summary page

2012-06-04 zzz
 * i2psnark: Take tracker out of opentracker list when removed

2012-06-03 kytv
* Translation updates:
  - Add Hungarian language from Transifex (thanks AdminLMH!)
  - Italian language updates from Transifex (thanks ColumboBT)

2012-06-02 zzz
 * i2psnark: Improve opentracker configuration
 * Job Queue: Add failsafe check

2012-06-01 zzz
 * Console: Tab the netdb and profile pages
 * i2psnark: Fix partially-complete torrent not announcing
 * NetDB: Reduce flood redundancy from 8x to 6x

2012-05-31 zzz
 * i2psnark:
   - Add per-hour conn limit
   - Blacklist peer after two bad handshakes
   - Reduce connect timeout
   - Close connection immediately if bad protocol
   - Stop adding peers when we hit the limit
   - Lower limit for outbound connections so we give
     new peers a better chance in large swarms

2012-05-30 zzz
 * Graphs: Reduce log EOF error to warn
 * i2psnark:
   - Increase max upload (ticket #645)
   - Increase per-minute conn limit from 6 to 8
   - Improve rarest-first behavior
   - Handle URI encoding, UTF-8, and multiple trackers in magnet links
 * Timestamper:
   - Move from core to router, leave stub in core
     so it doesn't break compatibility. This removes a
     thread in app context and prevents any app context from
     running NTP; external clients must use the time
     received from the router.
   - Increase query interval

2012-05-28 kytv
 * i2prouter: Add support so that 'i2prouter install' will work in ArchLinux
 * jbigi/jcpuid scripts: Improve support for ArchLinux

2012-05-25 kytv
 * German, Italian, Spanish, and Swedish translation updates from Transifex

2012-05-23 zzz
 * i2psnark:
   - Fixes when complete except for skipped files
     (ticket #447) status in UI, don't connect outbound,
     disconnect seeds when done
   - Custom tracker map AIOOBE fix
   - More classes pkg private
 * jobs.jsp: Add more queue diagnostics

2012-05-22 zzz
 * i2psnark:
   - Refactor tracker map
   - Prevent torrent shutdown when changing file priority to skip
   - Fix deadlock when changing file priorities
 * RoutingKeyModifier: Update after large clock shift

2012-05-20 zzz
 * Console: Add full file path to thread dump message
 * i2psnark:
   - Create sparse files at torrent creation and delay
     "ballooning" until first write (ticket #641, #447)
   - Redo clear messages button
   - Concurrent message queue
 * Profiles: reduce same-country bonus
 * RoutingKeyModifier: Several changes to ensure the routing key
                       is correctly changed just after midnight.

2012-05-19 zzz
 * i2psnark:
   - Store received chunks in temp files
   - Don't allocate from heap for unneeded chunks
   - Remove peer count restriction for torrents with large pieces
   - Use priorities and rarest calculations to sort partials
   - Preserve p parameter in clear messages link

2012-05-13 zzz
 * Console: Add X-Frame-Options to headers,
   disable with routerconsole.disableXFrame=true

* 2012-05-02 0.9 released

2012-04-26 kytv
 * German, Spanish, and Swedish Translation updates
   from Transifex

2012-04-20 zzz
 * Remove search box
 * Fix i2psnark dir when started from Windows no-wrapper
   (ticket #627)

2012-04-14 kytv
 * Update wrapper to v3.5.14
 * Update geoip.txt from Maxmind's April 2012 database

2012-04-12 kytv
 * German, Spanish, and Swedish translation updates from Transifex

2012-04-12 zzz
  * Console:
    - Try again to fix console on Windows w/o IPv6
      by starting connectors individually
    - Fix whitespace issues on several pages
    - Prevent rare early NPE
    - Non-default theme cleanups
    - Theme and translate home page logo

2012-03-28 zzz
  * RouterInfo: Fix fatal NPE in last checkin

2012-03-27 zzz
  * FloodfillVerify:
    - Fix verifies stuck on one peer by blamimg the verify peer on failure
    - Follow DSRM in response to RI verifies
    - Increase floodfill verify timeout
  * Home page: Delay router down message until two consecutive fails
  * RouterInfo: Add method to validate sig during read-in for speed

2012-03-27 sponge
  * A hopeful fix to allow SHOUTcast/icecast to work over the http proxy.
  * A little more code clean up

2012-03-26 zzz
  * Code cleanups:
    - Remove unused imports
    - Remove unused local variables
    - Remove unused private fields
    - Remove unnecessary casts
  * Console:
    - Try again to fix console on Windows w/o IPv6 (ticket #621)
    - Move oldconsole rendering from Router to OldConsoleHelper

2012-03-24 zzz
  * GarlicConfig: Remove more unused methods
  * i2psnark:
    - Fix dup torrent msg with magnets (tickets #433 and #504)
    - Fix state when storage dies during transition out of magnet mode
    - Fix NPE in magnet mode
    - Error logging improvements
    - Support add-torrent with infohash alone
    - CSS tweaks

2012-03-22 zzz
  * Home page: CSS tweaks
  * Reseeder: Get rid of static instance, root in netDB,
              don't use system properties for status
  * RetransmissionTimer: Instantiate per-destination
  * Router: When removing a config setting, remove from context also
  * SimpleScheduler, SimpleTimer, SimpleTimer2: Replace static instances
    with I2PAppContext-rooted references

2012-03-20 zzz
  * i2psnark: Message area tweaks and clear link
  * NetDB:
    - Don't reread RI if netdb date is recent
    - Prevent LS/RI overwrites
    - Disallow hash mismatches in RI files
    - Reseed won't fetch our own RI
    - Reseed won't overwrite recent RIs
  * Router: Make runRouter() public

2012-03-19 sponge
  * Plugins: Less confusing message, fix CNFE by catch and ignore on delete.
             Order and reverse order plugin names for start/stop all cases.

2012-03-18 zzz
  * Jetty: Fix check alias override

2012-03-17 zzz
  * BuildHandler: Implement restart and shutdown to stop the thread
  * Jetty: Don't extract wars
  * FileUtil: Better logging of weird unpack200 errors
  * I2PTunnel: Make CLI-only methods private, and static where possible
  * Streaming: Scheduler cleanup

2012-03-16 zzz
  * FragmentHandler: Zero-copy read of unfragmented messages
                     for speed and to reduce object churn
  * Home page: Tag tooltip; CSS tweaks; news tweak
  * HTTP Proxy: Jump and addresshelper page tweaks
  * Jetty: Add I2P mime types to default eepsite config
  * OCMOSJ: Refactor cache to its own class, make non-static
  * TransportManager: Fix fatal exception on soft restart caused by DHSKB refactoring
  * TrustedUpdate: Preserve default key names even when keys are set
                   in advanced config

2012-03-15 sponge
  * Plugins:
    - String.isEmpty() [ java 6 ] -> (String.length() == 0) [ java 5 ]
    - for a file: URL, use "Attempting to copy plugin from" message
    - s/{0}// on non-translated string
    - grammar: "File copy failed {0}" -> "Failed to copy file from {0}"
    - use the context provided to get startup time
    - getCanonicalPath() -> getAbsolutePath()
    - install != update. Don't change the user's settings, and don't restart
      it on an update if "dont-start-at-install". This gives the same
      functionality as before.

2012-03-14 zzz
  * Blockfile, i2psnark: Remove static logs
  * DHSessionKeyBuilder:
    - Move from core to router/transport
    - Make non-static, instantiate in TransportManager
    - Generate keypair in constructor and make final
      to move more processing to the precalc thread
      and eliminate races
    - Synchronize getSessionKey() to eliminate races
    - Comment out unused methods
  * Jetty:
    - Set default cache-control for webapps and eepsite
    - Disable dir listing for console webapps
  * UDPTransport:
    - Make key builder final in InboundEstablishState to
      eliminate rare NPE (ticket #406)
    - Remove unused static instance
  * YKGenerator: Make non-static, instantiate in ElGamalEngine

2012-03-13 sponge
  * Add sponge.i2p :-D bump version.

2012-03-13 sponge
  * Plugins:
    - Fix a bug in the updater. It was not comparing the correct name.
    - Plugin updates can now be deferred if router-restart-required is set.
      The update happens at the next router restart.

2012-03-13 sponge
  * Plugins:
     - Handle 'file://' URLs for installation and updates (ticket #429).
       You must specify the entire path, e.g.
       file:///home/someone/magicplugin.xpi2p
       - This works for updates too!
       - Only tested on Linux, needs to be tested on Windows.

2012-03-12 zzz
  * Console:
    - Better IPv6 test, hopefully will work on Windows
    - Hide home page flags once language is selected
    - Home page shrinkage and other CSS tweaks

2012-03-11 sponge
  * Slackware package script updates

2012-03-11 zzz
  * Build:
    - Include old commons logging classes in commons-logging.jar
    - Preserve manifests in Jetty/Tomcat jars
  * Jetty Logger: Promote warns to errors when a Throwable is the second arg

2012-03-11 sponge
  * fix broken comment in jetty.xml

2012-03-10 zzz
  * Build: Add new jetty jars to router.jar classpath so it works
    on very old installs with individual jars specified in the
    wrapper.config classpath
  * configloggging: Fix clearing log overrides
  * Console: Test if IPv6 addresses will work before instantiating
             connectors, so Jetty will still start without them
  * HTTP Proxy: Fix generation of jump links (ticket #616),
                broken by refactoring in -1
  * Jetty Logger: Put a note in wrapper log saying where the logs went

2012-03-09 zzz
  * Update default eepsite base context to use DefaultServlet
    instead of ResourceHandler, to provide resume, directory
    indexes, caching, etc.
  * Simplify default eepsite base and CGI contexts to use a Context
    instead of a ContextHolder, ServletHandler, and ServletHolder

2012-03-08 zzz
  * GarlicConfig: Remove unused reply block methods
  * SessionKeyManager:
    - Don't use unacked tagsets after consecutive ack failures
      and revert to full ElGamal if necessary (ticket #574)
    - Synchronize creation of new sessions to prevent dups
    - Don't remove an unacked session until it's really out of tags
    - Failsafe removal of old unacked tagsets
    - Cleanups, final, comments, log tweaks, debug.jsp tweaks, synchronization tweaks

2012-03-06 kytv
 * German and Spanish translation updates from Transifex

2012-03-06 zzz
  * i2psnark: Fix NPE on magnet link addition
  * Jetty logger: Fix stack trace logging
  * viewstat.jsp: Properly close the ImageOutputStream to fix
    NPEs in the finalizer, probably was the root cause of
    what we blamed on Jetty
  * Webapp class loader: Fix dup classes in classpath
    caused by last checkin (symptom: i2psnark in wrong directory)

2012-03-05 zzz
  * Build: Make windows and non-windows installers for release
  * configclients: Tweaks
  * Graphs: Add time interval to legend
  * NetDB: Increase min ff to 250
  * Plugins: Fix setting webapp classpath on Jetty 6
  * UDP: Log tweaks
  * viewstat.jsp: Set Connection: Close to work around Jetty bug
    http://jira.codehaus.org/browse/JETTY-1346

2012-03-04 zzz
  * Jetty: Upgrade to Jetty 6.1.26, Tomcat 6.0.35, and JSTL 1.2.
    - Supports Servlet 2.5 / JSP 2.1 standards
    - Jetty and Tomcat jars are checked in, no more need to
      download Jetty in the build process.
    - Bundle Jetty 6 rewrite handler and JMX
    - Bundle sample Jetty config files for rewrite, JMX, and SSL
    - Use ant's ant.jar instead of the one from Jetty
    - Port router console, i2psnark, and I2PRequestLog code to Jetty 6
    - Remove all old Jetty 5 patches and the custom Server() constructor,
      this will break Seedless use of the custom constructor
    - Fix up all .jsps to JSP 2.1 standards
    - Include automatic migration of clients.config,
      and of jetty.xml files for an eepsite at port 7658.
      New config includes files in eepsite/contexts and eepsite/etc
      Any other Jetty-hosted eepsites,
      or an eepsite not at port 7658 or with custom
      modifications of the jetty.xml file, will require
      manual editing of the new Jetty config files.
      This includes modifications for the seedless server in jetty.xml.
    - The following plugins are not compatible with Jetty 6
      and will be disabled until updates are available:
         i2pcontrol, pebble, and zzzot
    - Users updating must use the updaterWithJetty build target once,
      to get the new Jetty and Tomcat.
    - Put I2PRequestLog in its own jetty-i2p.jar
    - Jetty logging moved from wrapper to I2P log using the new I2PLogger class,
      also in jetty-i2p.jar
  * Console: Start all wars after the main console war,
    for faster startup and to prevent one failed war from preventing
    startup of the entire console
  * i2psnark: Disable i2psnark RunStandalone, unused and instantiated Jetty 5
  * i2ptunnel: Move i2ptunnel Bean classes from the jar to the war.
    These were deprecated for external use long ago.
    This will break very old seedless plugins; updates have
    been available for months.
  * susimail: Copy MultiPartRequest and other required classes from Jetty 5.1.15
    and add it to susimail, as the replacement MultiPartFilter in
    Jetty 6 is difficult to migrate to, and does not support content-type

2012-03-03 zzz
  * Console:
    - New simplified home page, refreshing with AJAX
    - New home configuration page
  * i2psnark:
    - CSS tweaks
    - Ajax and link fixes
    - Move js to console in prep for merging w/ homepage
  * NetDB: Remove bw stats (effective next release)

2012-03-02 zzz
  * BlockfileNamingService: Add negative cache
  * Build: Add built-by to jars; check for corrupt jars on debug page
  * configstats.jsp: Hide log settings unless already enabled
  * DataStructures:
    - Remove static logs
    - Sort addresses in RouterInfo at initialization only;
      change from Set to List to save space
    - Remove unused counters in Lease to save space
    - Increase max leases to 16
  * Graphs:
    - New single graph page with easy resizing
    - Support graphing of previous intervals
  * i2pinstall.exe: Add icon
  * i2psnark:
    - Add tracker configuration form
